<?xml version="1.0" encoding="UTF-8"?>
<!-- $Id: xoev-profil.ndr.sch 7434 2017-08-24 11:06:25Z fbuettner $ -->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:xmi="http://www.omg.org/spec/XMI/20131001" queryBinding="xslt2">

    <sch:title>XÖV-Prüfanweisungen</sch:title>
    <xsl:include href="xgenerator-library.xgen-core.xsl"/>
    <xsl:include href="xgenerator-library.uml-access-layer.xsl"/>
    <xsl:include href="xoev-profil.profile-access-layer.xsl"/>
    <xsl:include href="xoev-profil.helpers.xsl"/>

    <sch:ns uri="http://www.xoev.de/de/xgenerator/framework/1/library" prefix="xgen"/>
    <sch:ns uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
    <sch:ns uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
    <sch:ns uri="http://www.xoev.de/de/xoev-profil/1_5_1" prefix="xoev"/>

    <!-- Quelle XGen2-Datei: NDR-MUSS.invariants, NDR-SOLL.invariants, NDR-EMPFEHLUNG.invariants -->

    <!-- Hinweis: Invariante W3CDatatypesPackageExists nicht umgesetzt, da es sich hierbei um eine Altlast aus den Zeiten handelt, in denen die W3C-Datentypen
        noch gesondert ins Modell eingebunden werden mussten. -->

    <!-- Umsetzungsstand:  -->


    <sch:pattern>
        <sch:rule context="/">
            <sch:assert id="id1" role="error" test=".//@xmi:id">Das Dokument entspricht keiner vom XGenerator verarbeitbaren XMI-Version.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <sch:pattern>
        <sch:rule context="/">
            <sch:assert id="id2" role="error" test=".//uml:Model">Das Dokument enthält kein Modell in einer vom XGenerator verarbeitbaren UML-Version.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- TODO (FB und MK): Wieder aktivieren. -->
    <!--<sch:pattern>
        <sch:rule context="/">
            <sch:assert id="id3" role="error" test="$xoev:profile-application/@version = $xoev:version">Falsche Version des XÖV-Profils (erwartet: <sch:value-of select="$xoev:version"/>, erhalten: <sch:value-of select="$xoev:profile-application/@version"/>).</sch:assert>
        </sch:rule>
    </sch:pattern>-->

    <!-- TODO (MK mit FB): Klären wie NDRs mit mehreren Invarianten umgegesetzt werden soll. Derzeit hat jede Invariante ein eigenes Pattern. -->

    <!-- ToDo (MK mit FB): Klären ob diese Regel ausgewertet werden kann. Denn wenn sie fehlschlägt, gibt es bereits ein Problem mit dem Templates (my-model darf nur maximal einmal vorkommen). -->

    <!-- Quelle XGen2: ExactlyOneTopLevelXModel -->
    <sch:pattern id="NDR-2-HauptstrukturEinesXOEVFachmodells-GenauEinXOEVFachmodellAufObersterModellebene">
        <sch:title>NDR-2: Hauptstruktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Das XÖV-Fachmodell eines XÖV-Standards muss auf oberster Ebene einer vordefinierten Struktur folgen, welche die Inhalte des eigenen Standards von externen, in den XÖV-Standard eingebundenen Inhalten unterscheidet.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model[count(packagedElement[xoev:xsdXModel(.)]) != 1]">
            <sch:assert role="error" id="GenauEinXOEVFachmodellAufObersterModellebene" test="false()">Auf der obersten Modellebene darf nur das Modell des eigenen Standards (UML-Modell mit dem Stereotyp xsdXModel) vorliegen. Alle weiteren XÖV-Fachmodelle müssen als externe Modelle im Paket "Externe Modelle" vorliegen. Aktuell existieren <sch:value-of select="count(packagedElement[xoev:xsdXModel(.)])"/> Modelle auf der obersten Modellebene: <sch:value-of select="packagedElement[xoev:xsdXModel(.)]/@name"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ExternalXModelsInDedicatedPackage -->
    <sch:pattern id="NDR-2-HauptstrukturEinesXOEVFachmodells-ExterneModelleImPaketExterneModelle">
        <sch:title>NDR-2: Hauptstruktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Das XÖV-Fachmodell eines XÖV-Standards muss auf oberster Ebene einer vordefinierten Struktur folgen, welche die Inhalte des eigenen Standards von externen, in den XÖV-Standard eingebundenen Inhalten unterscheidet.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model">
            <sch:let name="models" value="//packagedElement[xoev:xsdXModel(.)]"/>
            <sch:assert role="error" id="ExterneModelleImPaketExterneModelle" test="
                    count($models) - count($models[parent::packagedElement/@name = 'Externe Modelle']) = 1">Externe Modelle (UML-Modelle mit dem Stereotyp xsdXModel, deren Inhalte nicht zum eigenen Standard gehören) müssen im Paket "Externe Modelle" abgelegt werden. Folgende Modelle liegen derzeit außerhalb des Pakets "Externe Modelle" vor: <sch:value-of select="//packagedElement[xoev:xsdXModel(.) and not(parent::packagedElement/@name = 'Externe Modelle')]/@name"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MessagesMustBeGlobalElements -->
    <sch:pattern id="NDR-3-NachrichtenSindGlobaleElemente">
        <sch:title>NDR-3: Nachrichten als globale Elemente</sch:title>
        <sch:p>Nachrichten eines XÖV-Standards müssen globale XML-Elemente sein.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and not(xoev:xsdGlobalElement(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and not(xoev:xsdGlobalElement(.))]">
            <sch:assert role="error" id="NachrichtenSindGlobaleElemente" test="false()">Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) eines XÖV-Standards müssen globale XML-Elemente (Stereotyp xsdGlobalElement) sein. Die Nachricht <sch:value-of select="xgen:model-path(.)"/> verletzt diese Regel.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TransNamespaceRestrictionImpliesUnqualifiedElements -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-UnqualifizierteElementeBeiRestriktionUeberMehrereNamensraeume">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[
                xoev:xsdRestriction(.) and
                not(xoev:getNamespace(parent::*) = xoev:getNamespace(uml:resolve-general(.)))]">
            <sch:let name="elem" value="."/>
            <sch:assert role="error" id="UnqualifizierteElementeBeiRestriktionUeberMehrereNamensraeume" test="
                    not(
                    ((some $e in parent::*/xoev:elements(.)
                        satisfies
                        xoev:xsdElement($e)/@form = 'qualified' or (xoev:xsdElement($e)/@form = 'default' and
                        (ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'qualified' or
                        (ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'default' and
                        ancestor::packagedElement/xoev:xsdXModel(.)/@elementFormDefault = 'qualified')))) or
                    (some $e in uml:resolve-general(.)/xoev:allElements(.)
                        satisfies
                        xoev:xsdElement($e)/@form = 'qualified' or (xoev:xsdElement($e)/@form = 'default' and
                        (uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'qualified' or
                        (uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'default' and
                        uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdXModel(.)/@elementFormDefault = 'qualified'))))))">Eine XML-Restriktion (UML-Generalisierung mit dem Stereotyp xsdRestriction) zwischen zwei in unterschiedlichen Namensräumen liegenden Bausteinen erfordert, dass alle XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) der beiden Bausteine unqualifiziert sind (XML-Element-Form ist "unqualified"). Im Falle der Restriktion zwischen den beiden Bausteinen <sch:value-of select="xgen:model-path(parent::*)"/> (eingeschränkter Baustein) und <sch:value-of select="xgen:model-path(uml:resolve-general(.))"/> (Basis-Baustein) wird diese Vorgabe nicht eingehalten.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: UnionsMustBeSimpleType -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-UnionIstSimpleType">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdUnion(.) and (xoev:allElements(.) or xoev:allAttributes(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdUnion(.) and (xoev:allElements(.) or xoev:allAttributes(.))]">
            <sch:assert role="error" id="UnionIstSimpleType" test="false()">Ein Datentyp, der eine XML-Union darstellt (Stereotyp xsdUnion), muss ein einfacher Typ sein. Der Union-Typ <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: UnionMembersMustBeSimpleType -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-UnionMemberIstSimpleType">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdUnionMember(.) and
                (uml:resolve-supplier(.)[
                not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:allElements(.) or xoev:allAttributes(.)])]">
            <sch:assert role="error" id="UnionMemberIstSimpleType" test="false()">Ein Datentyp, der als Member einer XML-Union genutzt wird (Stereotyp xsdUnionMember), muss ein einfacher Datentyp sein. Der Typ <sch:value-of select="xgen:model-path(uml:resolve-supplier(.))"/> verletzt diese Vorgabe. Er wird als Member der Union <sch:value-of select="xgen:model-path(uml:resolve-client(.))"/> genutzt.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: UnionMembersMustBeReachableByName -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-UnionMemberIstBenannt">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdUnionMember(.) and
                uml:resolve-supplier(.)[not(parent::packagedElement/@name = 'W3C Data Types' or xoev:xsdNamedType(.))]]">
            <sch:assert role="error" id="UnionMemberIstBenannt" test="false()">Ein Datentyp, der als Member einer XML-Union genutzt wird (Stereotyp xsdUnionMember), muss ein benannter Datentyp sein. Der Typ <sch:value-of select="xgen:model-path(uml:resolve-supplier(.))"/> verletzt diese Vorgabe. Er wird als Member der Union <sch:value-of select="xgen:model-path(uml:resolve-client(.))"/> genutzt.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: KeysKeyrefsUniquesImportsAndIncludesAreExclusive -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-KeysKeyrefsUniquesImportsUndIncludesSchliessenSichGegenseitigAus">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Dependency(.) and
                count((xoev:xsdImport(.), xoev:xsdInclude(.), xoev:xsdKey(.), xoev:xsdKeyref(.), xoev:xsdUnique(.))) ge 2]">
            <sch:assert role="error" id="KeysKeyrefsUniquesImportsUndIncludesSchliessenSichGegenseitigAus" test="false()">Die Stereotypen xsdKey, xsdKeyref, xsdUnique, xsdInclude und xsdImport schließen sich gegenseitig aus. Die UML-Abhängigkeitsbeziehung zwischen dem Baustein <sch:value-of select="xgen:model-path(uml:resolve-client(.))"/> (abhängiger Baustein) und dem Baustein <sch:value-of select="xgen:model-path(uml:resolve-supplier(.))"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NamedTypesAndGlobalElementsAreExclusive -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-BenannteTypenSindKeineGlobalenElemente">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and xoev:xsdGlobalElement(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and xoev:xsdGlobalElement(.)]">
            <sch:assert role="error" id="BenannteTypenSindKeineGlobalenElemente" test="false()">Die Stereotypen xsdNamedType und xsdGlobalElement schließen sich gegenseitig aus. Der Baustein <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: LocalStructuresElementsAndAttributesAreExclusive -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AttributeElementeUndLokaleStrukturenSchliessenSichGegenseitigAus">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[count((xoev:xsdLocalStructure(.), xoev:xsdElement(.), xoev:xsdAttribute(.))) ge 2]">
            <sch:assert role="error" id="AttributeElementeUndLokaleStrukturenSchliessenSichGegenseitigAus" test="false()">Die Stereotypen xsdLocalStructure, xsdAttribute und xsdElement schließen sich gegenseitig aus. Die UML-Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementPositionMustBeNaturalNumber-->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementenpositionIstNatuerlicheZahlGroesserNull">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and not(xs:integer(xoev:xsdElement(.)/@position) ge 1)]">
            <sch:assert role="error" id="ElementenpositionIstNatuerlicheZahlGroesserNull" test="false()">Die Position eines Elements (Eigenschaft position des Stereotyps xsdElement) muss eine Zahl größer null sein. Die UML-Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementPositionMustBeUnique -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementenpositionIstEindeutig">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and
                xoev:elements(parent::*)[@xmi:id != current()/@xmi:id and xoev:xsdElement(.)/@position = current()/xoev:xsdElement(.)/@position]]">
            <sch:assert role="error" id="ElementenpositionIstEindeutig" test="false()">Die Position eines Elements (Eigenschaft position des Stereotyps xsdElement) muss innerhalb eines Bausteins (UML-Klasse) eindeutig sein. Die UML-Eigenschaft <sch:value-of select="xgen:model-path(.)"/> besitzt jedoch dieselbe Position wie die folgenden Eigenschaften: <sch:value-of select="xoev:elements(parent::*)[@xmi:id != current()/@xmi:id and xoev:xsdElement(.)/@position = current()/xoev:xsdElement(.)/@position]/@name"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TypeNamesUniqueInNamespace -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-NamenVonTypenEindeutig">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and
                ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdNamedType(.) and
                @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and
                ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdNamedType(.) and
                @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]]">
            <sch:assert role="error" id="NamenVonTypenEindeutig" test="false()">Im gleichen Namensraum dürfen keine benannten Datentypen (UML-Klassen mit dem Stereotyp xsdNamedType) mit dem gleichen Namen existieren. Der Name des Typs <sch:value-of select="xgen:model-path(.)"/> ist im Namensraum "<sch:value-of select="xoev:getNamespace(.)"/>" nicht eindeutig.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GlobalElementNamesUniqueInNamespace -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-NamenVonGlobalenElementenEindeutig">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and
                ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdGlobalElement(.) and
                @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and
                ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdGlobalElement(.) and
                @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]]">
            <sch:assert role="error" id="NamenVonGlobalenElementenEindeutig" test="false()">Im gleichen Namensraum dürfen keine globalen Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) mit dem gleichen Namen existieren. Der Name des globalen Elements <sch:value-of select="xgen:model-path(.)"/> ist im Namensraum "<sch:value-of select="xoev:getNamespace(.)"/>" nicht eindeutig.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NoInnerSchemas -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaDefinitionenNichtVerschachtelt">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and ancestor::packagedElement[xoev:xsdSchema(.)]]">
            <sch:assert role="error" id="SchemaDefinitionenNichtVerschachtelt" test="false()">XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) dürfen nicht verschachtelt sein. Das XML Schema-Paket <sch:value-of select="xgen:model-path(.)"/> befindet sich jedoch im XML Schema-Paket <sch:value-of select="xgen:model-path(ancestor::packagedElement[xoev:xsdSchema(.)])"/>.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CodelistsMustBeNamed -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenHabenEinenNamen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and xoev:xsdNamedType(.) and @name = ''] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xoevCodeliste(.) and xoev:xsdNamedType(.) and @name = '']">
            <sch:assert role="error" id="CodelistenHabenEinenNamen" test="false()">Benannte Codelisten (UML-Enumerationen mit den Stereotypen xoevCodeliste und xsdNamedType) müssen einen Namen (Name der UML-Enumeration) besitzen. Im Paket <sch:value-of select="xgen:model-path(parent::packagedElement)"/> befindet sich jedoch eine Codeliste ohne einen solchen Namen.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CodelistBaseMustBeSimpleType -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenBasistypIstSimpleType">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdCodeList(.)/xoev:resolve-base(.)[not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:allElements(.) or xoev:allAttributes(.)]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[
                xoev:xsdCodeList(.)/xoev:resolve-base(.)[not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:allElements(.) or xoev:allAttributes(.)]]">
            <sch:assert role="error" id="CodelistenBasistypIstSimpleType" test="false()">Der Basistyp einer Codeliste (Eigenschaft base des Stereotyps xsdCodeList) muss ein einfacher Datentyp sein. Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. Der Basistyp der Codeliste ist <sch:value-of select="xoev:xsdCodeList(.)/xoev:resolve-base(.)/xgen:model-path(.)"/>.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CodeEnumerationHasTokenType -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenBasistypIstTokenOderAbleitungVonToken">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdCodeList(.)/xoev:resolve-base(.)[empty((., xoev:allParents(.))[@name = 'token'])]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdCodeList(.)/xoev:resolve-base(.)[empty((., xoev:allParents(.))[@name = 'token'])]]">
            <sch:assert role="error" id="CodelistenBasistypIstTokenOderAbleitungVonToken" test="false()">Der Basistyp einer Codeliste (Eigenschaft des Stereotyps xsdCodeList) muss xs:token oder einem davon abgeleiteten Datentypen entsprechen. Die Codeliste <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. Der Basistyp der Codeliste ist <sch:value-of select="xoev:xsdCodeList(.)/xoev:resolve-base(.)/xgen:model-path(.)"/>.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementsAndAttributesMustBeNamed -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementeUndAttributeSindBenannt">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.)[not(@isRef)] or xoev:xsdAttribute(.)[not(@isRef)]) and @name = '']">
            <sch:assert role="error" id="ElementeUndAttributeSindBenannt" test="false()">XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) müssen benannt sein. Ein Element bzw. Attribut in der Klasse <sch:value-of select="xgen:model-path(parent::*)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementNamesAndGroupRefElementNamesMustBeUniqueOnSamelevel -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementnamenSindAufBausteinebeneEindeutig">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[ancestor::packagedElement[xoev:xsdSchema(.)] and uml:is-Class(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[ancestor::packagedElement[xoev:xsdSchema(.)] and uml:is-Class(.)]">
            <sch:assert role="error" id="ElementnamenSindAufBausteinebeneEindeutig" test="count(xoev:allElementNamesIncludingRefsAndGroups(.)) = count(distinct-values(xoev:allElementNamesIncludingRefsAndGroups(.)))">Die XML-Elemente eines Bausteins (UML-Klasse) müssen eindeutig benannt sein. Hierbei sind auch die Namen referenzierter globaler Elemente und die Namen der Elemente in referenzierten Gruppen zu berücksichtigen. Im Kontext des Bausteins <sch:value-of select="xgen:model-path(.)"/> sind die folgenden Namen nicht eindeutig: <sch:value-of select="
                        if (xoev:getDuplicateStrings(xoev:allElementNamesIncludingRefsAndGroups(.)) = '') then
                            'Elemente ohne Namen'
                        else
                            xoev:getDuplicateStrings(xoev:allElementNamesIncludingRefsAndGroups(.))"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TypedGlobalElementsCannotHaveAdditionalAttributesOrElements -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMitTypHabenKeineEigenenElementeOderAttribute">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)] and
                (xoev:allElements(.) or xoev:allAttributes(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifer[xoev:xsdGlobalElement(.) and xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)] and
                (xoev:allElements(.) or xoev:allAttributes(.))]">
            <sch:assert role="error" id="GlobaleElementeMitTypHabenKeineEigenenElementeOderAttribute" test="false()">Typisierte globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement und einer UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdGlobalElementType) dürfen keine eigenen XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) oder XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) besitzen. Das globale Element <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TypedGlobalElementsCanOnlyHaveOneType -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMaximalEinenTyp">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and count(xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]) ge 2] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifer[xoev:xsdGlobalElement(.) and count(xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]) ge 2]">
            <sch:assert role="error" id="GlobaleElementeMaximalEinenTyp" test="false()">Globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) dürfen nicht mehr als einen Typen zugewiesen bekommen (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdGlobalElementType). Das globale Element <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. Ihm sind die folgenden Typen zugewiesen: <sch:value-of select="xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)/@name"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TypedGlobalElementsReferToNamedType -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-TypisierteGlobaleElementeHabenBenanntenTyp">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and
                xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)[not(xoev:xsdNamedType(.))]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and
                xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)[not(xoev:xsdNamedType(.))]]">
            <sch:assert role="error" id="TypisierteGlobaleElementeHabenBenanntenTyp" test="false()">Typisierte globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement und einer UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdGlobalElementType) müssen einen benannten Typ haben. Das globale Element <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. Ihm ist der folgende Baustein zugewiesen: <sch:value-of select="xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)/@name"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: RefTargetsGlobalElementOrGroup -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementReferenzReferenziertGlobalesElementOderElementgruppe">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.)/@isRef and
                uml:resolve-type(.)[not(xoev:xsdGlobalElement(.) or xoev:xsdGroup(.))]]">
            <sch:assert role="error" id="ElementReferenzReferenziertGlobalesElementOderElementgruppe" test="false()">Element-Referenzen (UML-Eigenschaften mit Eigenschaft isRef des Stereotyps xsdElement) müssen auf globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) oder Elementgruppen (UML-Klassen mit dem Stereotyp xsdGroup) referenzieren. Das globale Element <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. Ihm ist der folgende Baustein zugewiesen: <sch:value-of select="uml:resolve-type(.)/@name"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaFileMustBeDefined -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-DateinameEinerXMLSchemaDefinitionIstAngegeben">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdSchema(.)]">
            <sch:assert role="error" id="DateinameEinerXMLSchemaDefinitionIstAngegeben" test="xoev:xsdSchema(.)/@schemaFile[. != '']">XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen einen Dateinamen aufweisen (Eigenschaft schemaFile des Stereotyps xsdSchema). Das Schema-Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaLocationMustBeDefined -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationEinerXMLSchemaDefinitionIstAngegeben">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdSchema(.) and ancestor::packagedElement/xoev:xsdXModel(.)[@deployment = 'true' and not(@schemaLocationBase[. != ''])]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[
                xoev:xsdSchema(.) and ancestor::packagedElement/xoev:xsdXModel(.)[@deployment = 'true' and not(@schemaLocationBase[. != ''])]]">
            <sch:assert role="error" id="SchemaLocationEinerXMLSchemaDefinitionIstAngegeben" test="xoev:xsdSchema(.)/@schemaLocation[. != '']">XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen eine Schema Location aufweisen (Eigenschaft schemaLocation des Stereotyps xsdSchema), sofern keine Schema Location Base für das XÖV-Fachmodell (UML-Modell mit der Eigenschaft schemaLocationBase des Stereotyps xsdXModel) vorliegt. Das Schema-Paket <sch:value-of select="xgen:model-path(.)"/> besitzt keine Schema Location. Gleichzeitig ist auch keine Schema Location Base spezifiziert.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ImportImpliesDifferentNamespacesAndPrefixes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ImportsNurZwischenXMLSchemaDefinitionenUnterschiedlicherNamensraeume">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdImport(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdImport(.)]">
            <sch:let name="client" value="uml:resolve-client(.)"/>
            <sch:let name="supplier" value="uml:resolve-supplier(.)"/>
            <sch:assert role="error" id="ImportsNurZwischenXMLSchemaDefinitionenUnterschiedlicherNamensraeume" test="
                    not($client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.)) and
                    not(($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] =
                    (xoev:xsdImport(.)/@prefix, $supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1])">Die Namensräume (spezifiziert an Schema-Paketen mittels der Eigenschaft namespace des Stereotyps xsdSchema oder am XÖV-Fachmodell mittels der Eigenschaft namespace des Stereotyps xsdXModel) und Namensraumpräfixe (spezifiziert an der Import-Beziehung mittels der Eigenschaft prefix des Stereotyps xsdImport, am Schema-Paket mittels der Eigenschaft prefix des Stereotyps xsdSchema oder am XÖV-Fachmodell mittels der Eigenschaft prefix des Stereotyps xsdXModel) zweier XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema), zwischen denen eine XML-Import-Beziehung besteht (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport) müssen sich unterscheiden. Die beiden Schema-Pakete <sch:value-of select="xgen:model-path(uml:resolve-client(.))"/> (importierendes Paket) und <sch:value-of select="xgen:model-path(uml:resolve-supplier(.))"/> (importiertes Paket) verletzen diese Vorgabe.<sch:value-of select="
                        if ($client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.)) then
                            concat(' Der Namensraum ist identisch: ', $client/xoev:getNamespace(.), '.')
                        else
                            ''"/>
                <sch:value-of select="
                        if (($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] =
                        (xoev:xsdImport(.)/@prefix, $supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]) then
                            concat(' Das Präfix ist identisch: ', ($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], '.')
                        else
                            ''"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NoCyclicImportsAndIncludes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ImportUndIncludeBeziehungenZyklenfrei">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdSchema(.)]">
            <sch:assert role="error" id="ImportUndIncludeBeziehungenZyklenfrei" test="
                    empty(
                    index-of(
                    xoev:allImportedAndIncludedPackageIDs(
                    xoev:dependencies-by-client(.)[xoev:xsdImport(.) or xoev:xsdInclude(.)]/uml:resolve-supplier(.)/@xmi:id,
                    ancestor::uml:Model),
                    @xmi:id))">Eine XML Schema-Definition (UML-Paket mit dem Stereotyp xsdSchema) darf sich nicht direkt oder indirekt selbst inkludieren oder importieren. Das Schema-Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: UniqueSchemaFileNamesInModel -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-DateinamenVonXMLSchemaDefinitionenEindeutig">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]">
            <sch:assert role="error" id="DateinamenVonXMLSchemaDefinitionenEindeutig" test="
                    count(descendant::packagedElement/xoev:xsdSchema(.)/@schemaFile) =
                    count(distinct-values(descendant::packagedElement/xoev:xsdSchema(.)/@schemaFile))">XML Schema-Definition (UML-Pakete mit dem Stereotyp xsdSchema) müssen im XÖV-Fachmodell eindeutige Dateinamen aufweisen (Eigenschaft schemaFile des Sterotyps xsdSchema). Die folgenden Dateinamen werden mehrfach verwendet: <sch:value-of select="
                        distinct-values(descendant::packagedElement[xoev:xsdSchema(.) and
                        (some $s in current()/descendant::packagedElement[xoev:xsdSchema(.)]
                            satisfies $s/@xmi:id != @xmi:id and $s/xoev:xsdSchema(.)/@schemaFile = xoev:xsdSchema(.)/@schemaFile)]/xoev:xsdSchema(.)/@schemaFile)"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: UniqueSchemaLocationsInModel -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationsVonXMLSchemaDefinitionenEindeutig">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]">
            <sch:assert role="error" id="SchemaLocationsVonXMLSchemaDefinitionenEindeutig" test="
                    count(descendant::packagedElement/xoev:xsdSchema(.)/@schemaLocation) =
                    count(distinct-values(descendant::packagedElement/xoev:xsdSchema(.)/@schemaLocation))">XML Schema-Definition (UML-Pakete mit dem Stereotyp xsdSchema) müssen im XÖV-Fachmodell eindeutige Schema Locations aufweisen (Eigenschaft schemaLocation des Stereotyps xsdSchema), sofern solche explizit angegeben wurden. Die folgenden Schema Locations werden mehrfach verwendet: <sch:value-of select="
                        distinct-values(descendant::packagedElement[xoev:xsdSchema(.) and
                        (some $s in current()/descendant::packagedElement[xoev:xsdSchema(.)]
                            satisfies $s/@xmi:id != @xmi:id and $s/xoev:xsdSchema(.)/@schemaLocation = xoev:xsdSchema(.)/@schemaLocation)]/xoev:xsdSchema(.)/@schemaLocation)"/></sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: IncludeImpliesEqualNamespacesAndPrefixes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-InkludierterNamensraumUndInkludiertesPraefixEntsprechenDenenDesInkludierendemSchemas">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdInclude(.)]">
            <sch:let name="client" value="uml:resolve-client(.)"/>
            <sch:let name="supplier" value="uml:resolve-supplier(.)"/>
            <sch:assert role="error" id="InkludierterNamensraumUndInkludiertesPraefixEntsprechenDenenDesInkludierendemSchemas" test="
                    $client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.) and
                    ($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] =
                    ($supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]">Der Namensraum und das Präfix einer inkludierten XML Schema-Definition müssen denen der inkludierenden XML Schema-Definition entsprechen. Die inkludierende XML Schema-Definition <sch:value-of select="xgen:model-path($client)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ImportsAndIncludesAreBinaryRelationships
        In XGen3 nicht umgesetzt, da Prüfanweisung vermutlich nicht verletzt werden kann. -->

    <!-- Quelle XGen2: ImportsAndIncludesBetweenSchemas -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ImportsUndIncludesNurZwischenSchemaPaketen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdInclude(.) or xoev:xsdImport(.)]">
            <sch:assert role="error" id="ImportsUndIncludesNurZwischenSchemaPaketen" test="uml:resolve-supplier(.)[xoev:xsdSchema(.)] and uml:resolve-client(.)[xoev:xsdSchema(.)]">XML-Imports (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport) und XML-Includes (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdInclude) müssen zwei XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) verbinden. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NamedTypesMustBeNamed -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-BenannteTypenMuessenNamenHaben">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and not(@name[. != ''])]">
            <sch:assert role="error" id="BenannteTypenMuessenNamenHaben" test="false()">Benannte Datentypen (UML-Klassen mit dem Stereotyp xsdNamedType) müssen einen Namen besitzen. Im Paket <sch:value-of select="xgen:model-path(.)"/> liegt ein Typ ohne Namen vor.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GroupsMustBeNamed -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenMuessenNamenHaben">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGroup(.) and not(@name[. != ''])]">
            <sch:assert role="error" id="GruppenMuessenNamenHaben" test="false()">XML-Gruppen (UML-Klassen mit dem Stereotyp xsdGroup) müssen einen Namen besitzen. Im Paket <sch:value-of select="xgen:model-path(.)"/> liegt eine solche Gruppe ohne Namen vor.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GlobalElementsMustBeNamed -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMuessenNamenHaben">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and not(@name[. != ''])]">
            <sch:assert role="error" id="GlobaleElementeMuessenNamenHaben" test="false()">Globale Elemente (UML-KLassen mit dem Stereotyp xsdGlobalElement) müssen einen Namen besitzen. Im Paket <sch:value-of select="xgen:model-path(.)"/> liegt ein solches globales Element ohne Namen vor.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MinOneElementInGroup -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenHabenMindestensEinElementOderAttribut">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGroup(.)]">
            <sch:assert role="error" id="GruppenHabenMindestensEinElementOderAttribut" test="xoev:elements(.) or xoev:attributes(.)">XML-Gruppen (UML-Klassen mit dem Stereotyp xsdGroup) müssen mindestens ein XML-Element oder -Attribut besitzen. Die Gruppe <sch:value-of select="xgen:model-path(.)"/> versetzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: OnlyElementsXorAttributesInGroup -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenEnthaltenEntwederElementeOderAttribute">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGroup(.) and xoev:attributes(.) and xoev:elements(.)]">
            <sch:assert role="error" id="GruppenEnthaltenEntwederElementeOderAttribute" test="false()">XML-Gruppen (UML-Klassen mit dem Stereotyp xsdGroup) besitzen entweder ausschließlich XML-Elemente oder ausschließlich XML-Attribute. Die Gruppe <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: XOEVStereotypedClassesBelongToSchema -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteKlassenInSchemaPaketen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdNamedType(.) or xoev:xsdChoice(.) or xoev:xsdCode(.) or xoev:xsdGlobalElement(.) or xoev:xsdAnyContents(.)]">
            <sch:assert role="error" id="AnnotierteKlassenInSchemaPaketen" test="ancestor::packagedElement[xoev:xsdSchema(.)]">UML-Klassen, die mit Stereotypen annotiert sind, müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: XOEVStereotypedDependenciesBelongToSchema -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteAbhaengigkeitsbeziehungenInSchemaPaketen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdInclude(.) or xoev:xsdImport(.) or xoev:xsdKey(.) or xoev:xsdKeyref(.) or xoev:xsdUnique(.)]">
            <sch:assert role="error" id="AnnotierteAbhaengigkeitsbeziehungenInSchemaPaketen" test="ancestor::packagedElement[xoev:xsdSchema(.)]">UML-Abhängigkeitsbeziehungen (Dependencies), die mit Stereotypen annotiert sind, müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: XOEVStereotypedGeneralizationsBelongToSchema -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteGeneralisierungenInSchemaPaketen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)]">
            <sch:assert role="error" id="AnnotierteGeneralisierungenInSchemaPaketen" test="ancestor::packagedElement[xoev:xsdSchema(.)]">UML-Generalisierungsbeziehungen, die mit Stereotypen annotiert sind, müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: XOEVStereotypedPropertiesBelongToSchema -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteElementeUndAttributeInSchemaPaketen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]">
            <sch:assert role="error" id="AnnotierteElementeUndAttributeInSchemaPaketen" test="ancestor::packagedElement[xoev:xsdSchema(.)]">XML-Elemente und -Attribute (UML-Eigenschaften mit dem Stereotyp xsdElement oder xsdAttribute) müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. Das <sch:value-of select="
                        if (xoev:xsdElement(.)) then
                            'Element '
                        else
                            'Attribut '"/>
                <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PropertiesOfNamedTypesAndGlobalElementsAreLocalStructuresElementsOrAttributes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and ownedAttribute] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and ownedAttribute]">
            <sch:assert role="error" id="TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen" test="count(ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)">UML-Klassen, die Typen (Stereotyp xsdNamedType) oder globale Elemente (Stereotyp xsdGlobalElement) repräsentieren, besitzen ausschließlich Eigenschaften, die XML-Elemente (Stereotyp xsdElement), XML-Attribute (Stereotyp xsdAttribute) oder lokale XML-Strukturen (Stereotyp xsdLocalStructure) repräsentieren. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NoPropertiesForAnyContents -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AnyContentsKlassenOhneEigenschaften">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdAnyContents(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdAnyContents(.)]">
            <sch:assert role="error" id="AnyContentsKlassenOhneEigenschaften" test="empty(ownedAttribute[xoev:xsdElement(.)])">UML-Klassen, die any-Elemente repräsentieren (Stereotyp xsdAnyContents), dürfen keine XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) besitzen. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SingleInheritance -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-EinfacheVererbung">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Class(.) and count(generalization) gt 1] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[uml:is-Class(.) and count(generalization) gt 1]">
            <sch:assert role="error" id="EinfacheVererbung" test="false()">Typen und globale Elemente dürfen von maximal einem Basistypen ableiten. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: RestrictionRestricts -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionSchraenktEin">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.) and
                not(uml:resolve-general(.)/ancestor::packagedElement[xoev:xoevAdapter(.)])]">
            <sch:let name="restricted" value=".."/>
            <sch:let name="base" value="uml:resolve-general(.)"/>
            <sch:assert role="error" id="XMLRestriktionSchraenktEin" test="
                    (every $p in $restricted/ownedAttribute
                        satisfies
                        $base/ownedAttribute[@name = $p/@name]/uml:resolve-type(.)[
                        @xmi:id = $p/uml:resolve-type(.)/(., xoev:allParents(.))/@xmi:id or
                        @name = ('token', 'string', 'normalizedString') and $p/uml:resolve-type(.)[uml:is-Enumeration(.)]]
                        
                        and
                        
                        $base/ownedAttribute[@name = $p/@name and xoev:lowerBound($p) ge xoev:lowerBound(.) and
                        (xoev:upperBound(.) = -1 or xoev:upperBound($p) != -1 and xoev:upperBound($p) le xoev:upperBound(.))]) and
                    ($restricted/xoev:xsdChoice(.) or (every $p in $base/ownedAttribute
                        satisfies
                        xoev:lowerBound($p) = 0 or $restricted/ownedAttribute[@name = $p/@name]))">Eine per XML-Restriktion (UML-Generalisierung mit dem Stereotyp xsdRestriction) abgeleitete UML-Klasse darf dem Basistyp keine UML-Klasseneigenschaften mehr hinzufügen. Die Eigenschaftstypen müssen gleich den Typen der entpsrechenden Eigenschaften im Basistyp sein bzw. diese einschränken. Ebenso müssen die Multiplizitäten der Eigenschaften gleich bzw. eingeschränkt gegenüber den Multiplizitäten im Basistyp sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GlobalElementExcludesOtherParticularXOEVClassStereotypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeOhneStereotypenXsdAnyContentsXsdCodeUndXsdNamedType">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and
                (xoev:xsdAnyContents(.), xoev:xsdCode(.), xoev:xsdNamedType(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and
                (xoev:xsdAnyContents(.), xoev:xsdCode(.), xoev:xsdNamedType(.))]">
            <sch:assert role="error" id="GlobaleElementeOhneStereotypenXsdAnyContentsXsdCodeUndXsdNamedType" test="false()">Globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) dürfen nicht gleichzeitig mit den Stereotypen xsdAnyContents, xsdCode oder xsdNamedType annotiert sein. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: AnyContentsExcludesOtherParticularXOEVClassStereotypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AnyElementeOhneStereotypenXsdGlobalElementXsdCodeUndXsdChoice">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdAnyContents(.) and
                (xoev:xsdGlobalElement(.), xoev:xsdCode(.), xoev:xsdChoice(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdAnyContents(.) and
                (xoev:xsdGlobalElement(.), xoev:xsdCode(.), xoev:xsdChoice(.))]">
            <sch:assert role="error" id="AnyElementeOhneStereotypenXsdGlobalElementXsdCodeUndXsdChoice" test="false()">Any-Elemente (UML-Klassen mit dem Stereotyp xsdAnyContents) dürfen nicht gleichzeitig mit den Stereotypen xsdGlobalElement, xsdCode oder xsdChoice annotiert sein. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ChoiceExcludesOtherParticularXOEVClassStereotypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ChoiceOhneStereotypenXsdAnyContentsUndXsdCode">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdChoice(.) and
                (xoev:xsdAnyContents(.), xoev:xsdCode(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdChoice(.) and
                (xoev:xsdAnyContents(.), xoev:xsdCode(.))]">
            <sch:assert role="error" id="ChoiceOhneStereotypenXsdAnyContentsUndXsdCode" test="false()">XML-Choices (UML-Klassen mit dem Stereotyp xsdChoice) dürfen nicht gleichzeitig mit den Stereotypen xsdAnyContents oder xsdCode annotiert sein. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CodeExcludesOtherParticularXOEVClassStereotypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-CodeDatentypenOhneStereotypenXsdGlobalElementXsdAnyContentsUndXsdChoice">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdCode(.) and
                (xoev:xsdGlobalElement(.), xoev:xsdAnyContents(.), xoev:xsdChoice(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdCode(.) and
                (xoev:xsdGlobalElement(.), xoev:xsdAnyContents(.), xoev:xsdChoice(.))]">
            <sch:assert role="error" id="CodeDatentypenOhneStereotypenXsdGlobalElementXsdAnyContentsUndXsdChoice" test="false()">Code-Datentypen (UML-Klassen mit dem Stereotyp xsdCode) dürfen nicht gleichzeitig mit den Stereotypen xsdGlobalElement, xsdAnyContents oder xsdChoice annotiert sein. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GlobalElementsAreClassesOrEnumerations -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeSindKlassenOderEnumerationen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and not(uml:is-Class(.) or uml:is-Enumeration(.))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and not(uml:is-Class(.) or uml:is-Enumeration(.))]">
            <sch:assert role="error" id="GlobaleElementeSindKlassenOderEnumerationen" test="false()">Globale Elemente müssen UML-Klassen oder UML-Enumerationen sein. Das UML-Element <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ActivatedClassesMustNotUseDeactivatedClasses -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-KeineTypenImEntwurfGenutzt">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and
                not((parent::packagedElement | parent::nestedClassifier)/xoev:xsdDraft(.)) and uml:resolve-type(.)/xoev:xsdDraft(.)]">
            <sch:assert role="error" id="KeineTypenImEntwurfGenutzt" test="false()">XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) dürfen keine sich im Entwurf befindenden Typen bzw. Elemente nutzen (UML-Klassen mit dem Stereotyp xsdDraft), sofern sie nicht Teil einer Klasse sind, die sich ebenso im Entwurf befindet. Die UML-Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: RestrictionWithValidElementOrder -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMitKorrekterElementenreihenfolge">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.) and not(xoev:xsdAll(.)) and
                not(xoev:allParents(.)/ancestor::packagedElement[xoev:xoevAdapter(.)])] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.) and not(xoev:xsdAll(.)) and
                not(xoev:allParents(.)/ancestor::packagedElement[xoev:xoevAdapter(.)])]">
            <sch:let name="class" value="."/>
            <sch:let name="basistyp" value="$class/generalization/uml:resolve-general(.)"/>
            <sch:let name="elemente-basistyp" value="
                    $basistyp/xoev:allElements(.)[(if (xoev:xsdElement(.)/@isRef = 'true') then
                        uml:resolve-type(.)/@name
                    else
                        @name) = $class/xoev:elements(.)/(if (xoev:xsdElement(.)/@isRef = 'true') then
                        uml:resolve-type(.)/@name
                    else
                        @name)]"/>
            <sch:let name="elemente-rest" value="$class/xoev:elements(.)"/>
            <sch:assert role="error" id="XMLRestriktionMitKorrekterElementenreihenfolge" test="
                    every $e in $elemente-rest
                        satisfies count($elemente-rest[number(xoev:xsdElement(.)/@position) le number($e/xoev:xsdElement(.)/@position)]) =
                        count($elemente-basistyp[xoev:getRealPosition((if (xoev:xsdElement(.)/@isRef = 'true') then
                            uml:resolve-type(.)/@name
                        else
                            @name), $basistyp) le xoev:getRealPosition($e/(if (xoev:xsdElement(.)/@isRef = 'true') then
                            uml:resolve-type(.)/@name
                        else
                            @name), $basistyp)])">XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) müssen in einem per XML-Restriktion (UML-Generalisierung mit dem Stereotyp xsdRestriction) eingeschränkten Datentypen die gleiche Reihenfolge wie die Elemente des Basistyps aufweisen. Die UML-Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe. Elementreihenfolge des Basistyps: <sch:value-of select="xoev:sortAndConcatForXMLRestriktionMitKorrekterElementenreihenfolge($basistyp)"/> Elementreihenfolge des eingeschränkten Typs: <sch:value-of select="xoev:sortAndConcatForXMLRestriktionMitKorrekterElementenreihenfolge($class)"/>
            </sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: RestrictionFacetsOnlyForSimpleContent -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFacettenNurBeiSimpleContent">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and
                generalization/xoev:xsdRestriction(.)[@fractionDigits or @length or @totalDigits or @maxExclusive or @maxInclusive or @maxLength or
                @minInclusive or @minInclusive or @minLength or @pattern or
                @whitespace]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and
                generalization/xoev:xsdRestriction(.)[@fractionDigits or @length or @totalDigits or @maxExclusive or
                @maxInclusive or @maxLength or @minInclusive or @minInclusive or @minLength or @pattern or
                @whitespace]]">
            <sch:assert role="error" id="XMLRestriktionFacettenNurBeiSimpleContent" test="
                    empty(xoev:elements(.)) and empty(generalization/uml:resolve-general(.)/xoev:allElements(.))">XML-Restriction-Facetten (Eigenschaften des Stereotyps xsdRestriction) dürfen ausschließich im Kontext von Datentypen mit einfachem Inhalt genutzt werden. Die UML-Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: FractionDigitsOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFractionDigitsMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@fractionDigits]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@fractionDigits]]">
            <sch:assert role="error" id="XMLRestriktionFractionDigitsMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = 'decimal'">Datentypen, die per XML-Restriction mit der Facette fractionDigits (Eigenschaft fractionDigits des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:decimal als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: LengthOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@length]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@length]]">
            <sch:assert role="error" id="XMLRestriktionLengthMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name =
                    ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS',
                    'normalizedString', 'NOTATION', 'QName', 'string', 'token')">Datentypen, die per XML-Restriction mit der Facette length (Eigenschaft length des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, base64Binary, xs:ENTITIES, xs:ENTITY, xs:hexBinary, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:NOTATION, xs:QName, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MaxExclusiveOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxExclusiveMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@maxExclusive]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@maxExclusive]]">
            <sch:assert role="error" id="XMLRestriktionMaxExclusiveMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">Datentypen, die per XML-Restriction mit der Facette maxExclusive (Eigenschaft maxExclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MaxInclusiveOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxInclusiveMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@maxInclusive]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@maxInclusive]]">
            <sch:assert role="error" id="XMLRestriktionMaxInclusiveMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">Datentypen, die per XML-Restriction mit der Facette maxInclusive (Eigenschaft maxInclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MaxLengthOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxLengthMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@maxLength]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@maxLength]]">
            <sch:assert role="error" id="XMLRestriktionMaxLengthMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')">Datentypen, die per XML-Restriction mit der Facette maxLength (Eigenschaft maxLength des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, base64Binary, xs:ENTITIES, xs:ENTITY, xs:hexBinary, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:NOTATION, xs:QName, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MinExclusiveOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinExclusiveMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@minExclusive]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@minExclusive]]">
            <sch:assert role="error" id="XMLRestriktionMinExclusiveMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">Datentypen, die per XML-Restriction mit der Facette minExclusive (Eigenschaft minExclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MinInclusiveOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinInclusiveMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@minInclusive]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@minInclusive]]">
            <sch:assert role="error" id="XMLRestriktionMinInclusiveMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">Datentypen, die per XML-Restriction mit der Facette minInclusive (Eigenschaft minInclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MinLengthOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinLengthMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@minLength]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@minLength]]">
            <sch:assert role="error" id="XMLRestriktionMinLengthMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')">Datentypen, die per XML-Restriction mit der Facette minLength (Eigenschaft minLength des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, base64Binary, xs:ENTITIES, xs:ENTITY, xs:hexBinary, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:NOTATION, xs:QName, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PatternOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionPatternMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@pattern]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@pattern]]">
            <sch:assert role="error" id="XMLRestriktionPatternMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'boolean', 'byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'ENTITY', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'hexBinary', 'ID', 'IDREF', 'int', 'integer', 'language', 'long', 'Name', 'NCName', 'negativeInteger', 'NMTOKEN', 'nonNegativeInteger', 'nonPositiveInteger', 'normalizedString', 'NOTATION', 'positiveInteger', 'QName', 'short', 'string', 'time', 'token', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">Datentypen, die per XML-Restriction mit der Facette pattern (Eigenschaft pattern des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, xs:base64Binary, xs:boolean, xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:ENTITY, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:hexBinary, xs:ID, xs:IDREF, xs:int, xs:integer, xs:language, xs:long, xs:Name, xs:NCName, xs:negativeInteger, xs:NMTOKEN, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:normalizedString, xs:NOTATION, xs:positiveInteger, xs:QName, xs:short, xs:string, xs:time, xs:token, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TotalDigitsOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionTotalDigitsMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@totalDigits]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@totalDigits]]">
            <sch:assert role="error" id="XMLRestriktionTotalDigitsMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'decimal', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">Datentypen, die per XML-Restriction mit der Facette totalDigits (Eigenschaft totalDigits des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:decimal, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: WhitespaceOnlyForParticularW3CDataTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionWhitespaceMitKorrektenW3CDatentypen">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@whitespace]] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@whitespace]]">
            <sch:assert role="error" id="XMLRestriktionWhitespaceMitKorrektenW3CDatentypen" test="
                    generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('ENTITIES', 'ENTITY', 'ID', 'IDREF', 'IDREFS', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'string', 'token')">Datentypen, die per XML-Restriction mit der Facette whitespace (Eigenschaft whitespace des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:ENTITIES, xs:ENTITY, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: LengthNonNegativeInteger -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthIstPositiveGanzeZahl">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@length]]">
            <sch:assert role="error" id="XMLRestriktionLengthIstPositiveGanzeZahl" test="
                    replace(xoev:xsdRestriction(.)/@length, '[0-9]+', '') = ''">Die Eigenschaft length des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MaxLengthNonNegativeInteger -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxLengthIstPositiveGanzeZahl">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@maxLength]]">
            <sch:assert role="error" id="XMLRestriktionMaxLengthIstPositiveGanzeZahl" test="
                    replace(xoev:xsdRestriction(.)/@maxLength, '[0-9]+', '') = ''">Die Eigenschaft maxLength des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TotalDigitsNonNegativeInteger -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionTotalDigitsIstPositiveGanzeZahl">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@totalDigits]]">
            <sch:assert role="error" id="XMLRestriktionTotalDigitsIstPositiveGanzeZahl" test="
                    replace(xoev:xsdRestriction(.)/@totalDigits, '[0-9]+', '') = ''">Die Eigenschaft totalDigits des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: FractionDigitsNonNegativeInteger -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFractionDigitsIstPositiveGanzeZahl">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@fractionDigits]]">
            <sch:assert role="error" id="XMLRestriktionFractionDigitsIstPositiveGanzeZahl" test="
                    replace(xoev:xsdRestriction(.)/@fractionDigits, '[0-9]+', '') = ''">Die Eigenschaft fractionDigits des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: LengthExcludesMaxAndMinLength -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthSchliesstMaxLengthUndMinLengthAus">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@length]]">
            <sch:assert role="error" id="XMLRestriktionLengthSchliesstMaxLengthUndMinLengthAus" test="
                    empty(xoev:xsdRestriction(.)/@maxLength) and empty(xoev:xsdRestriction(.)/@minLength)">Die Eigenschaft length des Stereotyps xsdRestriction darf nicht zusammen mit den Eigenschaften maxLength oder minLength angegeben sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MaxExclusiveExcludesMaxInclusive -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxExclusiveUndMaxInclusiveSchliessenSichAus">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@maxExclusive and @maxInclusive]]">
            <sch:assert role="error" id="XMLRestriktionMaxExclusiveUndMaxInclusiveSchliessenSichAus" test="false()">Die Eigenschaften maxExclusive und maxInclusive des Stereotyps xsdRestriction schließen sich gegenseitig aus. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MinExclusiveExcludesMinInclusive -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinExclusiveUndMinInclusiveSchliessenSichAus">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@minExclusive and @minInclusive]]">
            <sch:assert role="error" id="XMLRestriktionMinExclusiveUndMinInclusiveSchliessenSichAus" test="false()">Die Eigenschaften minExclusive und minInclusive des Stereotyps xsdRestriction schließen sich gegenseitig aus. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ValueRestrictionForWhitespaceFacet -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionWhitespaceMitKorrektenWerten">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@whitespace]]">
            <sch:assert role="error" id="XMLRestriktionWhitespaceMitKorrektenWerten" test="xoev:xsdRestriction(.)/@whitespace = ('preserve', 'replace', 'collapse')">Die Eigenschaft whitespace des Stereotyps xsdRestriction muss den Wert "preserve", "replace" oder "collapse" besitzen. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: AttributeTypesBasedOnW3CDatatypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AttributMitKorrektemTyp">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdAttribute(.)[not(@isRef)]]">
            <sch:assert role="error" id="AttributMitKorrektemTyp" test="
                    uml:resolve-type(.)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' or
                    uml:resolve-type(.)/uml:is-Enumeration(.) or
                    uml:resolve-type(.)/xoev:xsdNamedType(.)">Der Typ eines XML-Attributs (UML-Eigenschaft mit dem Stereotyp xsdAttribute) muss ein W3C-Datentyp, die Ableitung eines W3C-Datentyps, eine Enumeration oder ein benannter Datentyp sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementTypesBasedOnW3CDatatypesOrDefinedSchemaTypes -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementMitKorrektemTyp">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.)]">
            <sch:assert role="error" id="ElementMitKorrektemTyp" test="
                    uml:resolve-type(.)[xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'] or
                    uml:resolve-type(.)/uml:is-Enumeration(.) or
                    uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdSchema(.)">Der Typ eines XML-Elements (UML-Eigenschaft mit dem Stereotyp xsdElement) muss ein W3C-Datentyp, die Ableitung eines W3C-Datentyps, eine Enumeration oder ein benannter Datentyp sein. <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementAndAttributeTypesMustBeVisible -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-ElementUndAttributTypenSichtbar">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and $xoev:ist-zyklenfrei]//ownedAttribute[
                xoev:xsdElement(.) and uml:resolve-type(.)/xoev:xsdNamedType(.) and
                ancestor::packagedElement[xoev:xsdSchema(.)]]">
            <sch:assert role="error" id="ElementUndAttributTypenSichtbar" test="
                    uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id =
                    (ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id,
                    xoev:package-with-imports-and-includes(ancestor::packagedElement[xoev:xsdSchema(.)])/(import, include)/@id)">Der Typ einer UML-Eigenschaft (bzw. die XML Schema-Definition, die den Typ enthält) muss in der XML Schema-Definition, in der die Eigenschaft spezifiziert ist, sichtbar sein, d. h. direkt oder indirekt per XML-Import bzw. -Include (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport bzw. xsdInclude) eingebunden sein. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: RestrictedAndExtendedTypesMustBeVisible -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-BasistypenSichtbar">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and
                $xoev:ist-zyklenfrei]//packagedElement[uml:is-Class(.) and generalization/uml:resolve-general(.)/xoev:xsdNamedType(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and
                $xoev:ist-zyklenfrei]//nestedClassifier[uml:is-Class(.) and generalization/uml:resolve-general(.)/xoev:xsdNamedType(.)]">
            <sch:assert role="error" id="BasistypenSichtbar" test="
                    generalization/uml:resolve-general(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id =
                    (ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id,
                    (if (ancestor::packagedElement[xoev:xsdSchema(.)]) then
                        xoev:package-with-imports-and-includes(ancestor::packagedElement[xoev:xsdSchema(.)])
                    else
                        ())/(import, include)/@id)">Der Basistyp einer UML-Klasse, von dem per UML-Generalisierung abgeleitet wird (bzw. die XML Schema-Definition, die den Typen enthält) muss in der XML Schema-Definition, in der die ableitende Klasse spezifiziert ist, sichtbar sein, d. h. direkt oder indirekt per XML-Import bzw. -Include (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport bzw. xsdInclude) eingebunden sein. Die ableitende Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: InlinePropertiesMustBeTyped -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-EigenschaftenHabenEinenTyp">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdAttribute(.) or xoev:xsdElement(.)) and empty(uml:resolve-type(.))]">
            <sch:assert role="error" id="EigenschaftenHabenEinenTyp" test="false()">Jede UML-Eigenschaft mit dem Stereotyp xsdAttribute oder xsdElement muss einen Typ besitzen. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: AttributesSingleValued -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AttributeMitEinzelnemWert">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdAttribute(.) and (xoev:upperBound(.) gt 1 or xoev:upperBound(.) = -1)]">
            <sch:assert role="error" id="AttributeMitEinzelnemWert" test="false()">XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) müssen die Multiplizität 0..1 oder 1 besitzen. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: FileExtensionXSDDefinedForSchemas -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaDateiEndungXsd">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and
                not(ends-with(xoev:xsdSchema(.)/@schemaFile, lower-case('.xsd')))]">
            <sch:assert role="error" id="SchemaDateiEndungXsd" test="false()">Dateinamen von Schema-Paketen (Eigenschaft schemaFile des Stereotyps xsdSchema) müssen "xsd" als Dateiendung beinhalten. Das UML-Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: FileExtensionXSDDefinedForSchemaLocations -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationEndungXsd">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and xoev:xsdSchema(.)/@schemaLocation and
                not(ends-with(xoev:xsdSchema(.)/@schemaLocation, lower-case('.xsd')))]">
            <sch:assert role="error" id="SchemaLocationEndungXsd" test="false()">Schema Locations (Eigenschaft schemaLocation des Stereotyps xsdSchema) müssen "xsd" als Dateiendung beinhalten, sofern sie im Kontext eines Schema-Pakets spezifiziert sind. Das UML-Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: AttributeOwnerAlsoOwnsAssociation -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-AssoziationImGleichenPaketWieEigenschaft">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[uml:resolve-association(.)]">
            <sch:assert role="information" id="AssoziationImGleichenPaketWieEigenschaft" test="
                    ancestor::packagedElement[uml:is-Package(.)][1] = uml:resolve-association(.)/ancestor::packagedElement[uml:is-Package(.)][1]">Es wird empfohlen, das eine UML-Assoziation (i. d. R. eine Komposition) im selben Paket wie die über die Assoziation spezifizierte Eigenschaft vorliegt. Die Eigenschaft (Assoziationsende) <sch:value-of select="xgen:model-path(.)"/> hält diese Empfehlung nicht ein.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: OnlyOneIncludeDependencyBetweenTwoPackages -->
    <sch:pattern id="NDR-28-ValideW3CXMLSchemaDefinitionen-KeineMehrfachenXMLIncludes">
        <sch:title>NDR-28: Valide W3C XML Schema-Definitionen</sch:title>
        <sch:p>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and xoev:dependencies-by-client(.)[xoev:xsdInclude(.)]]">
            <sch:assert role="error" id="KeineMehrfachenXMLIncludes" test="
                    every $d in xoev:dependencies-by-client(.)[xoev:xsdInclude(.)]
                        satisfies
                        not(xoev:dependencies-by-client(.)[xoev:xsdInclude(.) and @xmi:id != $d/@xmi:id]/uml:resolve-supplier(.)/@xmi:id =
                        $d/uml:resolve-supplier(.)/@xmi:id)">Ein Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) darf ein anderes Schema-Paket nicht mehrfach per XML-Include (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdInclude) einbinden. Das Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaMustHaveNamespace -->
    <sch:pattern id="NDR-29-IdentifizierendeNamensraeume-XMLSchemaDefinitionenHabenNamensraum">
        <sch:title>NDR-29: Identifizierende Namensräume</sch:title>
        <sch:p>Alle im Rahmen eines XÖV-Standards definierten globalen XML-Elemente und benannten XML-Typen müssen sich in einem Namensraum befinden, der den betroffenen XÖV-Standard eindeutig identifiziert.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and empty(xoev:getNamespace(.)[. != ''])]">
            <sch:assert role="error" id="XMLSchemaDefinitionenHabenNamensraum" test="false()">XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen einen Namensraum besitzen, entweder über die Eigenschaft namespace des Stereotyps xsdSchema oder die Eigenschaft namespace des Stereotyps xsdXModel. Das Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaMustHavePrefix -->
    <sch:pattern id="NDR-29-IdentifizierendeNamensraeume-XMLSchemaDefinitionenHabenPraefix">
        <sch:title>NDR-29: Identifizierende Namensräume</sch:title>
        <sch:p>Alle im Rahmen eines XÖV-Standards definierten globalen XML-Elemente und benannten XML-Typen müssen sich in einem Namensraum befinden, der den betroffenen XÖV-Standard eindeutig identifiziert.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[
                xoev:xsdSchema(.) and empty((xoev:xsdSchema(.)/@prefix, ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[. != ''])]">
            <sch:assert role="error" id="XMLSchemaDefinitionenHabenPraefix" test="false()">XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen ein Namensraumpräfix besitzen, entweder über die Eigenschaft prefix des Stereotyps xsdSchema oder die Eigenschaft prefix des Stereotyps xsdXModel. Das Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaMustBeVersioned -->
    <sch:pattern id="NDR-30-VersionierungDerXMLSchemaDefinitionen-XMLSchemaDefinitionenSindVersioniert">
        <sch:title>NDR-30: Versionierung der XML Schema-Definitionen</sch:title>
        <sch:p>Jede XML Schema-Definition eines XÖV-Standards muss versioniert sein.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)
                and empty((xoev:xsdSchema(.)/@version, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[. != ''])]">
            <sch:assert role="error" id="XMLSchemaDefinitionenSindVersioniert" test="false()">XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen eine Version besitzen, entweder über die Eigenschaft version des Stereotyps xsdSchema oder die Eigenschaft version des Stereotyps xoevVersionStandard. Das Paket <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardNameLangMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameLangMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@nameLang[. != ''])]">
            <sch:assert role="error" id="MetadatenelementStandardNameLangMussBefuelltSein" test="false()">Der Name (lang) eines Standards muss spezifiziert sein (Eigenschaft nameLang des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardNameKurzMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameKurzMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@nameKurz[. != ''])]">
            <sch:assert role="error" id="MetadatenelementStandardNameKurzMussBefuelltSein" test="false()">Der Name (kurz) eines Standards muss spezifiziert sein (Eigenschaft nameKurz des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardNameTechnischMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameTechnischMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@nameTechnisch[. != ''])]">
            <sch:assert role="error" id="MetadatenelementStandardNameTechnischMussBefuelltSein" test="false()">Der Name (technisch) eines Standards muss spezifiziert sein (Eigenschaft nameTechnisch des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardKennungMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@kennung[. != ''])]">
            <sch:assert role="error" id="MetadatenelementStandardKennungMussBefuelltSein" test="false()">Die Kennung eines Standards muss spezifiziert sein (Eigenschaft kennung des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardBeschreibungMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardBeschreibungMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@beschreibung[. != ''])]">
            <sch:assert role="error" id="MetadatenelementStandardBeschreibungMussBefuelltSein" test="false()">Die Beschreibung eines Standards muss vorliegen (Eigenschaft beschreibung des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementVersionStandardVersionMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@version[. != ''])]">
            <sch:assert role="error" id="MetadatenelementVersionStandardVersionMussBefuelltSein" test="false()">Die Version eines Standards muss spezifiziert sein (Eigenschaft version des Stereotyps xoevVersionStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementVersionStandardVersionXOEVHandbuchMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionXOEVHandbuchMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@versionXOEVHandbuch[. != ''])]">
            <sch:assert role="error" id="MetadatenelementVersionStandardVersionXOEVHandbuchMussBefuelltSein" test="false()">Die Version des XÖV-Handbuchs, zu dessen Regelungen die Version des Standards konform ist, muss spezifiziert sein (Eigenschaft versionXOEVHandbuch des Stereotyps xoevVersionStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementVersionStandardVersionXGeneratorMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionXGeneratorMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@versionXGenerator[. != ''])]">
            <sch:assert role="error" id="MetadatenelementVersionStandardVersionXGeneratorMussBefuelltSein" test="false()">Die Version des XGenerators, mit dem das XÖV-Fachmodell der Version des Standards verarbeitet und die Bestandteile der Version des Standards erzeugt wurden, muss spezifiziert sein (Eigenschaft versionXGenerator des Stereotyps xoevVersionStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementVersionStandardVersionModellierungswerkzeugMussBefuelltSein -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionModellierungswerkzeugMussBefuelltSein">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@versionModellierungswerkzeug[. != ''])]">
            <sch:assert role="error" id="MetadatenelementVersionStandardVersionModellierungswerkzeugMussBefuelltSein" test="false()">Die Version des Modellierungswerkzeugs, mit dem das XÖV-Fachmodell der Version des Standards erstellt wurde, muss spezifiziert sein (Eigenschaft versionModellierungswerkzeug des Stereotyps xoevVersionStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardKennungMussMitUrnXoevDeBeginnen -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussMitUrnXoevDeBeginnen">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and not(starts-with(xoev:xoevStandard(.)/@kennung, 'urn:xoev-de:'))]">
            <sch:assert role="error" id="MetadatenelementStandardKennungMussMitUrnXoevDeBeginnen" test="false()">Die Kennung des Standards muss mit der Zeichenfolge "urn:xoev-de:" beginnen (Eigenschaft kennung des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardKennungMussStandardEnthalten -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussStandardEnthalten">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and not(contains(xoev:xoevStandard(.)/@kennung, ':standard:'))]">
            <sch:assert role="error" id="MetadatenelementStandardKennungMussStandardEnthalten" test="false()">Die Kennung des Standards muss die Zeichenfolge ":standard:" enthalten (Eigenschaft kennung des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardKennungMussNameTechnischEnthalten -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussNameTechnischEnthalten">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and
                not(contains(xoev:xoevStandard(.)/@kennung,
                lower-case(xoev:xoevStandard(.)/@nameTechnisch)))]">
            <sch:assert role="error" id="MetadatenelementStandardKennungMussNameTechnischEnthalten" test="false()">Die Kennung des Standards (Eigenschaft kennung des Stereotyps xoevStandard) muss den Namen (technisch) des Standards in Kleinschreibung enthalten (Eigenschaft nameTechnisch des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardKennungDarfNichtXoevEnthalten -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungDarfNichtXoevEnthalten">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and contains(replace(xoev:xoevStandard(.)/@kennung, 'urn:xoev-de', ''), 'xoev')]">
            <sch:assert role="error" id="MetadatenelementStandardKennungDarfNichtXoevEnthalten" test="false()">Die Kennung des Standards muss mit der Zeichenfolge "urn:xoev-de:" beginnen, darf die Zeichenfolge "xoev" jedoch an keiner weiteren Stelle enthalten (Eigenschaft kennung des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardKennungDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungDarfNurErlaubteZeichenEnthalten">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and replace(xoev:xoevStandard(.)/@kennung, '[a-z0-9\.\-,:]', '') != '']">
            <sch:assert role="error" id="MetadatenelementStandardKennungDarfNurErlaubteZeichenEnthalten" test="false()">Die Kennung des Standards darf nur die Zeichen "a-z", "0-9", "-", ":" und "." enthalten (Eigenschaft kennung des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementStandardNameTechnischDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameTechnischDarfNurErlaubteZeichenEnthalten">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and replace(xoev:xoevStandard(.)/@nameTechnisch, '[a-zA-Z0-9\.\-,]', '') != '']">
            <sch:assert role="error" id="MetadatenelementStandardNameTechnischDarfNurErlaubteZeichenEnthalten" test="false()">Der Name (technisch) des Standards darf nur die Zeichen "a-z", "A-Z", "0-9", "-" und "." enthalten (Eigenschaft nameTechnisch des Stereotyps xoevStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MetadatenelementVersionStandardVersionDarfNurErlaubteZeichenEnthalten -->
    <sch:pattern id="NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionDarfNurErlaubteZeichenEnthalten">
        <sch:title>NDR-32: Dokumentation der Metadaten des Standards</sch:title>
        <sch:p>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and replace(xoev:xoevVersionStandard(.)/@version, '[a-zA-Z0-9\.\-,]', '') != '']">
            <sch:assert role="error" id="MetadatenelementVersionStandardVersionDarfNurErlaubteZeichenEnthalten" test="false()">Die Version des Standards darf nur die Zeichen "a-z", "A-Z", "0-9", "-", ":" und "." enthalten (Eigenschaft version des Stereotyps xoevVersionStandard).</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PeriodsClassifyTypeAndGlobalElementNames -->
    <sch:pattern id="NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenBenannterTypenUndGlobalerElementeOhneAufeinanderfolgendePunkte">
        <sch:title>NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</sch:title>
        <sch:p>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and contains(@name, '..')] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and contains(@name, '..')]">
            <sch:assert role="warning" id="NamenBenannterTypenUndGlobalerElementeOhneAufeinanderfolgendePunkte" test="false()">Die Namen benannter Datentypen (UML-Klasse mit dem Stereotyp xsdNamedType) und globaler Elemente (UML-Klasse mit dem Stereotyp xsdGlobalElement) sollen keine aufeinanderfolgenden Punkte enthalten. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PeriodsClassifyElementAndAttributesNames -->
    <sch:pattern id="NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenVonElementenUndAttributenOhneAufeinanderfolgendePunkte">
        <sch:title>NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</sch:title>
        <sch:p>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and contains(@name, '..')]">
            <sch:assert role="warning" id="NamenVonElementenUndAttributenOhneAufeinanderfolgendePunkte" test="false()">Die Namen von XML-Elementen (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attributen (UML-Eigenschaften mit dem Stereotyp xsdAttribute) sollen keine aufeinanderfolgenden Punkte enthalten. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PeriodsClassifyCodeListNames -->
    <sch:pattern id="NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenVonCodelistenEnumerationenAlsBenannteTypenOhneAufeinanderfolgendePunkte">
        <sch:title>NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</sch:title>
        <sch:p>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xoevCodeliste(.) and xoev:xsdNamedType(.)) and contains(@name, '..')]">
            <sch:assert role="warning" id="NamenVonCodelistenEnumerationenAlsBenannteTypenOhneAufeinanderfolgendePunkte" test="false()">Die Namen von UML-Enumerationen, die Codelisten und benannte Typen darstellen (UML-Enumeration mit den Stereotypen xoevCodeliste und xsdNamedType) sollen keine aufeinanderfolgenden Punkte enthalten. Die Enumeration <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: EnumerationsAreUsedInContextOfFirstXOEVCodeType -->
    <sch:pattern id="NDR-4-ErlaubteEinbindungsartenFuerCodelisten-CodeDatentypEntsprichtCodeTyp1bis4">
        <sch:title>NDR-4: Erlaubte Einbindungsarten für Codelisten</sch:title>
        <sch:p>Eine Codeliste soll ausschließlich mittels der in Abschnitt 8.5: Nutzung von Codelisten beschriebenen Code-Typen 1 bis 4 in einem XÖV-Standard genutzt werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdCode(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdCode(.)]">
            <sch:assert role="warning" id="CodeDatentypEntsprichtCodeTyp1bis4" test="
                    (ownedAttribute[@name = 'code' and xoev:xsdElement(.) and xoev:upperBound(.) = 1 and xoev:lowerBound(.) = 1] and
                    ownedAttribute[@name = 'listURI' and xoev:xsdAttribute(.) and xoev:upperBound(.) = 1] and
                    ownedAttribute[@name = 'listVersionID' and xoev:xsdAttribute(.) and xoev:upperBound(.) = 1]) and
                    
                    (if (ownedAttribute[@name = 'code' and uml:resolve-type(.)[uml:is-Enumeration(.)]]) then
                        ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and
                        ownedAttribute[@name = 'listVersionID' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true']
                    else
                        (ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and
                        ownedAttribute[@name = 'listVersionID' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true']) or
                        
                        (ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and
                        ownedAttribute[@name = 'listVersionID' and xoev:lowerBound(.) = 1]) or
                        
                        (ownedAttribute[@name = 'listURI' and xoev:lowerBound(.) = 1] and
                        ownedAttribute[@name = 'listVersionID' and xoev:lowerBound(.) = 1]))">Code-Datentypen (UML-Klassen mit dem Stereotyp xsdCode) sollen entsprechend den Code-Typen 1 bis 4 ausgestaltet sein. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Regel.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CharacterRestrictionForTypeAndGlobalElementNames -->
    <sch:pattern id="NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerBenannteTypenUndGlobaleElemente">
        <sch:title>NDR-11: Erlaubte Zeichen für Namen</sch:title>
        <sch:p>Namen von XML-Attributen, XML-Elementen und XML-Typen eines XÖV-Standards sollen nur Buchstaben, Ziffern, Punkte, Unterstriche und Bindestriche enthalten.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and
                replace(@name, '[a-zA-Z0-9\.\-_]', '') != ''] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and
                replace(@name, '[a-zA-Z0-9\.\-_]', '') != '']">
            <sch:assert role="warning" id="NurErlaubteZeichenFuerBenannteTypenUndGlobaleElemente" test="false()">Benannte Typen (UML-Klassen mit dem Stereotyp xsdNamedType) und globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) sollen nur die Zeichen "a-z", "A-Z", "0-9", ".", "_" und "-" enthalten. Die Klasse <sch:value-of select="xgen:model-path(.)"/> verletzt diese Regel.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CharacterRestrictionForElementAndAttributeNames -->
    <sch:pattern id="NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerElementeUndAttribute">
        <sch:title>NDR-11: Erlaubte Zeichen für Namen</sch:title>
        <sch:p>Namen von XML-Attributen, XML-Elementen und XML-Typen eines XÖV-Standards sollen nur Buchstaben, Ziffern, Punkte, Unterstriche und Bindestriche enthalten.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and
                replace(@name, '[a-zA-Z0-9\.\-_]', '') != '']">
            <sch:assert role="warning" id="NurErlaubteZeichenFuerElementeUndAttribute" test="false()">XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) sollen nur die Zeichen "a-z", "A-Z", "0-9", ".", "_" und "-" enthalten. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> verletzt diese Regel.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CharacterRestrictionForCodeListNames -->
    <sch:pattern id="NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerNamenVonCodelistenEnumerationenAlsBenannteTypen">
        <sch:title>NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</sch:title>
        <sch:p>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and xoev:xsdNamedType(.) and
                replace(@name, '[a-zA-Z0-9\.\-_]', '') != '']">
            <sch:assert role="warning" id="NurErlaubteZeichenFuerNamenVonCodelistenEnumerationenAlsBenannteTypen" test="false()">Die Namen von UML-Enumerationen, die Codelisten und benannte Typen darstellen (UML-Enumeration mit den Stereotypen xoevCodeliste und xsdNamedType) sollen nur die Zeichen "a-z", "A-Z", "0-9", ".", "_" und "-" enthalten. Die Enumeration <sch:value-of select="xgen:model-path(.)"/> verletzt diese Vorgabe.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: BasisdatentypenSchemaDefined -->
    <sch:pattern id="NDR-5-DetaillierteStrukturEinesXOEVFachmodells-BasisdatentypenSchemaDefiniert">
        <sch:title>NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(packagedElement[xoev:xsdSchema(.) and @name = 'Basisdatentypen'])]">
            <sch:assert role="information" id="BasisdatentypenSchemaDefiniert" test="false()">Es wird empfohlen, auf der obersten Ebene des XÖV-Fachmodells ein Paket "Basisdatentypen" vorzusehen.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: BaukastenSchemaDefined -->
    <sch:pattern id="NDR-5-DetaillierteStrukturEinesXOEVFachmodells-BaukastenSchemaDefiniert">
        <sch:title>NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(packagedElement[xoev:xsdSchema(.) and @name = 'Baukasten'])]">
            <sch:assert role="information" id="BaukastenSchemaDefiniert" test="false()">Es wird empfohlen, auf der obersten Ebene des XÖV-Fachmodells ein Paket "Baukasten" vorzusehen.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NachrichtenOrFachmodulePackageDefined -->
    <sch:pattern id="NDR-5-DetaillierteStrukturEinesXOEVFachmodells-NachrichtenOderFachmodulePaketDefiniert">
        <sch:title>NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and
                empty(packagedElement[not(xoev:xsdSchema(.)) and (@name = 'Nachrichten' or @name = 'Fachmodule')])]">
            <sch:assert role="information" id="NachrichtenOderFachmodulePaketDefiniert" test="false()">Es wird empfohlen, auf der obersten Ebene des XÖV-Fachmodells ein Paket "Nachrichten" bzw. "Fachmodule" vorzusehen.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: AtLeastOneHauptgruppenSchemaDefined -->
    <sch:pattern id="NDR-5-DetaillierteStrukturEinesXOEVFachmodells-MindestensEinHauptgruppenschema">
        <sch:title>NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/packagedElement
                [not(xoev:xsdSchema(.)) and (@name = 'Nachrichten' or @name = 'Fachmodule')]
                [empty(packagedElement[xoev:xsdSchema(.) and not(@name = 'Nachrichtentypen')])]">
            <sch:assert role="information" id="MindestensEinHauptgruppenschema" test="false()">Es wird empfohlen, im Paket "Nachrichten" bzw. "Fachmodule" mindestens ein Nachrichtenhauptgruppen-Schema vorzusehen.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ExclusivelyHauptgruppenPackagesWithMessages -->
    <sch:pattern id="NDR-5-DetaillierteStrukturEinesXOEVFachmodells-NachrichtenNurInHauptgruppenpaketen">
        <sch:title>NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and
                not(ancestor::packagedElement[xoev:xsdSchema(.)]/parent::packagedElement[@name = 'Nachrichten' or @name = 'Fachmodule']/parent::packagedElement/@xmi:id =
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/@xmi:id)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and
                not(ancestor::packagedElement[xoev:xsdSchema(.)]/parent::packagedElement[@name = 'Nachrichten' or @name = 'Fachmodule']/parent::packagedElement/@xmi:id =
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/@xmi:id)]">
            <sch:assert role="information" id="NachrichtenNurInHauptgruppenpaketen" test="false()">Es wird empfohlen, Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) nur in den Hauptgruppenpaketen unterhalb des Pakets "Nachrichten" bzw. "Fachmodule" zu spezifizieren. Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NoHauptgruppenPackagesWithoutMessages -->
    <sch:pattern id="NDR-5-DetaillierteStrukturEinesXOEVFachmodells-HauptgruppenpaketeNichtOhneNachrichten">
        <sch:title>NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</sch:title>
        <sch:p>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/packagedElement[not(xoev:xsdSchema(.)) and (@name = 'Nachrichten' or @name = 'Fachmodule')]/
                packagedElement[xoev:xsdSchema(.) and not(@name = 'Nachrichtentypen')]
                [empty((descendant::packagedElement | descendant::nestedClassifier)[xoev:xsdMessage(.)])]">
            <sch:assert role="information" id="HauptgruppenpaketeNichtOhneNachrichten" test="false()">Es wird empfohlen, in einer Nachrichtenhauptgruppe mindestens eine Nachricht zu spezifieren (UML-Klasse mit dem Stereotyp xsdMessage). Das Paket <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: NoHauptgruppenPackagesWithoutMessages -->
    <sch:pattern id="NDR-7-XMLWildcardElementeMitNamensraum-AnyElementeMitNamensraum">
        <sch:title>NDR-7: XML-Wildcard-Elemente mit Namensraum</sch:title>
        <sch:p>Für XML-Wildcard-Elemente wird die Angabe eines Namensraums empfohlen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdAnyContents(.) and empty(xoev:xsdAnyContents(.)/@namespace[. != ''])] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdAnyContents(.) and empty(xoev:xsdAnyContents(.)/@namespace[. != ''])]">
            <sch:assert role="information" id="AnyElementeMitNamensraum" test="false()">Es wird empfohlen, für Any-Elemente (UML-Klassen mit dem Stereotyp xsdAnyContents) einen Namensraum zu vergeben (Eigenschaft namespace des Stereotyps xsdAnyContents). Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: TypeNameStartsWithUpperCaseLetter -->
    <sch:pattern id="NDR-15-GroßUndKleinschreibungVonNamen-UpperCamelCaseFuerNamenBenannterTypen">
        <sch:title>NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</sch:title>
        <sch:p>Es wird empfohlen, in Namen von XML-Typen eines XÖV-Standards alle eigenständigen Wörter mit einem Großbuchstaben zu beginnen (Upper Camel Case). In den Namen von XML-Attributen und -Elementen wird eine analoge Schreibweise empfohlen. Hier sollte das erste Zeichen des Namens jedoch ein Kleinbuchstabe sein (Lower Camel Case). Im Falle von Namen globaler XML-Elemente, und damit auch von Nachrichten, wird ebenfalls die Lower Camel Case Schreibweise empfohlen. Nach Klassifikationsmerkmalen in Namen globaler Elemente sollte ebenfalls mit einem Kleinbuchstaben begonnen werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and
                substring(@name, 1, 1) != upper-case(substring(@name, 1, 1))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and
                substring(@name, 1, 1) != upper-case(substring(@name, 1, 1))]">
            <sch:assert role="information" id="UpperCamelCaseFuerNamenBenannterTypen" test="false()">Es wird empfohlen, Namen benannter Typen (UML-Klassen mit dem Stereotyp xsdNamedType) mit einem Großbuchstaben zu beginnen. Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ElementOrAttributeNameStartsWithLowerCaseLetter -->
    <sch:pattern id="NDR-15-GroßUndKleinschreibungVonNamen-LowerCamelCaseFuerNamenVonElementenUndAttributen">
        <sch:title>NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</sch:title>
        <sch:p>Es wird empfohlen, in Namen von XML-Typen eines XÖV-Standards alle eigenständigen Wörter mit einem Großbuchstaben zu beginnen (Upper Camel Case). In den Namen von XML-Attributen und -Elementen wird eine analoge Schreibweise empfohlen. Hier sollte das erste Zeichen des Namens jedoch ein Kleinbuchstabe sein (Lower Camel Case). Im Falle von Namen globaler XML-Elemente, und damit auch von Nachrichten, wird ebenfalls die Lower Camel Case Schreibweise empfohlen. Nach Klassifikationsmerkmalen in Namen globaler Elemente sollte ebenfalls mit einem Kleinbuchstaben begonnen werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and
                substring(@name, 1, 1) != lower-case(substring(@name, 1, 1))]">
            <sch:assert role="information" id="LowerCamelCaseFuerNamenVonElementenUndAttributen" test="false()">Es wird empfohlen, Namen von XML-Elementen (UML-Eigenschaft mit dem Stereotyp xsdElement) und XML-Attributen (UML-Eigenschaft mit dem Stereotyp xsdAttribute) mit einem Kleinbuchstaben zu beginnen. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GlobalElementNameStartsWithLowerCaseLetter -->
    <sch:pattern id="NDR-15-GroßUndKleinschreibungVonNamen-LowerCamelCaseFuerNamenGlobalerElemente">
        <sch:title>NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</sch:title>
        <sch:p>Es wird empfohlen, in Namen von XML-Typen eines XÖV-Standards alle eigenständigen Wörter mit einem Großbuchstaben zu beginnen (Upper Camel Case). In den Namen von XML-Attributen und -Elementen wird eine analoge Schreibweise empfohlen. Hier sollte das erste Zeichen des Namens jedoch ein Kleinbuchstabe sein (Lower Camel Case). Im Falle von Namen globaler XML-Elemente, und damit auch von Nachrichten, wird ebenfalls die Lower Camel Case Schreibweise empfohlen. Nach Klassifikationsmerkmalen in Namen globaler Elemente sollte ebenfalls mit einem Kleinbuchstaben begonnen werden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and
                substring(@name, 1, 1) != lower-case(substring(@name, 1, 1))] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and
                substring(@name, 1, 1) != lower-case(substring(@name, 1, 1))]">
            <sch:assert role="information" id="LowerCamelCaseFuerNamenGlobalerElemente" test="false()">Es wird empfohlen, Namen globaler Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) mit einem Kleinbuchstaben zu beginnen. Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PrefixForMessages -->
    <sch:pattern id="NDR-16-NamensstrukturGlobalerElemente-NachrichtennamenMitPraefix">
        <sch:title>NDR-16: Namensstruktur globaler Elementen</sch:title>
        <sch:p>Für Nachrichtennamen wird empfohlen, den Namen der jeweiligen Nachrichtenhauptgruppe als Präfix voranzustellen. Das Präfix wird mit einem Punkt von dem eigentlichen Namen der Nachricht abgegrenzt.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and count(tokenize(@name, '\.')) lt 2] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and count(tokenize(@name, '\.')) lt 2]">
            <sch:assert role="information" id="NachrichtennamenMitPraefix" test="false()">Es wird empfohlen, Namen von Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) ein mit einem Punkt abgetrenntes Präfix voranzustelen. Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: PrefixForMessagesEqualsSchemaPackageName -->
    <sch:pattern id="NDR-16-NamensstrukturGlobalerElemente-NameNachrichtenpraefixEntsprichtNameSchemapaket">
        <sch:title>NDR-16: Namensstruktur globaler Elementen</sch:title>
        <sch:p>Für Nachrichtennamen wird empfohlen, den Namen der jeweiligen Nachrichtenhauptgruppe als Präfix voranzustellen. Das Präfix wird mit einem Punkt von dem eigentlichen Namen der Nachricht abgegrenzt.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.)]">
            <sch:let name="msg-prefix" value="tokenize(@name, '\.')[1]"/>
            <sch:let name="msg-prefix-norm" value="concat(lower-case(substring($msg-prefix, 1, 1)), substring($msg-prefix, 2, string-length($msg-prefix)))"/>
            <sch:let name="schema-name" value="ancestor::packagedElement[xoev:xsdSchema(.)]/@name"/>
            <sch:let name="schema-name-norm" value="concat(lower-case(substring($schema-name, 1, 1)), substring($schema-name, 2, string-length($schema-name)))"/>
            <sch:assert role="information" id="NameNachrichtenpraefixEntsprichtNameSchemapaket" test="$msg-prefix-norm = $schema-name-norm">Es wird empfohlen, Namen von Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) mit einem Präfix zu versehen, das dem Namen des zugehörigen Hauptgruppenpakets (UML-Paket mit dem Stereotyp xsdSchema) entspricht. (Hinweis: Die Anfangsbuchstaben der UML-Klasse und des UML-Pakets dürfen sich in ihrer Groß- und Kleinschreibung unterscheiden, z. B. "hamsterzuchtregister.hamstergeburtsmeldung.0101" und "Hamsterzuchtregister"). Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MessagesWithNumericalSuffix -->
    <sch:pattern id="NDR-17-VersionsuebergreifendEindeutigeNachrichtennummern-NachrichtennameMitNumerischemSuffix">
        <sch:title>NDR-17: Versionsübergreifend eindeutige Nachrichtennummern</sch:title>
        <sch:p>Es wird empfohlen, Nachrichten im Kontext eines XÖV-Standards versionsübergreifend eindeutige Nummern als Namenssuffix zuzuweisen. Das Suffix wird mit einem Punkt abgegrenzt. Darüber hinaus wird empfohlen, ungültig gewordene Nachrichtennummern nicht im Kontext neuer Nachrichten wiederzuverwenden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and replace(tokenize(@name, '\.')[last()], '[0-9]', '') != ''] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and replace(tokenize(@name, '\.')[last()], '[0-9]', '') != '']">
            <sch:assert role="information" id="NachrichtennameMitNumerischemSuffix" test="false()">Es wird empfohlen, Namen von Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) mit einem Suffix zu versehen, das die Nachrichtennummer repräsentiert, also ausschließlich aus Ziffern besteht. Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: MessageSuffixUnique -->
    <sch:pattern id="NDR-17-VersionsuebergreifendEindeutigeNachrichtennummern-NachrichtennummerEindeutig">
        <sch:title>NDR-17: Versionsübergreifend eindeutige Nachrichtennummern</sch:title>
        <sch:p>Es wird empfohlen, Nachrichten im Kontext eines XÖV-Standards versionsübergreifend eindeutige Nummern als Namenssuffix zuzuweisen. Das Suffix wird mit einem Punkt abgegrenzt. Darüber hinaus wird empfohlen, ungültig gewordene Nachrichtennummern nicht im Kontext neuer Nachrichten wiederzuverwenden.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and
                (some $m in
                ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[@xmi:id != current()/@xmi:id and
                xoev:xsdMessage(.) and xoev:getNamespace(.) = current()/xoev:getNamespace(.)]
                    satisfies tokenize($m/@name, '\.')[last()] = tokenize(@name, '\.')[last()])] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and
                (some $m in
                ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[@xmi:id != current()/@xmi:id and
                xoev:xsdMessage(.) and xoev:getNamespace(.) = current()/xoev:getNamespace(.)]
                    satisfies tokenize($m/@name, '\.')[last()] = tokenize(@name, '\.')[last()])]">
            <sch:assert role="information" id="NachrichtennummerEindeutig" test="false()">Es wird empfohlen, eindeutige Nachrichtennummern zu vergeben (Namenssuffix von UML-Klassen mit dem Stereotyp xsdMessage). Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaFileNameIncludesStandardName -->
    <sch:pattern id="NDR-18-NamenVonXMLSchemaDateien-NameSchemadateiEnthaeltNameModellpaket">
        <sch:title>NDR-18: Namen von XML Schema-Dateien</sch:title>
        <sch:p>Es wird empfohlen, den Namen des betroffenen XÖV-Standards in den Namen seiner XML Schema-Dateien aufzuführen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and
                not(contains(lower-case(xoev:xsdSchema(.)/@schemaFile), lower-case(ancestor::packagedElement[xoev:xoevStandard(.)]/@name)))]">
            <sch:assert role="information" id="NameSchemadateiEnthaeltNameModellpaket" test="false()">Es wird empfohlen, im Namen einer Schema-Datei (Eigenschaft schemaFile des Stereotyps xsdSchema) den Namen des Modellpakets (UML-Modell annotiert mit dem Stereotyp xsdXModel(.)) aufzuführen. Das Paket <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: SchemaLocationIncludesStandardName -->
    <sch:pattern id="NDR-18-NamenVonXMLSchemaDateien-SchemaLocationEnthaeltNameTechnischDesStandards">
        <sch:title>NDR-18: Namen von XML Schema-Dateien</sch:title>
        <sch:p>Es wird empfohlen, den Namen des betroffenen XÖV-Standards in den Namen seiner XML Schema-Dateien aufzuführen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and
                not(contains(
                lower-case((xoev:xsdSchema(.)/@schemaLocation[. != ''],
                concat(ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase, xoev:xsdSchema(.)/@schemaFile))[1]),
                lower-case(ancestor::packagedElement/xoev:xoevStandard(.)/@nameTechnisch)))]">
            <sch:assert role="information" id="SchemaLocationEnthaeltNameTechnischDesStandards" test="false()">Es wird empfohlen, in der Schema Location (Eigenschaft schemaLocation des Stereotyps xsdSchema bzw. Eigenschaft schemaLocationBase des Stereotyps xsdXModel in Verbindung mit der Eigenschacht schemaFile des Stereotyps xsdSchema) eines Schema-Pakets (UML-Klasse mit dem Stereotyp xsdSchema) den technischen Namen des Standards aufzuführen (Eigenschaft nameTechnisch des Stereotyps xoevStandard). Das Paket <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: LegalBasisDocumentedForMessages -->
    <sch:pattern id="NDR-20-DokumentationDerRechtsgrundlagen-RechtsgrundlageFuerNachrichtenDokumentiert">
        <sch:title>NDR-20: Dokumentation der Rechtsgrundlagen</sch:title>
        <sch:p>Für die Nachrichten eines XÖV-Standards wird empfohlen, ihre rechtliche Grundlagen innerhalb des Standards zu dokumentieren.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and empty(xoev:xsdMessage(.)/rechtsgrundlagen)] |
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifer[xoev:xsdMessage(.) and empty(xoev:xsdMessage(.)/rechtsgrundlagen)]">
            <sch:assert role="information" id="RechtsgrundlageFuerNachrichtenDokumentiert" test="false()">Es wird empfohlen, für Nachrichten die jeweiligen Rechtsgrundlagen zu dokumentieren (Eigenschaft rechtsgrundlagen des Stereotyps xsdMessage). Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: CodeNamesDefined -->
    <sch:pattern id="NDR-21-CodenamenFuerCodesEinerCodeliste-BeschreibungEinesCodesSpezifiziert">
        <sch:title>NDR-21: Codenamen für Codes einer Codeliste</sch:title>
        <sch:p>Es wird empfohlen, allen Codes einer Codeliste eine Beschreibung ihrer Bedeutung zuzuweisen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedLiteral[xoev:xoevCodelisteneintrag(.) and
                empty(xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte[. != ''])]">
            <sch:assert role="information" id="BeschreibungEinesCodesSpezifiziert" test="false()">Es wird empfohlen, zu jedem Code einer Codeliste eine Beschreibung zu spezifizieren (Eigenschaft wertErsteBeschreibungsspalte des Stereotyps xoevCodelisteneintrag). Die Klasse <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: ImportPrefixEqualsImportedSchema -->
    <sch:pattern id="NDR-27-VerwendungDesUrspruenglichenNamensraumpraefixesBeiXMLSchemaImporten-ImportPraefixAusImportiertemSchemaUebernommen">
        <sch:title>NDR-27: Verwendung des ursprünglichen Namensraumpräfixes bei XML Schema-Importen</sch:title>
        <sch:p>Es wird empfohlen, die Bestandteile einer importierten XML Schema-Definition über genau den Namensraumpräfix anzusprechen, der in der importierten XML Schema-Definition genutzt wird.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdImport(.) and xoev:xsdImport(.)/@prefix]">
            <sch:assert role="information" id="ImportPraefixAusImportiertemSchemaUebernommen" test="false()">Es wird empfohlen, bei einem XML-Import (UML-Abhängigkeit mit dem Stereotyp xsdImport) das Namensraumpräfix des importierten Schemas zu nutzen und das Präfix in der Import-Beziehung (Eigenschaft prefix des Stereotyps xsdImport) nicht zu spezifizieren. <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: RefsShouldBeUnnamed -->
    <sch:pattern id="NDR-6-NutzungVonXMLAttributenUndXMLElementen-ElementreferenzenUnbenannt">
        <sch:title>NDR-6: Nutzung von XML-Attributen und XML-Elementen</sch:title>
        <sch:p>Es wird empfohlen, fachliche Inhalte eines XÖV-Standards mit Hilfe von XML-Elementen zu modellieren, technische bzw. erläuternde Metadaten dagegen mit der Hilfe von XML-Attributen.</sch:p>
        <sch:rule context="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.)/@isRef = 'true' and @name[. != '']]">
            <sch:assert role="information" id="ElementreferenzenUnbenannt" test="false()">Es wird empfohlen, bei der Referenzierung eines globalen Elements (Eigenschaft isRef des Stereotyps xsdElement) der UML-Eigenschaft keinen Namen zu geben, da dieser irrelevant für die XML Schema-Definition ist. Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GlobalElementAttributesShouldBeRefs -->
    <sch:pattern id="NDR-6-NutzungVonXMLAttributenUndXMLElementen-KlasseineigenschaftenMitGlobalenElementenAlsTypSindReferenzen">
        <sch:title>NDR-6: Nutzung von XML-Attributen und XML-Elementen</sch:title>
        <sch:p>Es wird empfohlen, fachliche Inhalte eines XÖV-Standards mit Hilfe von XML-Elementen zu modellieren, technische bzw. erläuternde Metadaten dagegen mit der Hilfe von XML-Attributen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and uml:resolve-type(.)/xoev:xsdGlobalElement(.) and
                not(xoev:xsdElement(.)/@isRef = 'true')]">
            <sch:assert role="information" id="KlasseineigenschaftenMitGlobalenElementenAlsTypSindReferenzen" test="false()">Es wird empfohlen, bei der Nutzung eines globalen Elements (UML-Klasse mit dem Stereotyps xsdGlobalElement) in einer UML-Eigenschaft, auf dieses zu referenzieren (Eigenschaft isRef des Stereotyps xsdElement). Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

    <!-- Quelle XGen2: GroupAttributesShouldBeRefs -->
    <sch:pattern id="NDR-6-NutzungVonXMLAttributenUndXMLElementen-KlasseineigenschaftenMitGruppenAlsTypSindReferenzen">
        <sch:title>NDR-6: Nutzung von XML-Attributen und XML-Elementen</sch:title>
        <sch:p>Es wird empfohlen, fachliche Inhalte eines XÖV-Standards mit Hilfe von XML-Elementen zu modellieren, technische bzw. erläuternde Metadaten dagegen mit der Hilfe von XML-Attributen.</sch:p>
        <sch:rule context="
                /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and uml:resolve-type(.)/xoev:xsdGroup(.) and
                not(xoev:xsdElement(.)/@isRef = 'true')]">
            <sch:assert role="information" id="KlasseineigenschaftenMitGruppenAlsTypSindReferenzen" test="false()">Es wird empfohlen, bei der Nutzung einer Gruppe (UML-Klasse mit dem Stereotyp xsdGroup) in einer UML-Eigenschaft, auf die Gruppe zu referenzieren (Eigenschaft isRef des Stereotyps xsdElement). Die Eigenschaft <sch:value-of select="xgen:model-path(.)"/> entspricht der Empfehlung nicht.</sch:assert>
        </sch:rule>
    </sch:pattern>

</sch:schema>
