<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<xsl:stylesheet xmlns:xs="http://www.w3.org/2001/XMLSchema"
                xmlns:xsd="http://www.w3.org/2001/XMLSchema"
                xmlns:saxon="http://saxon.sf.net/"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:schold="http://www.ascc.net/xml/schematron"
                xmlns:iso="http://purl.oclc.org/dsdl/schematron"
                xmlns:xhtml="http://www.w3.org/1999/xhtml"
                xmlns:xgen="http://www.xoev.de/de/xgenerator/framework/1/library"
                xmlns:xmi="http://www.omg.org/spec/XMI/20131001"
                xmlns:uml="http://www.eclipse.org/uml2/5.0.0/UML"
                xmlns:xoev="http://www.xoev.de/de/xoev-profil/1_5_1"
                version="2.0"><!--Implementers: please note that overriding process-prolog or process-root is 
    the preferred method for meta-stylesheets to use where possible. -->
   <xsl:param name="archiveDirParameter"/>
   <xsl:param name="archiveNameParameter"/>
   <xsl:param name="fileNameParameter"/>
   <xsl:param name="fileDirParameter"/>
   <xsl:variable name="document-uri">
      <xsl:value-of select="document-uri(/)"/>
   </xsl:variable>
   <!--PHASES-->
   <!--PROLOG-->
   <xsl:output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
               method="xml"
               omit-xml-declaration="no"
               standalone="yes"
               indent="yes"/>
   <!--XSD TYPES FOR XSLT2-->
   <!--KEYS AND FUNCTIONS-->
   <!--DEFAULT RULES-->
   <!--MODE: SCHEMATRON-SELECT-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-select-full-path">
      <xsl:apply-templates select="." mode="schematron-get-full-path-3"/>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-->
   <!--This mode can be used to generate an ugly though full XPath for locators-->
   <xsl:template match="*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">
            <xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>*:</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>[namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:variable name="preceding"
                    select="count(preceding-sibling::*[local-name()=local-name(current())                                   and namespace-uri() = namespace-uri(current())])"/>
      <xsl:text>[</xsl:text>
      <xsl:value-of select="1+ $preceding"/>
      <xsl:text>]</xsl:text>
   </xsl:template>
   <xsl:template match="@*" mode="schematron-get-full-path">
      <xsl:apply-templates select="parent::*" mode="schematron-get-full-path"/>
      <xsl:text>/</xsl:text>
      <xsl:choose>
         <xsl:when test="namespace-uri()=''">@<xsl:value-of select="name()"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:text>@*[local-name()='</xsl:text>
            <xsl:value-of select="local-name()"/>
            <xsl:text>' and namespace-uri()='</xsl:text>
            <xsl:value-of select="namespace-uri()"/>
            <xsl:text>']</xsl:text>
         </xsl:otherwise>
      </xsl:choose>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-2-->
   <!--This mode can be used to generate prefixed XPath for humans-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-2">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="preceding-sibling::*[name(.)=name(current())]">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: SCHEMATRON-FULL-PATH-3-->
   <!--This mode can be used to generate prefixed XPath for humans 
	(Top-level element has index)-->
   <xsl:template match="node() | @*" mode="schematron-get-full-path-3">
      <xsl:for-each select="ancestor-or-self::*">
         <xsl:text>/</xsl:text>
         <xsl:value-of select="name(.)"/>
         <xsl:if test="parent::*">
            <xsl:text>[</xsl:text>
            <xsl:value-of select="count(preceding-sibling::*[name(.)=name(current())])+1"/>
            <xsl:text>]</xsl:text>
         </xsl:if>
      </xsl:for-each>
      <xsl:if test="not(self::*)">
         <xsl:text/>/@<xsl:value-of select="name(.)"/>
      </xsl:if>
   </xsl:template>
   <!--MODE: GENERATE-ID-FROM-PATH -->
   <xsl:template match="/" mode="generate-id-from-path"/>
   <xsl:template match="text()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.text-', 1+count(preceding-sibling::text()), '-')"/>
   </xsl:template>
   <xsl:template match="comment()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.comment-', 1+count(preceding-sibling::comment()), '-')"/>
   </xsl:template>
   <xsl:template match="processing-instruction()" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.processing-instruction-', 1+count(preceding-sibling::processing-instruction()), '-')"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-from-path">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:value-of select="concat('.@', name())"/>
   </xsl:template>
   <xsl:template match="*" mode="generate-id-from-path" priority="-0.5">
      <xsl:apply-templates select="parent::*" mode="generate-id-from-path"/>
      <xsl:text>.</xsl:text>
      <xsl:value-of select="concat('.',name(),'-',1+count(preceding-sibling::*[name()=name(current())]),'-')"/>
   </xsl:template>
   <!--MODE: GENERATE-ID-2 -->
   <xsl:template match="/" mode="generate-id-2">U</xsl:template>
   <xsl:template match="*" mode="generate-id-2" priority="2">
      <xsl:text>U</xsl:text>
      <xsl:number level="multiple" count="*"/>
   </xsl:template>
   <xsl:template match="node()" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>n</xsl:text>
      <xsl:number count="node()"/>
   </xsl:template>
   <xsl:template match="@*" mode="generate-id-2">
      <xsl:text>U.</xsl:text>
      <xsl:number level="multiple" count="*"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="string-length(local-name(.))"/>
      <xsl:text>_</xsl:text>
      <xsl:value-of select="translate(name(),':','.')"/>
   </xsl:template>
   <!--Strip characters-->
   <xsl:template match="text()" priority="-1"/>
   <!--SCHEMA SETUP-->
   <xsl:template match="/">
      <svrl:schematron-output xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                              title="XÖV-Prüfanweisungen"
                              schemaVersion="">
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xgenerator/framework/1/library"
                                             prefix="xgen"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.omg.org/spec/XMI/20131001" prefix="xmi"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.eclipse.org/uml2/5.0.0/UML" prefix="uml"/>
         <svrl:ns-prefix-in-attribute-values uri="http://www.xoev.de/de/xoev-profil/1_5_1" prefix="xoev"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M9"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M10"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-2-HauptstrukturEinesXOEVFachmodells-GenauEinXOEVFachmodellAufObersterModellebene</xsl:attribute>
            <xsl:attribute name="name">NDR-2: Hauptstruktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Das XÖV-Fachmodell eines XÖV-Standards muss auf oberster Ebene einer vordefinierten Struktur folgen, welche die Inhalte des eigenen Standards von externen, in den XÖV-Standard eingebundenen Inhalten unterscheidet.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M11"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-2-HauptstrukturEinesXOEVFachmodells-ExterneModelleImPaketExterneModelle</xsl:attribute>
            <xsl:attribute name="name">NDR-2: Hauptstruktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Das XÖV-Fachmodell eines XÖV-Standards muss auf oberster Ebene einer vordefinierten Struktur folgen, welche die Inhalte des eigenen Standards von externen, in den XÖV-Standard eingebundenen Inhalten unterscheidet.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M12"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-3-NachrichtenSindGlobaleElemente</xsl:attribute>
            <xsl:attribute name="name">NDR-3: Nachrichten als globale Elemente</xsl:attribute>
            <svrl:text>Nachrichten eines XÖV-Standards müssen globale XML-Elemente sein.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M13"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-UnqualifizierteElementeBeiRestriktionUeberMehrereNamensraeume</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M14"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-UnionIstSimpleType</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M15"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-UnionMemberIstSimpleType</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M16"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-UnionMemberIstBenannt</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M17"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-KeysKeyrefsUniquesImportsUndIncludesSchliessenSichGegenseitigAus</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M18"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-BenannteTypenSindKeineGlobalenElemente</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M19"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AttributeElementeUndLokaleStrukturenSchliessenSichGegenseitigAus</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M20"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementenpositionIstNatuerlicheZahlGroesserNull</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M21"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementenpositionIstEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M22"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-NamenVonTypenEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M23"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-NamenVonGlobalenElementenEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M24"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaDefinitionenNichtVerschachtelt</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M25"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenHabenEinenNamen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M26"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenBasistypIstSimpleType</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M27"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenBasistypIstTokenOderAbleitungVonToken</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M28"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementeUndAttributeSindBenannt</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M29"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementnamenSindAufBausteinebeneEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M30"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMitTypHabenKeineEigenenElementeOderAttribute</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M31"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMaximalEinenTyp</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M32"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-TypisierteGlobaleElementeHabenBenanntenTyp</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M33"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementReferenzReferenziertGlobalesElementOderElementgruppe</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M34"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-DateinameEinerXMLSchemaDefinitionIstAngegeben</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M35"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationEinerXMLSchemaDefinitionIstAngegeben</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M36"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ImportsNurZwischenXMLSchemaDefinitionenUnterschiedlicherNamensraeume</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M37"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ImportUndIncludeBeziehungenZyklenfrei</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M38"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-DateinamenVonXMLSchemaDefinitionenEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M39"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationsVonXMLSchemaDefinitionenEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M40"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-InkludierterNamensraumUndInkludiertesPraefixEntsprechenDenenDesInkludierendemSchemas</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M41"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ImportsUndIncludesNurZwischenSchemaPaketen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M42"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-BenannteTypenMuessenNamenHaben</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M43"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenMuessenNamenHaben</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M44"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMuessenNamenHaben</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M45"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenHabenMindestensEinElementOderAttribut</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M46"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenEnthaltenEntwederElementeOderAttribute</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M47"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteKlassenInSchemaPaketen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M48"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteAbhaengigkeitsbeziehungenInSchemaPaketen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M49"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteGeneralisierungenInSchemaPaketen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M50"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteElementeUndAttributeInSchemaPaketen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M51"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M52"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AnyContentsKlassenOhneEigenschaften</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M53"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-EinfacheVererbung</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M54"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionSchraenktEin</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M55"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeOhneStereotypenXsdAnyContentsXsdCodeUndXsdNamedType</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M56"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AnyElementeOhneStereotypenXsdGlobalElementXsdCodeUndXsdChoice</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M57"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ChoiceOhneStereotypenXsdAnyContentsUndXsdCode</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M58"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-CodeDatentypenOhneStereotypenXsdGlobalElementXsdAnyContentsUndXsdChoice</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M59"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeSindKlassenOderEnumerationen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M60"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-KeineTypenImEntwurfGenutzt</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M61"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMitKorrekterElementenreihenfolge</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M62"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFacettenNurBeiSimpleContent</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M63"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFractionDigitsMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M64"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M65"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxExclusiveMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M66"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxInclusiveMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M67"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxLengthMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M68"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinExclusiveMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M69"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinInclusiveMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M70"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinLengthMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M71"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionPatternMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M72"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionTotalDigitsMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M73"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionWhitespaceMitKorrektenW3CDatentypen</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M74"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthIstPositiveGanzeZahl</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M75"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxLengthIstPositiveGanzeZahl</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M76"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionTotalDigitsIstPositiveGanzeZahl</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M77"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFractionDigitsIstPositiveGanzeZahl</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M78"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthSchliesstMaxLengthUndMinLengthAus</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M79"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxExclusiveUndMaxInclusiveSchliessenSichAus</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M80"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinExclusiveUndMinInclusiveSchliessenSichAus</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M81"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionWhitespaceMitKorrektenWerten</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M82"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AttributMitKorrektemTyp</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M83"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementMitKorrektemTyp</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M84"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-ElementUndAttributTypenSichtbar</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M85"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-BasistypenSichtbar</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M86"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-EigenschaftenHabenEinenTyp</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M87"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AttributeMitEinzelnemWert</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M88"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaDateiEndungXsd</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M89"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationEndungXsd</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M90"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-AssoziationImGleichenPaketWieEigenschaft</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M91"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-28-ValideW3CXMLSchemaDefinitionen-KeineMehrfachenXMLIncludes</xsl:attribute>
            <xsl:attribute name="name">NDR-28: Valide W3C XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Alle XML Schema-Definitionen eines XÖV-Standards müssen gültig bezüglich der XML Schema-Spezifikation des W3C sein (siehe http://www.w3.org/2001/XMLSchema).</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M92"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-29-IdentifizierendeNamensraeume-XMLSchemaDefinitionenHabenNamensraum</xsl:attribute>
            <xsl:attribute name="name">NDR-29: Identifizierende Namensräume</xsl:attribute>
            <svrl:text>Alle im Rahmen eines XÖV-Standards definierten globalen XML-Elemente und benannten XML-Typen müssen sich in einem Namensraum befinden, der den betroffenen XÖV-Standard eindeutig identifiziert.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M93"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-29-IdentifizierendeNamensraeume-XMLSchemaDefinitionenHabenPraefix</xsl:attribute>
            <xsl:attribute name="name">NDR-29: Identifizierende Namensräume</xsl:attribute>
            <svrl:text>Alle im Rahmen eines XÖV-Standards definierten globalen XML-Elemente und benannten XML-Typen müssen sich in einem Namensraum befinden, der den betroffenen XÖV-Standard eindeutig identifiziert.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M94"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-30-VersionierungDerXMLSchemaDefinitionen-XMLSchemaDefinitionenSindVersioniert</xsl:attribute>
            <xsl:attribute name="name">NDR-30: Versionierung der XML Schema-Definitionen</xsl:attribute>
            <svrl:text>Jede XML Schema-Definition eines XÖV-Standards muss versioniert sein.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M95"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameLangMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M96"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameKurzMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M97"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameTechnischMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M98"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M99"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardBeschreibungMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M100"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M101"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionXOEVHandbuchMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M102"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionXGeneratorMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M103"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionModellierungswerkzeugMussBefuelltSein</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M104"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussMitUrnXoevDeBeginnen</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M105"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussStandardEnthalten</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M106"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussNameTechnischEnthalten</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M107"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungDarfNichtXoevEnthalten</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M108"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M109"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameTechnischDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M110"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionDarfNurErlaubteZeichenEnthalten</xsl:attribute>
            <xsl:attribute name="name">NDR-32: Dokumentation der Metadaten des Standards</xsl:attribute>
            <svrl:text>Die Metadaten eines XÖV-Standards und seiner Version müssen im XÖV-Fachmodell dokumentiert werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M111"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenBenannterTypenUndGlobalerElementeOhneAufeinanderfolgendePunkte</xsl:attribute>
            <xsl:attribute name="name">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</xsl:attribute>
            <svrl:text>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M112"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenVonElementenUndAttributenOhneAufeinanderfolgendePunkte</xsl:attribute>
            <xsl:attribute name="name">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</xsl:attribute>
            <svrl:text>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M113"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenVonCodelistenEnumerationenAlsBenannteTypenOhneAufeinanderfolgendePunkte</xsl:attribute>
            <xsl:attribute name="name">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</xsl:attribute>
            <svrl:text>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M114"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-4-ErlaubteEinbindungsartenFuerCodelisten-CodeDatentypEntsprichtCodeTyp1bis4</xsl:attribute>
            <xsl:attribute name="name">NDR-4: Erlaubte Einbindungsarten für Codelisten</xsl:attribute>
            <svrl:text>Eine Codeliste soll ausschließlich mittels der in Abschnitt 8.5: Nutzung von Codelisten beschriebenen Code-Typen 1 bis 4 in einem XÖV-Standard genutzt werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M115"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerBenannteTypenUndGlobaleElemente</xsl:attribute>
            <xsl:attribute name="name">NDR-11: Erlaubte Zeichen für Namen</xsl:attribute>
            <svrl:text>Namen von XML-Attributen, XML-Elementen und XML-Typen eines XÖV-Standards sollen nur Buchstaben, Ziffern, Punkte, Unterstriche und Bindestriche enthalten.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M116"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerElementeUndAttribute</xsl:attribute>
            <xsl:attribute name="name">NDR-11: Erlaubte Zeichen für Namen</xsl:attribute>
            <svrl:text>Namen von XML-Attributen, XML-Elementen und XML-Typen eines XÖV-Standards sollen nur Buchstaben, Ziffern, Punkte, Unterstriche und Bindestriche enthalten.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M117"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerNamenVonCodelistenEnumerationenAlsBenannteTypen</xsl:attribute>
            <xsl:attribute name="name">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</xsl:attribute>
            <svrl:text>Zur Abbildung von Klassifikationen in Namen sollen Punkte verwendet werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M118"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-5-DetaillierteStrukturEinesXOEVFachmodells-BasisdatentypenSchemaDefiniert</xsl:attribute>
            <xsl:attribute name="name">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M119"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-5-DetaillierteStrukturEinesXOEVFachmodells-BaukastenSchemaDefiniert</xsl:attribute>
            <xsl:attribute name="name">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M120"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-5-DetaillierteStrukturEinesXOEVFachmodells-NachrichtenOderFachmodulePaketDefiniert</xsl:attribute>
            <xsl:attribute name="name">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M121"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-5-DetaillierteStrukturEinesXOEVFachmodells-MindestensEinHauptgruppenschema</xsl:attribute>
            <xsl:attribute name="name">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M122"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-5-DetaillierteStrukturEinesXOEVFachmodells-NachrichtenNurInHauptgruppenpaketen</xsl:attribute>
            <xsl:attribute name="name">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M123"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-5-DetaillierteStrukturEinesXOEVFachmodells-HauptgruppenpaketeNichtOhneNachrichten</xsl:attribute>
            <xsl:attribute name="name">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</xsl:attribute>
            <svrl:text>Für die inhaltliche Gliederung des XÖV-Fachmodells eines XÖV-Standards wird die Nutzung einer bewährten Struktur empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M124"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-7-XMLWildcardElementeMitNamensraum-AnyElementeMitNamensraum</xsl:attribute>
            <xsl:attribute name="name">NDR-7: XML-Wildcard-Elemente mit Namensraum</xsl:attribute>
            <svrl:text>Für XML-Wildcard-Elemente wird die Angabe eines Namensraums empfohlen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M125"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-15-GroßUndKleinschreibungVonNamen-UpperCamelCaseFuerNamenBenannterTypen</xsl:attribute>
            <xsl:attribute name="name">NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</xsl:attribute>
            <svrl:text>Es wird empfohlen, in Namen von XML-Typen eines XÖV-Standards alle eigenständigen Wörter mit einem Großbuchstaben zu beginnen (Upper Camel Case). In den Namen von XML-Attributen und -Elementen wird eine analoge Schreibweise empfohlen. Hier sollte das erste Zeichen des Namens jedoch ein Kleinbuchstabe sein (Lower Camel Case). Im Falle von Namen globaler XML-Elemente, und damit auch von Nachrichten, wird ebenfalls die Lower Camel Case Schreibweise empfohlen. Nach Klassifikationsmerkmalen in Namen globaler Elemente sollte ebenfalls mit einem Kleinbuchstaben begonnen werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M126"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-15-GroßUndKleinschreibungVonNamen-LowerCamelCaseFuerNamenVonElementenUndAttributen</xsl:attribute>
            <xsl:attribute name="name">NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</xsl:attribute>
            <svrl:text>Es wird empfohlen, in Namen von XML-Typen eines XÖV-Standards alle eigenständigen Wörter mit einem Großbuchstaben zu beginnen (Upper Camel Case). In den Namen von XML-Attributen und -Elementen wird eine analoge Schreibweise empfohlen. Hier sollte das erste Zeichen des Namens jedoch ein Kleinbuchstabe sein (Lower Camel Case). Im Falle von Namen globaler XML-Elemente, und damit auch von Nachrichten, wird ebenfalls die Lower Camel Case Schreibweise empfohlen. Nach Klassifikationsmerkmalen in Namen globaler Elemente sollte ebenfalls mit einem Kleinbuchstaben begonnen werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M127"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-15-GroßUndKleinschreibungVonNamen-LowerCamelCaseFuerNamenGlobalerElemente</xsl:attribute>
            <xsl:attribute name="name">NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</xsl:attribute>
            <svrl:text>Es wird empfohlen, in Namen von XML-Typen eines XÖV-Standards alle eigenständigen Wörter mit einem Großbuchstaben zu beginnen (Upper Camel Case). In den Namen von XML-Attributen und -Elementen wird eine analoge Schreibweise empfohlen. Hier sollte das erste Zeichen des Namens jedoch ein Kleinbuchstabe sein (Lower Camel Case). Im Falle von Namen globaler XML-Elemente, und damit auch von Nachrichten, wird ebenfalls die Lower Camel Case Schreibweise empfohlen. Nach Klassifikationsmerkmalen in Namen globaler Elemente sollte ebenfalls mit einem Kleinbuchstaben begonnen werden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M128"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-16-NamensstrukturGlobalerElemente-NachrichtennamenMitPraefix</xsl:attribute>
            <xsl:attribute name="name">NDR-16: Namensstruktur globaler Elementen</xsl:attribute>
            <svrl:text>Für Nachrichtennamen wird empfohlen, den Namen der jeweiligen Nachrichtenhauptgruppe als Präfix voranzustellen. Das Präfix wird mit einem Punkt von dem eigentlichen Namen der Nachricht abgegrenzt.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M129"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-16-NamensstrukturGlobalerElemente-NameNachrichtenpraefixEntsprichtNameSchemapaket</xsl:attribute>
            <xsl:attribute name="name">NDR-16: Namensstruktur globaler Elementen</xsl:attribute>
            <svrl:text>Für Nachrichtennamen wird empfohlen, den Namen der jeweiligen Nachrichtenhauptgruppe als Präfix voranzustellen. Das Präfix wird mit einem Punkt von dem eigentlichen Namen der Nachricht abgegrenzt.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M130"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-17-VersionsuebergreifendEindeutigeNachrichtennummern-NachrichtennameMitNumerischemSuffix</xsl:attribute>
            <xsl:attribute name="name">NDR-17: Versionsübergreifend eindeutige Nachrichtennummern</xsl:attribute>
            <svrl:text>Es wird empfohlen, Nachrichten im Kontext eines XÖV-Standards versionsübergreifend eindeutige Nummern als Namenssuffix zuzuweisen. Das Suffix wird mit einem Punkt abgegrenzt. Darüber hinaus wird empfohlen, ungültig gewordene Nachrichtennummern nicht im Kontext neuer Nachrichten wiederzuverwenden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M131"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-17-VersionsuebergreifendEindeutigeNachrichtennummern-NachrichtennummerEindeutig</xsl:attribute>
            <xsl:attribute name="name">NDR-17: Versionsübergreifend eindeutige Nachrichtennummern</xsl:attribute>
            <svrl:text>Es wird empfohlen, Nachrichten im Kontext eines XÖV-Standards versionsübergreifend eindeutige Nummern als Namenssuffix zuzuweisen. Das Suffix wird mit einem Punkt abgegrenzt. Darüber hinaus wird empfohlen, ungültig gewordene Nachrichtennummern nicht im Kontext neuer Nachrichten wiederzuverwenden.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M132"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-18-NamenVonXMLSchemaDateien-NameSchemadateiEnthaeltNameModellpaket</xsl:attribute>
            <xsl:attribute name="name">NDR-18: Namen von XML Schema-Dateien</xsl:attribute>
            <svrl:text>Es wird empfohlen, den Namen des betroffenen XÖV-Standards in den Namen seiner XML Schema-Dateien aufzuführen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M133"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-18-NamenVonXMLSchemaDateien-SchemaLocationEnthaeltNameTechnischDesStandards</xsl:attribute>
            <xsl:attribute name="name">NDR-18: Namen von XML Schema-Dateien</xsl:attribute>
            <svrl:text>Es wird empfohlen, den Namen des betroffenen XÖV-Standards in den Namen seiner XML Schema-Dateien aufzuführen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M134"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-20-DokumentationDerRechtsgrundlagen-RechtsgrundlageFuerNachrichtenDokumentiert</xsl:attribute>
            <xsl:attribute name="name">NDR-20: Dokumentation der Rechtsgrundlagen</xsl:attribute>
            <svrl:text>Für die Nachrichten eines XÖV-Standards wird empfohlen, ihre rechtliche Grundlagen innerhalb des Standards zu dokumentieren.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M135"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-21-CodenamenFuerCodesEinerCodeliste-BeschreibungEinesCodesSpezifiziert</xsl:attribute>
            <xsl:attribute name="name">NDR-21: Codenamen für Codes einer Codeliste</xsl:attribute>
            <svrl:text>Es wird empfohlen, allen Codes einer Codeliste eine Beschreibung ihrer Bedeutung zuzuweisen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M136"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-27-VerwendungDesUrspruenglichenNamensraumpraefixesBeiXMLSchemaImporten-ImportPraefixAusImportiertemSchemaUebernommen</xsl:attribute>
            <xsl:attribute name="name">NDR-27: Verwendung des ursprünglichen Namensraumpräfixes bei XML Schema-Importen</xsl:attribute>
            <svrl:text>Es wird empfohlen, die Bestandteile einer importierten XML Schema-Definition über genau den Namensraumpräfix anzusprechen, der in der importierten XML Schema-Definition genutzt wird.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M137"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-6-NutzungVonXMLAttributenUndXMLElementen-ElementreferenzenUnbenannt</xsl:attribute>
            <xsl:attribute name="name">NDR-6: Nutzung von XML-Attributen und XML-Elementen</xsl:attribute>
            <svrl:text>Es wird empfohlen, fachliche Inhalte eines XÖV-Standards mit Hilfe von XML-Elementen zu modellieren, technische bzw. erläuternde Metadaten dagegen mit der Hilfe von XML-Attributen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M138"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-6-NutzungVonXMLAttributenUndXMLElementen-KlasseineigenschaftenMitGlobalenElementenAlsTypSindReferenzen</xsl:attribute>
            <xsl:attribute name="name">NDR-6: Nutzung von XML-Attributen und XML-Elementen</xsl:attribute>
            <svrl:text>Es wird empfohlen, fachliche Inhalte eines XÖV-Standards mit Hilfe von XML-Elementen zu modellieren, technische bzw. erläuternde Metadaten dagegen mit der Hilfe von XML-Attributen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M139"/>
         <svrl:active-pattern>
            <xsl:attribute name="documents">
               <xsl:value-of select="document-uri(/)"/>
            </xsl:attribute>
            <xsl:attribute name="id">NDR-6-NutzungVonXMLAttributenUndXMLElementen-KlasseineigenschaftenMitGruppenAlsTypSindReferenzen</xsl:attribute>
            <xsl:attribute name="name">NDR-6: Nutzung von XML-Attributen und XML-Elementen</xsl:attribute>
            <svrl:text>Es wird empfohlen, fachliche Inhalte eines XÖV-Standards mit Hilfe von XML-Elementen zu modellieren, technische bzw. erläuternde Metadaten dagegen mit der Hilfe von XML-Attributen.</svrl:text>
            <xsl:apply-templates/>
         </svrl:active-pattern>
         <xsl:apply-templates select="/" mode="M140"/>
      </svrl:schematron-output>
   </xsl:template>
   <!--SCHEMATRON PATTERNS-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">XÖV-Prüfanweisungen</svrl:text>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.xgen-core.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xgenerator-library.uml-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.profile-access-layer.xsl"/>
   <xsl:include xmlns:sch="http://purl.oclc.org/dsdl/schematron"
                href="xoev-profil.helpers.xsl"/>
   <!--PATTERN -->
   <!--RULE -->
   <xsl:template match="/" priority="1000" mode="M9">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test=".//@xmi:id"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test=".//@xmi:id">
               <xsl:attribute name="id">id1</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Das Dokument entspricht keiner vom XGenerator verarbeitbaren XMI-Version.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M9"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M9"/>
   <xsl:template match="@*|node()" priority="-2" mode="M9">
      <xsl:apply-templates select="*" mode="M9"/>
   </xsl:template>
   <!--PATTERN -->
   <!--RULE -->
   <xsl:template match="/" priority="1000" mode="M10">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test=".//uml:Model"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test=".//uml:Model">
               <xsl:attribute name="id">id2</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Das Dokument enthält kein Modell in einer vom XGenerator verarbeitbaren UML-Version.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M10"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M10"/>
   <xsl:template match="@*|node()" priority="-2" mode="M10">
      <xsl:apply-templates select="*" mode="M10"/>
   </xsl:template>
   <!--PATTERN NDR-2-HauptstrukturEinesXOEVFachmodells-GenauEinXOEVFachmodellAufObersterModellebeneNDR-2: Hauptstruktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-2: Hauptstruktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model[count(packagedElement[xoev:xsdXModel(.)]) != 1]"
                 priority="1000"
                 mode="M11">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GenauEinXOEVFachmodellAufObersterModellebene</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Auf der obersten Modellebene darf nur das Modell des eigenen Standards (UML-Modell mit dem Stereotyp xsdXModel) vorliegen. Alle weiteren XÖV-Fachmodelle müssen als externe Modelle im Paket "Externe Modelle" vorliegen. Aktuell existieren <xsl:text/>
                  <xsl:value-of select="count(packagedElement[xoev:xsdXModel(.)])"/>
                  <xsl:text/> Modelle auf der obersten Modellebene: <xsl:text/>
                  <xsl:value-of select="packagedElement[xoev:xsdXModel(.)]/@name"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M11"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M11"/>
   <xsl:template match="@*|node()" priority="-2" mode="M11">
      <xsl:apply-templates select="*" mode="M11"/>
   </xsl:template>
   <!--PATTERN NDR-2-HauptstrukturEinesXOEVFachmodells-ExterneModelleImPaketExterneModelleNDR-2: Hauptstruktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-2: Hauptstruktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model" priority="1000" mode="M12">
      <xsl:variable name="models" select="//packagedElement[xoev:xsdXModel(.)]"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     count($models) - count($models[parent::packagedElement/@name = 'Externe Modelle']) = 1"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count($models) - count($models[parent::packagedElement/@name = 'Externe Modelle']) = 1">
               <xsl:attribute name="id">ExterneModelleImPaketExterneModelle</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Externe Modelle (UML-Modelle mit dem Stereotyp xsdXModel, deren Inhalte nicht zum eigenen Standard gehören) müssen im Paket "Externe Modelle" abgelegt werden. Folgende Modelle liegen derzeit außerhalb des Pakets "Externe Modelle" vor: <xsl:text/>
                  <xsl:value-of select="//packagedElement[xoev:xsdXModel(.) and not(parent::packagedElement/@name = 'Externe Modelle')]/@name"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M12"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M12"/>
   <xsl:template match="@*|node()" priority="-2" mode="M12">
      <xsl:apply-templates select="*" mode="M12"/>
   </xsl:template>
   <!--PATTERN NDR-3-NachrichtenSindGlobaleElementeNDR-3: Nachrichten als globale Elemente-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-3: Nachrichten als globale Elemente</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and not(xoev:xsdGlobalElement(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and not(xoev:xsdGlobalElement(.))]"
                 priority="1000"
                 mode="M13">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NachrichtenSindGlobaleElemente</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) eines XÖV-Standards müssen globale XML-Elemente (Stereotyp xsdGlobalElement) sein. Die Nachricht <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Regel.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M13"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M13"/>
   <xsl:template match="@*|node()" priority="-2" mode="M13">
      <xsl:apply-templates select="*" mode="M13"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-UnqualifizierteElementeBeiRestriktionUeberMehrereNamensraeumeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[                 xoev:xsdRestriction(.) and                 not(xoev:getNamespace(parent::*) = xoev:getNamespace(uml:resolve-general(.)))]"
                 priority="1000"
                 mode="M14">
      <xsl:variable name="elem" select="."/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     not(                     ((some $e in parent::*/xoev:elements(.)                         satisfies                         xoev:xsdElement($e)/@form = 'qualified' or (xoev:xsdElement($e)/@form = 'default' and                         (ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'qualified' or                         (ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'default' and                         ancestor::packagedElement/xoev:xsdXModel(.)/@elementFormDefault = 'qualified')))) or                     (some $e in uml:resolve-general(.)/xoev:allElements(.)                         satisfies                         xoev:xsdElement($e)/@form = 'qualified' or (xoev:xsdElement($e)/@form = 'default' and                         (uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'qualified' or                         (uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'default' and                         uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdXModel(.)/@elementFormDefault = 'qualified'))))))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="not( ((some $e in parent::*/xoev:elements(.) satisfies xoev:xsdElement($e)/@form = 'qualified' or (xoev:xsdElement($e)/@form = 'default' and (ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'qualified' or (ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'default' and ancestor::packagedElement/xoev:xsdXModel(.)/@elementFormDefault = 'qualified')))) or (some $e in uml:resolve-general(.)/xoev:allElements(.) satisfies xoev:xsdElement($e)/@form = 'qualified' or (xoev:xsdElement($e)/@form = 'default' and (uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'qualified' or (uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdSchema(.)/@elementFormDefault = 'default' and uml:resolve-general(.)/ancestor::packagedElement/xoev:xsdXModel(.)/@elementFormDefault = 'qualified'))))))">
               <xsl:attribute name="id">UnqualifizierteElementeBeiRestriktionUeberMehrereNamensraeume</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Eine XML-Restriktion (UML-Generalisierung mit dem Stereotyp xsdRestriction) zwischen zwei in unterschiedlichen Namensräumen liegenden Bausteinen erfordert, dass alle XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) der beiden Bausteine unqualifiziert sind (XML-Element-Form ist "unqualified"). Im Falle der Restriktion zwischen den beiden Bausteinen <xsl:text/>
                  <xsl:value-of select="xgen:model-path(parent::*)"/>
                  <xsl:text/> (eingeschränkter Baustein) und <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-general(.))"/>
                  <xsl:text/> (Basis-Baustein) wird diese Vorgabe nicht eingehalten.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M14"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M14"/>
   <xsl:template match="@*|node()" priority="-2" mode="M14">
      <xsl:apply-templates select="*" mode="M14"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-UnionIstSimpleTypeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdUnion(.) and (xoev:allElements(.) or xoev:allAttributes(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdUnion(.) and (xoev:allElements(.) or xoev:allAttributes(.))]"
                 priority="1000"
                 mode="M15">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">UnionIstSimpleType</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Ein Datentyp, der eine XML-Union darstellt (Stereotyp xsdUnion), muss ein einfacher Typ sein. Der Union-Typ <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M15"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M15"/>
   <xsl:template match="@*|node()" priority="-2" mode="M15">
      <xsl:apply-templates select="*" mode="M15"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-UnionMemberIstSimpleTypeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdUnionMember(.) and                 (uml:resolve-supplier(.)[                 not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:allElements(.) or xoev:allAttributes(.)])]"
                 priority="1000"
                 mode="M16">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">UnionMemberIstSimpleType</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Ein Datentyp, der als Member einer XML-Union genutzt wird (Stereotyp xsdUnionMember), muss ein einfacher Datentyp sein. Der Typ <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-supplier(.))"/>
                  <xsl:text/> verletzt diese Vorgabe. Er wird als Member der Union <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-client(.))"/>
                  <xsl:text/> genutzt.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M16"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M16"/>
   <xsl:template match="@*|node()" priority="-2" mode="M16">
      <xsl:apply-templates select="*" mode="M16"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-UnionMemberIstBenanntNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdUnionMember(.) and                 uml:resolve-supplier(.)[not(parent::packagedElement/@name = 'W3C Data Types' or xoev:xsdNamedType(.))]]"
                 priority="1000"
                 mode="M17">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">UnionMemberIstBenannt</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Ein Datentyp, der als Member einer XML-Union genutzt wird (Stereotyp xsdUnionMember), muss ein benannter Datentyp sein. Der Typ <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-supplier(.))"/>
                  <xsl:text/> verletzt diese Vorgabe. Er wird als Member der Union <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-client(.))"/>
                  <xsl:text/> genutzt.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M17"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M17"/>
   <xsl:template match="@*|node()" priority="-2" mode="M17">
      <xsl:apply-templates select="*" mode="M17"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-KeysKeyrefsUniquesImportsUndIncludesSchliessenSichGegenseitigAusNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Dependency(.) and                 count((xoev:xsdImport(.), xoev:xsdInclude(.), xoev:xsdKey(.), xoev:xsdKeyref(.), xoev:xsdUnique(.))) ge 2]"
                 priority="1000"
                 mode="M18">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">KeysKeyrefsUniquesImportsUndIncludesSchliessenSichGegenseitigAus</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Stereotypen xsdKey, xsdKeyref, xsdUnique, xsdInclude und xsdImport schließen sich gegenseitig aus. Die UML-Abhängigkeitsbeziehung zwischen dem Baustein <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-client(.))"/>
                  <xsl:text/> (abhängiger Baustein) und dem Baustein <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-supplier(.))"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M18"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M18"/>
   <xsl:template match="@*|node()" priority="-2" mode="M18">
      <xsl:apply-templates select="*" mode="M18"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-BenannteTypenSindKeineGlobalenElementeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and xoev:xsdGlobalElement(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and xoev:xsdGlobalElement(.)]"
                 priority="1000"
                 mode="M19">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">BenannteTypenSindKeineGlobalenElemente</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Stereotypen xsdNamedType und xsdGlobalElement schließen sich gegenseitig aus. Der Baustein <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M19"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M19"/>
   <xsl:template match="@*|node()" priority="-2" mode="M19">
      <xsl:apply-templates select="*" mode="M19"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AttributeElementeUndLokaleStrukturenSchliessenSichGegenseitigAusNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[count((xoev:xsdLocalStructure(.), xoev:xsdElement(.), xoev:xsdAttribute(.))) ge 2]"
                 priority="1000"
                 mode="M20">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">AttributeElementeUndLokaleStrukturenSchliessenSichGegenseitigAus</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Stereotypen xsdLocalStructure, xsdAttribute und xsdElement schließen sich gegenseitig aus. Die UML-Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M20"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M20"/>
   <xsl:template match="@*|node()" priority="-2" mode="M20">
      <xsl:apply-templates select="*" mode="M20"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementenpositionIstNatuerlicheZahlGroesserNullNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and not(xs:integer(xoev:xsdElement(.)/@position) ge 1)]"
                 priority="1000"
                 mode="M21">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ElementenpositionIstNatuerlicheZahlGroesserNull</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Position eines Elements (Eigenschaft position des Stereotyps xsdElement) muss eine Zahl größer null sein. Die UML-Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M21"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M21"/>
   <xsl:template match="@*|node()" priority="-2" mode="M21">
      <xsl:apply-templates select="*" mode="M21"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementenpositionIstEindeutigNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and                 xoev:elements(parent::*)[@xmi:id != current()/@xmi:id and xoev:xsdElement(.)/@position = current()/xoev:xsdElement(.)/@position]]"
                 priority="1000"
                 mode="M22">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ElementenpositionIstEindeutig</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Position eines Elements (Eigenschaft position des Stereotyps xsdElement) muss innerhalb eines Bausteins (UML-Klasse) eindeutig sein. Die UML-Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> besitzt jedoch dieselbe Position wie die folgenden Eigenschaften: <xsl:text/>
                  <xsl:value-of select="xoev:elements(parent::*)[@xmi:id != current()/@xmi:id and xoev:xsdElement(.)/@position = current()/xoev:xsdElement(.)/@position]/@name"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M22"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M22"/>
   <xsl:template match="@*|node()" priority="-2" mode="M22">
      <xsl:apply-templates select="*" mode="M22"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-NamenVonTypenEindeutigNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and                 ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdNamedType(.) and                 @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and                 ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdNamedType(.) and                 @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]]"
                 priority="1000"
                 mode="M23">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NamenVonTypenEindeutig</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Im gleichen Namensraum dürfen keine benannten Datentypen (UML-Klassen mit dem Stereotyp xsdNamedType) mit dem gleichen Namen existieren. Der Name des Typs <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> ist im Namensraum "<xsl:text/>
                  <xsl:value-of select="xoev:getNamespace(.)"/>
                  <xsl:text/>" nicht eindeutig.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M23"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M23"/>
   <xsl:template match="@*|node()" priority="-2" mode="M23">
      <xsl:apply-templates select="*" mode="M23"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-NamenVonGlobalenElementenEindeutigNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and                 ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdGlobalElement(.) and                 @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and                 ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[xoev:xsdGlobalElement(.) and                 @xmi:id != current()/@xmi:id and xoev:getNamespace(.) = xoev:getNamespace(current()) and @name = current()/@name]]"
                 priority="1000"
                 mode="M24">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NamenVonGlobalenElementenEindeutig</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Im gleichen Namensraum dürfen keine globalen Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) mit dem gleichen Namen existieren. Der Name des globalen Elements <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> ist im Namensraum "<xsl:text/>
                  <xsl:value-of select="xoev:getNamespace(.)"/>
                  <xsl:text/>" nicht eindeutig.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M24"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M24"/>
   <xsl:template match="@*|node()" priority="-2" mode="M24">
      <xsl:apply-templates select="*" mode="M24"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaDefinitionenNichtVerschachteltNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and ancestor::packagedElement[xoev:xsdSchema(.)]]"
                 priority="1000"
                 mode="M25">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">SchemaDefinitionenNichtVerschachtelt</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) dürfen nicht verschachtelt sein. Das XML Schema-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> befindet sich jedoch im XML Schema-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(ancestor::packagedElement[xoev:xsdSchema(.)])"/>
                  <xsl:text/>.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M25"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M25"/>
   <xsl:template match="@*|node()" priority="-2" mode="M25">
      <xsl:apply-templates select="*" mode="M25"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenHabenEinenNamenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and xoev:xsdNamedType(.) and @name = ''] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xoevCodeliste(.) and xoev:xsdNamedType(.) and @name = '']"
                 priority="1000"
                 mode="M26">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">CodelistenHabenEinenNamen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Benannte Codelisten (UML-Enumerationen mit den Stereotypen xoevCodeliste und xsdNamedType) müssen einen Namen (Name der UML-Enumeration) besitzen. Im Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(parent::packagedElement)"/>
                  <xsl:text/> befindet sich jedoch eine Codeliste ohne einen solchen Namen.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M26"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M26"/>
   <xsl:template match="@*|node()" priority="-2" mode="M26">
      <xsl:apply-templates select="*" mode="M26"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenBasistypIstSimpleTypeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdCodeList(.)/xoev:resolve-base(.)[not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:allElements(.) or xoev:allAttributes(.)]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[                 xoev:xsdCodeList(.)/xoev:resolve-base(.)[not(xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types') or xoev:allElements(.) or xoev:allAttributes(.)]]"
                 priority="1000"
                 mode="M27">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">CodelistenBasistypIstSimpleType</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Basistyp einer Codeliste (Eigenschaft base des Stereotyps xsdCodeList) muss ein einfacher Datentyp sein. Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. Der Basistyp der Codeliste ist <xsl:text/>
                  <xsl:value-of select="xoev:xsdCodeList(.)/xoev:resolve-base(.)/xgen:model-path(.)"/>
                  <xsl:text/>.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M27"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M27"/>
   <xsl:template match="@*|node()" priority="-2" mode="M27">
      <xsl:apply-templates select="*" mode="M27"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-CodelistenBasistypIstTokenOderAbleitungVonTokenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdCodeList(.)/xoev:resolve-base(.)[empty((., xoev:allParents(.))[@name = 'token'])]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdCodeList(.)/xoev:resolve-base(.)[empty((., xoev:allParents(.))[@name = 'token'])]]"
                 priority="1000"
                 mode="M28">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">CodelistenBasistypIstTokenOderAbleitungVonToken</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Basistyp einer Codeliste (Eigenschaft des Stereotyps xsdCodeList) muss xs:token oder einem davon abgeleiteten Datentypen entsprechen. Die Codeliste <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. Der Basistyp der Codeliste ist <xsl:text/>
                  <xsl:value-of select="xoev:xsdCodeList(.)/xoev:resolve-base(.)/xgen:model-path(.)"/>
                  <xsl:text/>.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M28"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M28"/>
   <xsl:template match="@*|node()" priority="-2" mode="M28">
      <xsl:apply-templates select="*" mode="M28"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementeUndAttributeSindBenanntNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.)[not(@isRef)] or xoev:xsdAttribute(.)[not(@isRef)]) and @name = '']"
                 priority="1000"
                 mode="M29">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ElementeUndAttributeSindBenannt</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) müssen benannt sein. Ein Element bzw. Attribut in der Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(parent::*)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M29"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M29"/>
   <xsl:template match="@*|node()" priority="-2" mode="M29">
      <xsl:apply-templates select="*" mode="M29"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementnamenSindAufBausteinebeneEindeutigNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[ancestor::packagedElement[xoev:xsdSchema(.)] and uml:is-Class(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[ancestor::packagedElement[xoev:xsdSchema(.)] and uml:is-Class(.)]"
                 priority="1000"
                 mode="M30">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="count(xoev:allElementNamesIncludingRefsAndGroups(.)) = count(distinct-values(xoev:allElementNamesIncludingRefsAndGroups(.)))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count(xoev:allElementNamesIncludingRefsAndGroups(.)) = count(distinct-values(xoev:allElementNamesIncludingRefsAndGroups(.)))">
               <xsl:attribute name="id">ElementnamenSindAufBausteinebeneEindeutig</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die XML-Elemente eines Bausteins (UML-Klasse) müssen eindeutig benannt sein. Hierbei sind auch die Namen referenzierter globaler Elemente und die Namen der Elemente in referenzierten Gruppen zu berücksichtigen. Im Kontext des Bausteins <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> sind die folgenden Namen nicht eindeutig: <xsl:text/>
                  <xsl:value-of select="                         if (xoev:getDuplicateStrings(xoev:allElementNamesIncludingRefsAndGroups(.)) = '') then                             'Elemente ohne Namen'                         else                             xoev:getDuplicateStrings(xoev:allElementNamesIncludingRefsAndGroups(.))"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M30"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M30"/>
   <xsl:template match="@*|node()" priority="-2" mode="M30">
      <xsl:apply-templates select="*" mode="M30"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMitTypHabenKeineEigenenElementeOderAttributeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)] and                 (xoev:allElements(.) or xoev:allAttributes(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifer[xoev:xsdGlobalElement(.) and xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)] and                 (xoev:allElements(.) or xoev:allAttributes(.))]"
                 priority="1000"
                 mode="M31">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GlobaleElementeMitTypHabenKeineEigenenElementeOderAttribute</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Typisierte globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement und einer UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdGlobalElementType) dürfen keine eigenen XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) oder XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) besitzen. Das globale Element <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M31"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M31"/>
   <xsl:template match="@*|node()" priority="-2" mode="M31">
      <xsl:apply-templates select="*" mode="M31"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMaximalEinenTypNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and count(xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]) ge 2] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifer[xoev:xsdGlobalElement(.) and count(xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]) ge 2]"
                 priority="1000"
                 mode="M32">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GlobaleElementeMaximalEinenTyp</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) dürfen nicht mehr als einen Typen zugewiesen bekommen (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdGlobalElementType). Das globale Element <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. Ihm sind die folgenden Typen zugewiesen: <xsl:text/>
                  <xsl:value-of select="xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)/@name"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M32"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M32"/>
   <xsl:template match="@*|node()" priority="-2" mode="M32">
      <xsl:apply-templates select="*" mode="M32"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-TypisierteGlobaleElementeHabenBenanntenTypNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and                 xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)[not(xoev:xsdNamedType(.))]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and                 xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)[not(xoev:xsdNamedType(.))]]"
                 priority="1000"
                 mode="M33">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">TypisierteGlobaleElementeHabenBenanntenTyp</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Typisierte globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement und einer UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdGlobalElementType) müssen einen benannten Typ haben. Das globale Element <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. Ihm ist der folgende Baustein zugewiesen: <xsl:text/>
                  <xsl:value-of select="xoev:dependencies-by-client(.)[xoev:xsdGlobalElementType(.)]/uml:resolve-supplier(.)/@name"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M33"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M33"/>
   <xsl:template match="@*|node()" priority="-2" mode="M33">
      <xsl:apply-templates select="*" mode="M33"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementReferenzReferenziertGlobalesElementOderElementgruppeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.)/@isRef and                 uml:resolve-type(.)[not(xoev:xsdGlobalElement(.) or xoev:xsdGroup(.))]]"
                 priority="1000"
                 mode="M34">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ElementReferenzReferenziertGlobalesElementOderElementgruppe</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Element-Referenzen (UML-Eigenschaften mit Eigenschaft isRef des Stereotyps xsdElement) müssen auf globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) oder Elementgruppen (UML-Klassen mit dem Stereotyp xsdGroup) referenzieren. Das globale Element <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. Ihm ist der folgende Baustein zugewiesen: <xsl:text/>
                  <xsl:value-of select="uml:resolve-type(.)/@name"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M34"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M34"/>
   <xsl:template match="@*|node()" priority="-2" mode="M34">
      <xsl:apply-templates select="*" mode="M34"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-DateinameEinerXMLSchemaDefinitionIstAngegebenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdSchema(.)]"
                 priority="1000"
                 mode="M35">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xsdSchema(.)/@schemaFile[. != '']"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xsdSchema(.)/@schemaFile[. != '']">
               <xsl:attribute name="id">DateinameEinerXMLSchemaDefinitionIstAngegeben</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen einen Dateinamen aufweisen (Eigenschaft schemaFile des Stereotyps xsdSchema). Das Schema-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M35"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M35"/>
   <xsl:template match="@*|node()" priority="-2" mode="M35">
      <xsl:apply-templates select="*" mode="M35"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationEinerXMLSchemaDefinitionIstAngegebenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdSchema(.) and ancestor::packagedElement/xoev:xsdXModel(.)[@deployment = 'true' and not(@schemaLocationBase[. != ''])]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[                 xoev:xsdSchema(.) and ancestor::packagedElement/xoev:xsdXModel(.)[@deployment = 'true' and not(@schemaLocationBase[. != ''])]]"
                 priority="1000"
                 mode="M36">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xsdSchema(.)/@schemaLocation[. != '']"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xsdSchema(.)/@schemaLocation[. != '']">
               <xsl:attribute name="id">SchemaLocationEinerXMLSchemaDefinitionIstAngegeben</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen eine Schema Location aufweisen (Eigenschaft schemaLocation des Stereotyps xsdSchema), sofern keine Schema Location Base für das XÖV-Fachmodell (UML-Modell mit der Eigenschaft schemaLocationBase des Stereotyps xsdXModel) vorliegt. Das Schema-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> besitzt keine Schema Location. Gleichzeitig ist auch keine Schema Location Base spezifiziert.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M36"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M36"/>
   <xsl:template match="@*|node()" priority="-2" mode="M36">
      <xsl:apply-templates select="*" mode="M36"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ImportsNurZwischenXMLSchemaDefinitionenUnterschiedlicherNamensraeumeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdImport(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdImport(.)]"
                 priority="1000"
                 mode="M37">
      <xsl:variable name="client" select="uml:resolve-client(.)"/>
      <xsl:variable name="supplier" select="uml:resolve-supplier(.)"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     not($client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.)) and                     not(($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] =                     (xoev:xsdImport(.)/@prefix, $supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1])"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="not($client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.)) and not(($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] = (xoev:xsdImport(.)/@prefix, $supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1])">
               <xsl:attribute name="id">ImportsNurZwischenXMLSchemaDefinitionenUnterschiedlicherNamensraeume</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Namensräume (spezifiziert an Schema-Paketen mittels der Eigenschaft namespace des Stereotyps xsdSchema oder am XÖV-Fachmodell mittels der Eigenschaft namespace des Stereotyps xsdXModel) und Namensraumpräfixe (spezifiziert an der Import-Beziehung mittels der Eigenschaft prefix des Stereotyps xsdImport, am Schema-Paket mittels der Eigenschaft prefix des Stereotyps xsdSchema oder am XÖV-Fachmodell mittels der Eigenschaft prefix des Stereotyps xsdXModel) zweier XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema), zwischen denen eine XML-Import-Beziehung besteht (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport) müssen sich unterscheiden. Die beiden Schema-Pakete <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-client(.))"/>
                  <xsl:text/> (importierendes Paket) und <xsl:text/>
                  <xsl:value-of select="xgen:model-path(uml:resolve-supplier(.))"/>
                  <xsl:text/> (importiertes Paket) verletzen diese Vorgabe.<xsl:text/>
                  <xsl:value-of select="                         if ($client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.)) then                             concat(' Der Namensraum ist identisch: ', $client/xoev:getNamespace(.), '.')                         else                             ''"/>
                  <xsl:text/>
                  <xsl:text/>
                  <xsl:value-of select="                         if (($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] =                         (xoev:xsdImport(.)/@prefix, $supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]) then                             concat(' Das Präfix ist identisch: ', ($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1], '.')                         else                             ''"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M37"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M37"/>
   <xsl:template match="@*|node()" priority="-2" mode="M37">
      <xsl:apply-templates select="*" mode="M37"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ImportUndIncludeBeziehungenZyklenfreiNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdSchema(.)]"
                 priority="1000"
                 mode="M38">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     empty(                     index-of(                     xoev:allImportedAndIncludedPackageIDs(                     xoev:dependencies-by-client(.)[xoev:xsdImport(.) or xoev:xsdInclude(.)]/uml:resolve-supplier(.)/@xmi:id,                     ancestor::uml:Model),                     @xmi:id))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="empty( index-of( xoev:allImportedAndIncludedPackageIDs( xoev:dependencies-by-client(.)[xoev:xsdImport(.) or xoev:xsdInclude(.)]/uml:resolve-supplier(.)/@xmi:id, ancestor::uml:Model), @xmi:id))">
               <xsl:attribute name="id">ImportUndIncludeBeziehungenZyklenfrei</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Eine XML Schema-Definition (UML-Paket mit dem Stereotyp xsdSchema) darf sich nicht direkt oder indirekt selbst inkludieren oder importieren. Das Schema-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M38"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M38"/>
   <xsl:template match="@*|node()" priority="-2" mode="M38">
      <xsl:apply-templates select="*" mode="M38"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-DateinamenVonXMLSchemaDefinitionenEindeutigNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]"
                 priority="1000"
                 mode="M39">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     count(descendant::packagedElement/xoev:xsdSchema(.)/@schemaFile) =                     count(distinct-values(descendant::packagedElement/xoev:xsdSchema(.)/@schemaFile))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count(descendant::packagedElement/xoev:xsdSchema(.)/@schemaFile) = count(distinct-values(descendant::packagedElement/xoev:xsdSchema(.)/@schemaFile))">
               <xsl:attribute name="id">DateinamenVonXMLSchemaDefinitionenEindeutig</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definition (UML-Pakete mit dem Stereotyp xsdSchema) müssen im XÖV-Fachmodell eindeutige Dateinamen aufweisen (Eigenschaft schemaFile des Sterotyps xsdSchema). Die folgenden Dateinamen werden mehrfach verwendet: <xsl:text/>
                  <xsl:value-of select="                         distinct-values(descendant::packagedElement[xoev:xsdSchema(.) and                         (some $s in current()/descendant::packagedElement[xoev:xsdSchema(.)]                             satisfies $s/@xmi:id != @xmi:id and $s/xoev:xsdSchema(.)/@schemaFile = xoev:xsdSchema(.)/@schemaFile)]/xoev:xsdSchema(.)/@schemaFile)"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M39"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M39"/>
   <xsl:template match="@*|node()" priority="-2" mode="M39">
      <xsl:apply-templates select="*" mode="M39"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationsVonXMLSchemaDefinitionenEindeutigNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]"
                 priority="1000"
                 mode="M40">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     count(descendant::packagedElement/xoev:xsdSchema(.)/@schemaLocation) =                     count(distinct-values(descendant::packagedElement/xoev:xsdSchema(.)/@schemaLocation))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count(descendant::packagedElement/xoev:xsdSchema(.)/@schemaLocation) = count(distinct-values(descendant::packagedElement/xoev:xsdSchema(.)/@schemaLocation))">
               <xsl:attribute name="id">SchemaLocationsVonXMLSchemaDefinitionenEindeutig</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definition (UML-Pakete mit dem Stereotyp xsdSchema) müssen im XÖV-Fachmodell eindeutige Schema Locations aufweisen (Eigenschaft schemaLocation des Stereotyps xsdSchema), sofern solche explizit angegeben wurden. Die folgenden Schema Locations werden mehrfach verwendet: <xsl:text/>
                  <xsl:value-of select="                         distinct-values(descendant::packagedElement[xoev:xsdSchema(.) and                         (some $s in current()/descendant::packagedElement[xoev:xsdSchema(.)]                             satisfies $s/@xmi:id != @xmi:id and $s/xoev:xsdSchema(.)/@schemaLocation = xoev:xsdSchema(.)/@schemaLocation)]/xoev:xsdSchema(.)/@schemaLocation)"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M40"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M40"/>
   <xsl:template match="@*|node()" priority="-2" mode="M40">
      <xsl:apply-templates select="*" mode="M40"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-InkludierterNamensraumUndInkludiertesPraefixEntsprechenDenenDesInkludierendemSchemasNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdInclude(.)]"
                 priority="1000"
                 mode="M41">
      <xsl:variable name="client" select="uml:resolve-client(.)"/>
      <xsl:variable name="supplier" select="uml:resolve-supplier(.)"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     $client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.) and                     ($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] =                     ($supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="$client/xoev:getNamespace(.) = $supplier/xoev:getNamespace(.) and ($client/xoev:xsdSchema(.)/@prefix, $client/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1] = ($supplier/xoev:xsdSchema(.)/@prefix, $supplier/ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[1]">
               <xsl:attribute name="id">InkludierterNamensraumUndInkludiertesPraefixEntsprechenDenenDesInkludierendemSchemas</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Namensraum und das Präfix einer inkludierten XML Schema-Definition müssen denen der inkludierenden XML Schema-Definition entsprechen. Die inkludierende XML Schema-Definition <xsl:text/>
                  <xsl:value-of select="xgen:model-path($client)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M41"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M41"/>
   <xsl:template match="@*|node()" priority="-2" mode="M41">
      <xsl:apply-templates select="*" mode="M41"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ImportsUndIncludesNurZwischenSchemaPaketenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdInclude(.) or xoev:xsdImport(.)]"
                 priority="1000"
                 mode="M42">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="uml:resolve-supplier(.)[xoev:xsdSchema(.)] and uml:resolve-client(.)[xoev:xsdSchema(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="uml:resolve-supplier(.)[xoev:xsdSchema(.)] and uml:resolve-client(.)[xoev:xsdSchema(.)]">
               <xsl:attribute name="id">ImportsUndIncludesNurZwischenSchemaPaketen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Imports (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport) und XML-Includes (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdInclude) müssen zwei XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) verbinden. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M42"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M42"/>
   <xsl:template match="@*|node()" priority="-2" mode="M42">
      <xsl:apply-templates select="*" mode="M42"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-BenannteTypenMuessenNamenHabenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and not(@name[. != ''])]"
                 priority="1000"
                 mode="M43">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">BenannteTypenMuessenNamenHaben</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Benannte Datentypen (UML-Klassen mit dem Stereotyp xsdNamedType) müssen einen Namen besitzen. Im Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> liegt ein Typ ohne Namen vor.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M43"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M43"/>
   <xsl:template match="@*|node()" priority="-2" mode="M43">
      <xsl:apply-templates select="*" mode="M43"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenMuessenNamenHabenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGroup(.) and not(@name[. != ''])]"
                 priority="1000"
                 mode="M44">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GruppenMuessenNamenHaben</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Gruppen (UML-Klassen mit dem Stereotyp xsdGroup) müssen einen Namen besitzen. Im Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> liegt eine solche Gruppe ohne Namen vor.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M44"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M44"/>
   <xsl:template match="@*|node()" priority="-2" mode="M44">
      <xsl:apply-templates select="*" mode="M44"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeMuessenNamenHabenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and not(@name[. != ''])]"
                 priority="1000"
                 mode="M45">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GlobaleElementeMuessenNamenHaben</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Globale Elemente (UML-KLassen mit dem Stereotyp xsdGlobalElement) müssen einen Namen besitzen. Im Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> liegt ein solches globales Element ohne Namen vor.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M45"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M45"/>
   <xsl:template match="@*|node()" priority="-2" mode="M45">
      <xsl:apply-templates select="*" mode="M45"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenHabenMindestensEinElementOderAttributNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGroup(.)]"
                 priority="1000"
                 mode="M46">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:elements(.) or xoev:attributes(.)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:elements(.) or xoev:attributes(.)">
               <xsl:attribute name="id">GruppenHabenMindestensEinElementOderAttribut</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Gruppen (UML-Klassen mit dem Stereotyp xsdGroup) müssen mindestens ein XML-Element oder -Attribut besitzen. Die Gruppe <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> versetzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M46"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M46"/>
   <xsl:template match="@*|node()" priority="-2" mode="M46">
      <xsl:apply-templates select="*" mode="M46"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GruppenEnthaltenEntwederElementeOderAttributeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGroup(.) and xoev:attributes(.) and xoev:elements(.)]"
                 priority="1000"
                 mode="M47">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GruppenEnthaltenEntwederElementeOderAttribute</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Gruppen (UML-Klassen mit dem Stereotyp xsdGroup) besitzen entweder ausschließlich XML-Elemente oder ausschließlich XML-Attribute. Die Gruppe <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M47"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M47"/>
   <xsl:template match="@*|node()" priority="-2" mode="M47">
      <xsl:apply-templates select="*" mode="M47"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteKlassenInSchemaPaketenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdNamedType(.) or xoev:xsdChoice(.) or xoev:xsdCode(.) or xoev:xsdGlobalElement(.) or xoev:xsdAnyContents(.)]"
                 priority="1000"
                 mode="M48">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="ancestor::packagedElement[xoev:xsdSchema(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ancestor::packagedElement[xoev:xsdSchema(.)]">
               <xsl:attribute name="id">AnnotierteKlassenInSchemaPaketen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>UML-Klassen, die mit Stereotypen annotiert sind, müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M48"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M48"/>
   <xsl:template match="@*|node()" priority="-2" mode="M48">
      <xsl:apply-templates select="*" mode="M48"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteAbhaengigkeitsbeziehungenInSchemaPaketenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdInclude(.) or xoev:xsdImport(.) or xoev:xsdKey(.) or xoev:xsdKeyref(.) or xoev:xsdUnique(.)]"
                 priority="1000"
                 mode="M49">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="ancestor::packagedElement[xoev:xsdSchema(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ancestor::packagedElement[xoev:xsdSchema(.)]">
               <xsl:attribute name="id">AnnotierteAbhaengigkeitsbeziehungenInSchemaPaketen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>UML-Abhängigkeitsbeziehungen (Dependencies), die mit Stereotypen annotiert sind, müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M49"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M49"/>
   <xsl:template match="@*|node()" priority="-2" mode="M49">
      <xsl:apply-templates select="*" mode="M49"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteGeneralisierungenInSchemaPaketenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)]"
                 priority="1000"
                 mode="M50">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="ancestor::packagedElement[xoev:xsdSchema(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ancestor::packagedElement[xoev:xsdSchema(.)]">
               <xsl:attribute name="id">AnnotierteGeneralisierungenInSchemaPaketen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>UML-Generalisierungsbeziehungen, die mit Stereotypen annotiert sind, müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M50"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M50"/>
   <xsl:template match="@*|node()" priority="-2" mode="M50">
      <xsl:apply-templates select="*" mode="M50"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AnnotierteElementeUndAttributeInSchemaPaketenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]"
                 priority="1000"
                 mode="M51">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="ancestor::packagedElement[xoev:xsdSchema(.)]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ancestor::packagedElement[xoev:xsdSchema(.)]">
               <xsl:attribute name="id">AnnotierteElementeUndAttributeInSchemaPaketen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Elemente und -Attribute (UML-Eigenschaften mit dem Stereotyp xsdElement oder xsdAttribute) müssen sich direkt oder indirekt in einem Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) befinden. Das <xsl:text/>
                  <xsl:value-of select="                         if (xoev:xsdElement(.)) then                             'Element '                         else                             'Attribut '"/>
                  <xsl:text/>
                  <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M51"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M51"/>
   <xsl:template match="@*|node()" priority="-2" mode="M51">
      <xsl:apply-templates select="*" mode="M51"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and ownedAttribute] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and ownedAttribute]"
                 priority="1000"
                 mode="M52">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="count(ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="count(ownedAttribute[xoev:xsdElement(.) or xoev:xsdAttribute(.) or xoev:xsdLocalStructure(.)]) = count(ownedAttribute)">
               <xsl:attribute name="id">TypenUndGlobaleElementeEnthaltenElementeAttributeOderLokaleStrukturen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>UML-Klassen, die Typen (Stereotyp xsdNamedType) oder globale Elemente (Stereotyp xsdGlobalElement) repräsentieren, besitzen ausschließlich Eigenschaften, die XML-Elemente (Stereotyp xsdElement), XML-Attribute (Stereotyp xsdAttribute) oder lokale XML-Strukturen (Stereotyp xsdLocalStructure) repräsentieren. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M52"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M52"/>
   <xsl:template match="@*|node()" priority="-2" mode="M52">
      <xsl:apply-templates select="*" mode="M52"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AnyContentsKlassenOhneEigenschaftenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdAnyContents(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdAnyContents(.)]"
                 priority="1000"
                 mode="M53">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="empty(ownedAttribute[xoev:xsdElement(.)])"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="empty(ownedAttribute[xoev:xsdElement(.)])">
               <xsl:attribute name="id">AnyContentsKlassenOhneEigenschaften</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>UML-Klassen, die any-Elemente repräsentieren (Stereotyp xsdAnyContents), dürfen keine XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) besitzen. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M53"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M53"/>
   <xsl:template match="@*|node()" priority="-2" mode="M53">
      <xsl:apply-templates select="*" mode="M53"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-EinfacheVererbungNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[uml:is-Class(.) and count(generalization) gt 1] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[uml:is-Class(.) and count(generalization) gt 1]"
                 priority="1000"
                 mode="M54">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">EinfacheVererbung</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Typen und globale Elemente dürfen von maximal einem Basistypen ableiten. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M54"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M54"/>
   <xsl:template match="@*|node()" priority="-2" mode="M54">
      <xsl:apply-templates select="*" mode="M54"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionSchraenktEinNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.) and                 not(uml:resolve-general(.)/ancestor::packagedElement[xoev:xoevAdapter(.)])]"
                 priority="1000"
                 mode="M55">
      <xsl:variable name="restricted" select=".."/>
      <xsl:variable name="base" select="uml:resolve-general(.)"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     (every $p in $restricted/ownedAttribute                         satisfies                         $base/ownedAttribute[@name = $p/@name]/uml:resolve-type(.)[                         @xmi:id = $p/uml:resolve-type(.)/(., xoev:allParents(.))/@xmi:id or                         @name = ('token', 'string', 'normalizedString') and $p/uml:resolve-type(.)[uml:is-Enumeration(.)]]                                                  and                                                  $base/ownedAttribute[@name = $p/@name and xoev:lowerBound($p) ge xoev:lowerBound(.) and                         (xoev:upperBound(.) = -1 or xoev:upperBound($p) != -1 and xoev:upperBound($p) le xoev:upperBound(.))]) and                     ($restricted/xoev:xsdChoice(.) or (every $p in $base/ownedAttribute                         satisfies                         xoev:lowerBound($p) = 0 or $restricted/ownedAttribute[@name = $p/@name]))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="(every $p in $restricted/ownedAttribute satisfies $base/ownedAttribute[@name = $p/@name]/uml:resolve-type(.)[ @xmi:id = $p/uml:resolve-type(.)/(., xoev:allParents(.))/@xmi:id or @name = ('token', 'string', 'normalizedString') and $p/uml:resolve-type(.)[uml:is-Enumeration(.)]] and $base/ownedAttribute[@name = $p/@name and xoev:lowerBound($p) ge xoev:lowerBound(.) and (xoev:upperBound(.) = -1 or xoev:upperBound($p) != -1 and xoev:upperBound($p) le xoev:upperBound(.))]) and ($restricted/xoev:xsdChoice(.) or (every $p in $base/ownedAttribute satisfies xoev:lowerBound($p) = 0 or $restricted/ownedAttribute[@name = $p/@name]))">
               <xsl:attribute name="id">XMLRestriktionSchraenktEin</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Eine per XML-Restriktion (UML-Generalisierung mit dem Stereotyp xsdRestriction) abgeleitete UML-Klasse darf dem Basistyp keine UML-Klasseneigenschaften mehr hinzufügen. Die Eigenschaftstypen müssen gleich den Typen der entpsrechenden Eigenschaften im Basistyp sein bzw. diese einschränken. Ebenso müssen die Multiplizitäten der Eigenschaften gleich bzw. eingeschränkt gegenüber den Multiplizitäten im Basistyp sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M55"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M55"/>
   <xsl:template match="@*|node()" priority="-2" mode="M55">
      <xsl:apply-templates select="*" mode="M55"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeOhneStereotypenXsdAnyContentsXsdCodeUndXsdNamedTypeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and                 (xoev:xsdAnyContents(.), xoev:xsdCode(.), xoev:xsdNamedType(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and                 (xoev:xsdAnyContents(.), xoev:xsdCode(.), xoev:xsdNamedType(.))]"
                 priority="1000"
                 mode="M56">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GlobaleElementeOhneStereotypenXsdAnyContentsXsdCodeUndXsdNamedType</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) dürfen nicht gleichzeitig mit den Stereotypen xsdAnyContents, xsdCode oder xsdNamedType annotiert sein. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M56"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M56"/>
   <xsl:template match="@*|node()" priority="-2" mode="M56">
      <xsl:apply-templates select="*" mode="M56"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AnyElementeOhneStereotypenXsdGlobalElementXsdCodeUndXsdChoiceNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdAnyContents(.) and                 (xoev:xsdGlobalElement(.), xoev:xsdCode(.), xoev:xsdChoice(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdAnyContents(.) and                 (xoev:xsdGlobalElement(.), xoev:xsdCode(.), xoev:xsdChoice(.))]"
                 priority="1000"
                 mode="M57">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">AnyElementeOhneStereotypenXsdGlobalElementXsdCodeUndXsdChoice</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Any-Elemente (UML-Klassen mit dem Stereotyp xsdAnyContents) dürfen nicht gleichzeitig mit den Stereotypen xsdGlobalElement, xsdCode oder xsdChoice annotiert sein. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M57"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M57"/>
   <xsl:template match="@*|node()" priority="-2" mode="M57">
      <xsl:apply-templates select="*" mode="M57"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ChoiceOhneStereotypenXsdAnyContentsUndXsdCodeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdChoice(.) and                 (xoev:xsdAnyContents(.), xoev:xsdCode(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdChoice(.) and                 (xoev:xsdAnyContents(.), xoev:xsdCode(.))]"
                 priority="1000"
                 mode="M58">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ChoiceOhneStereotypenXsdAnyContentsUndXsdCode</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Choices (UML-Klassen mit dem Stereotyp xsdChoice) dürfen nicht gleichzeitig mit den Stereotypen xsdAnyContents oder xsdCode annotiert sein. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M58"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M58"/>
   <xsl:template match="@*|node()" priority="-2" mode="M58">
      <xsl:apply-templates select="*" mode="M58"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-CodeDatentypenOhneStereotypenXsdGlobalElementXsdAnyContentsUndXsdChoiceNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdCode(.) and                 (xoev:xsdGlobalElement(.), xoev:xsdAnyContents(.), xoev:xsdChoice(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdCode(.) and                 (xoev:xsdGlobalElement(.), xoev:xsdAnyContents(.), xoev:xsdChoice(.))]"
                 priority="1000"
                 mode="M59">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">CodeDatentypenOhneStereotypenXsdGlobalElementXsdAnyContentsUndXsdChoice</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Code-Datentypen (UML-Klassen mit dem Stereotyp xsdCode) dürfen nicht gleichzeitig mit den Stereotypen xsdGlobalElement, xsdAnyContents oder xsdChoice annotiert sein. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M59"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M59"/>
   <xsl:template match="@*|node()" priority="-2" mode="M59">
      <xsl:apply-templates select="*" mode="M59"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-GlobaleElementeSindKlassenOderEnumerationenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and not(uml:is-Class(.) or uml:is-Enumeration(.))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and not(uml:is-Class(.) or uml:is-Enumeration(.))]"
                 priority="1000"
                 mode="M60">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">GlobaleElementeSindKlassenOderEnumerationen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Globale Elemente müssen UML-Klassen oder UML-Enumerationen sein. Das UML-Element <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M60"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M60"/>
   <xsl:template match="@*|node()" priority="-2" mode="M60">
      <xsl:apply-templates select="*" mode="M60"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-KeineTypenImEntwurfGenutztNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and                 not((parent::packagedElement | parent::nestedClassifier)/xoev:xsdDraft(.)) and uml:resolve-type(.)/xoev:xsdDraft(.)]"
                 priority="1000"
                 mode="M61">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">KeineTypenImEntwurfGenutzt</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) dürfen keine sich im Entwurf befindenden Typen bzw. Elemente nutzen (UML-Klassen mit dem Stereotyp xsdDraft), sofern sie nicht Teil einer Klasse sind, die sich ebenso im Entwurf befindet. Die UML-Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M61"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M61"/>
   <xsl:template match="@*|node()" priority="-2" mode="M61">
      <xsl:apply-templates select="*" mode="M61"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMitKorrekterElementenreihenfolgeNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.) and not(xoev:xsdAll(.)) and                 not(xoev:allParents(.)/ancestor::packagedElement[xoev:xoevAdapter(.)])] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.) and not(xoev:xsdAll(.)) and                 not(xoev:allParents(.)/ancestor::packagedElement[xoev:xoevAdapter(.)])]"
                 priority="1000"
                 mode="M62">
      <xsl:variable name="class" select="."/>
      <xsl:variable name="basistyp" select="$class/generalization/uml:resolve-general(.)"/>
      <xsl:variable name="elemente-basistyp"
                    select="                     $basistyp/xoev:allElements(.)[(if (xoev:xsdElement(.)/@isRef = 'true') then                         uml:resolve-type(.)/@name                     else                         @name) = $class/xoev:elements(.)/(if (xoev:xsdElement(.)/@isRef = 'true') then                         uml:resolve-type(.)/@name                     else                         @name)]"/>
      <xsl:variable name="elemente-rest" select="$class/xoev:elements(.)"/>
      <!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     every $e in $elemente-rest                         satisfies count($elemente-rest[number(xoev:xsdElement(.)/@position) le number($e/xoev:xsdElement(.)/@position)]) =                         count($elemente-basistyp[xoev:getRealPosition((if (xoev:xsdElement(.)/@isRef = 'true') then                             uml:resolve-type(.)/@name                         else                             @name), $basistyp) le xoev:getRealPosition($e/(if (xoev:xsdElement(.)/@isRef = 'true') then                             uml:resolve-type(.)/@name                         else                             @name), $basistyp)])"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="every $e in $elemente-rest satisfies count($elemente-rest[number(xoev:xsdElement(.)/@position) le number($e/xoev:xsdElement(.)/@position)]) = count($elemente-basistyp[xoev:getRealPosition((if (xoev:xsdElement(.)/@isRef = 'true') then uml:resolve-type(.)/@name else @name), $basistyp) le xoev:getRealPosition($e/(if (xoev:xsdElement(.)/@isRef = 'true') then uml:resolve-type(.)/@name else @name), $basistyp)])">
               <xsl:attribute name="id">XMLRestriktionMitKorrekterElementenreihenfolge</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) müssen in einem per XML-Restriktion (UML-Generalisierung mit dem Stereotyp xsdRestriction) eingeschränkten Datentypen die gleiche Reihenfolge wie die Elemente des Basistyps aufweisen. Die UML-Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe. Elementreihenfolge des Basistyps: <xsl:text/>
                  <xsl:value-of select="xoev:sortAndConcatForXMLRestriktionMitKorrekterElementenreihenfolge($basistyp)"/>
                  <xsl:text/> Elementreihenfolge des eingeschränkten Typs: <xsl:text/>
                  <xsl:value-of select="xoev:sortAndConcatForXMLRestriktionMitKorrekterElementenreihenfolge($class)"/>
                  <xsl:text/>
               </svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M62"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M62"/>
   <xsl:template match="@*|node()" priority="-2" mode="M62">
      <xsl:apply-templates select="*" mode="M62"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFacettenNurBeiSimpleContentNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and                 generalization/xoev:xsdRestriction(.)[@fractionDigits or @length or @totalDigits or @maxExclusive or @maxInclusive or @maxLength or                 @minInclusive or @minInclusive or @minLength or @pattern or                 @whitespace]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and                 generalization/xoev:xsdRestriction(.)[@fractionDigits or @length or @totalDigits or @maxExclusive or                 @maxInclusive or @maxLength or @minInclusive or @minInclusive or @minLength or @pattern or                 @whitespace]]"
                 priority="1000"
                 mode="M63">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     empty(xoev:elements(.)) and empty(generalization/uml:resolve-general(.)/xoev:allElements(.))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="empty(xoev:elements(.)) and empty(generalization/uml:resolve-general(.)/xoev:allElements(.))">
               <xsl:attribute name="id">XMLRestriktionFacettenNurBeiSimpleContent</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Restriction-Facetten (Eigenschaften des Stereotyps xsdRestriction) dürfen ausschließich im Kontext von Datentypen mit einfachem Inhalt genutzt werden. Die UML-Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M63"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M63"/>
   <xsl:template match="@*|node()" priority="-2" mode="M63">
      <xsl:apply-templates select="*" mode="M63"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFractionDigitsMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@fractionDigits]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@fractionDigits]]"
                 priority="1000"
                 mode="M64">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = 'decimal'"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = 'decimal'">
               <xsl:attribute name="id">XMLRestriktionFractionDigitsMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette fractionDigits (Eigenschaft fractionDigits des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:decimal als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M64"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M64"/>
   <xsl:template match="@*|node()" priority="-2" mode="M64">
      <xsl:apply-templates select="*" mode="M64"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@length]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@length]]"
                 priority="1000"
                 mode="M65">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name =                     ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS',                     'normalizedString', 'NOTATION', 'QName', 'string', 'token')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')">
               <xsl:attribute name="id">XMLRestriktionLengthMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette length (Eigenschaft length des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, base64Binary, xs:ENTITIES, xs:ENTITY, xs:hexBinary, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:NOTATION, xs:QName, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M65"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M65"/>
   <xsl:template match="@*|node()" priority="-2" mode="M65">
      <xsl:apply-templates select="*" mode="M65"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxExclusiveMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@maxExclusive]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@maxExclusive]]"
                 priority="1000"
                 mode="M66">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">
               <xsl:attribute name="id">XMLRestriktionMaxExclusiveMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette maxExclusive (Eigenschaft maxExclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M66"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M66"/>
   <xsl:template match="@*|node()" priority="-2" mode="M66">
      <xsl:apply-templates select="*" mode="M66"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxInclusiveMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@maxInclusive]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@maxInclusive]]"
                 priority="1000"
                 mode="M67">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">
               <xsl:attribute name="id">XMLRestriktionMaxInclusiveMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette maxInclusive (Eigenschaft maxInclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M67"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M67"/>
   <xsl:template match="@*|node()" priority="-2" mode="M67">
      <xsl:apply-templates select="*" mode="M67"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxLengthMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@maxLength]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@maxLength]]"
                 priority="1000"
                 mode="M68">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')">
               <xsl:attribute name="id">XMLRestriktionMaxLengthMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette maxLength (Eigenschaft maxLength des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, base64Binary, xs:ENTITIES, xs:ENTITY, xs:hexBinary, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:NOTATION, xs:QName, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M68"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M68"/>
   <xsl:template match="@*|node()" priority="-2" mode="M68">
      <xsl:apply-templates select="*" mode="M68"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinExclusiveMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@minExclusive]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@minExclusive]]"
                 priority="1000"
                 mode="M69">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">
               <xsl:attribute name="id">XMLRestriktionMinExclusiveMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette minExclusive (Eigenschaft minExclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M69"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M69"/>
   <xsl:template match="@*|node()" priority="-2" mode="M69">
      <xsl:apply-templates select="*" mode="M69"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinInclusiveMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@minInclusive]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@minInclusive]]"
                 priority="1000"
                 mode="M70">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'time', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">
               <xsl:attribute name="id">XMLRestriktionMinInclusiveMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette minInclusive (Eigenschaft minInclusive des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:time, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M70"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M70"/>
   <xsl:template match="@*|node()" priority="-2" mode="M70">
      <xsl:apply-templates select="*" mode="M70"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinLengthMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@minLength]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@minLength]]"
                 priority="1000"
                 mode="M71">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'ENTITIES', 'ENTITY', 'hexBinary', 'ID', 'IDREF', 'IDREFS', 'language', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'NOTATION', 'QName', 'string', 'token')">
               <xsl:attribute name="id">XMLRestriktionMinLengthMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette minLength (Eigenschaft minLength des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, base64Binary, xs:ENTITIES, xs:ENTITY, xs:hexBinary, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:NOTATION, xs:QName, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M71"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M71"/>
   <xsl:template match="@*|node()" priority="-2" mode="M71">
      <xsl:apply-templates select="*" mode="M71"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionPatternMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@pattern]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@pattern]]"
                 priority="1000"
                 mode="M72">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'boolean', 'byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'ENTITY', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'hexBinary', 'ID', 'IDREF', 'int', 'integer', 'language', 'long', 'Name', 'NCName', 'negativeInteger', 'NMTOKEN', 'nonNegativeInteger', 'nonPositiveInteger', 'normalizedString', 'NOTATION', 'positiveInteger', 'QName', 'short', 'string', 'time', 'token', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('anyURI', 'base64Binary', 'boolean', 'byte', 'date', 'dateTime', 'decimal', 'double', 'duration', 'ENTITY', 'float', 'gDay', 'gMonth', 'gYear', 'gYearMonth', 'hexBinary', 'ID', 'IDREF', 'int', 'integer', 'language', 'long', 'Name', 'NCName', 'negativeInteger', 'NMTOKEN', 'nonNegativeInteger', 'nonPositiveInteger', 'normalizedString', 'NOTATION', 'positiveInteger', 'QName', 'short', 'string', 'time', 'token', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">
               <xsl:attribute name="id">XMLRestriktionPatternMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette pattern (Eigenschaft pattern des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:anyURI, xs:base64Binary, xs:boolean, xs:byte, xs:date, xs:dateTime, xs:decimal, xs:double, xs:duration, xs:ENTITY, xs:float, xs:gDay, xs:gMonth, xs:gYear, xs:gYearMonth, xs:hexBinary, xs:ID, xs:IDREF, xs:int, xs:integer, xs:language, xs:long, xs:Name, xs:NCName, xs:negativeInteger, xs:NMTOKEN, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:normalizedString, xs:NOTATION, xs:positiveInteger, xs:QName, xs:short, xs:string, xs:time, xs:token, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M72"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M72"/>
   <xsl:template match="@*|node()" priority="-2" mode="M72">
      <xsl:apply-templates select="*" mode="M72"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionTotalDigitsMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@totalDigits]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@totalDigits]]"
                 priority="1000"
                 mode="M73">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'decimal', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('byte', 'decimal', 'int', 'integer', 'long', 'negativeInteger', 'nonNegativeInteger', 'nonPositiveInteger', 'positiveInteger', 'short', 'unsignedByte', 'unsignedInt', 'unsignedLong', 'unsignedShort')">
               <xsl:attribute name="id">XMLRestriktionTotalDigitsMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette totalDigits (Eigenschaft totalDigits des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:byte, xs:decimal, xs:int, xs:integer, xs:long, xs:negativeInteger, xs:nonNegativeInteger, xs:nonPositiveInteger, xs:positiveInteger, xs:short, xs:unsignedByte, xs:unsignedInt, xs:unsignedLong oder xs:unsignedShort als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M73"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M73"/>
   <xsl:template match="@*|node()" priority="-2" mode="M73">
      <xsl:apply-templates select="*" mode="M73"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionWhitespaceMitKorrektenW3CDatentypenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[generalization/xoev:xsdRestriction(.)[@whitespace]] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[generalization/xoev:xsdRestriction(.)[@whitespace]]"
                 priority="1000"
                 mode="M74">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('ENTITIES', 'ENTITY', 'ID', 'IDREF', 'IDREFS', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'string', 'token')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/xoev:topmost-parent(.)/@name = ('ENTITIES', 'ENTITY', 'ID', 'IDREF', 'IDREFS', 'Name', 'NCName', 'NMTOKEN', 'NMTOKENS', 'normalizedString', 'string', 'token')">
               <xsl:attribute name="id">XMLRestriktionWhitespaceMitKorrektenW3CDatentypen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Datentypen, die per XML-Restriction mit der Facette whitespace (Eigenschaft whitespace des Stereotyps xsdRestriction) ableiten, müssen den W3C-Datentyp xs:ENTITIES, xs:ENTITY, xs:ID, xs:IDREF, xs:IDREFS, xs:language, xs:Name, xs:NCName, xs:NMTOKEN, xs:NMTOKENS, xs:normalizedString, xs:string oder xs:token als Basistyp haben. Die UML-Klasse<xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M74"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M74"/>
   <xsl:template match="@*|node()" priority="-2" mode="M74">
      <xsl:apply-templates select="*" mode="M74"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthIstPositiveGanzeZahlNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@length]]"
                 priority="1000"
                 mode="M75">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     replace(xoev:xsdRestriction(.)/@length, '[0-9]+', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xsdRestriction(.)/@length, '[0-9]+', '') = ''">
               <xsl:attribute name="id">XMLRestriktionLengthIstPositiveGanzeZahl</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaft length des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M75"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M75"/>
   <xsl:template match="@*|node()" priority="-2" mode="M75">
      <xsl:apply-templates select="*" mode="M75"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxLengthIstPositiveGanzeZahlNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@maxLength]]"
                 priority="1000"
                 mode="M76">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     replace(xoev:xsdRestriction(.)/@maxLength, '[0-9]+', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xsdRestriction(.)/@maxLength, '[0-9]+', '') = ''">
               <xsl:attribute name="id">XMLRestriktionMaxLengthIstPositiveGanzeZahl</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaft maxLength des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M76"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M76"/>
   <xsl:template match="@*|node()" priority="-2" mode="M76">
      <xsl:apply-templates select="*" mode="M76"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionTotalDigitsIstPositiveGanzeZahlNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@totalDigits]]"
                 priority="1000"
                 mode="M77">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     replace(xoev:xsdRestriction(.)/@totalDigits, '[0-9]+', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xsdRestriction(.)/@totalDigits, '[0-9]+', '') = ''">
               <xsl:attribute name="id">XMLRestriktionTotalDigitsIstPositiveGanzeZahl</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaft totalDigits des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M77"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M77"/>
   <xsl:template match="@*|node()" priority="-2" mode="M77">
      <xsl:apply-templates select="*" mode="M77"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionFractionDigitsIstPositiveGanzeZahlNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@fractionDigits]]"
                 priority="1000"
                 mode="M78">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     replace(xoev:xsdRestriction(.)/@fractionDigits, '[0-9]+', '') = ''"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="replace(xoev:xsdRestriction(.)/@fractionDigits, '[0-9]+', '') = ''">
               <xsl:attribute name="id">XMLRestriktionFractionDigitsIstPositiveGanzeZahl</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaft fractionDigits des Stereotyps xsdRestriction muss eine positive ganze Zahl sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M78"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M78"/>
   <xsl:template match="@*|node()" priority="-2" mode="M78">
      <xsl:apply-templates select="*" mode="M78"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionLengthSchliesstMaxLengthUndMinLengthAusNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@length]]"
                 priority="1000"
                 mode="M79">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     empty(xoev:xsdRestriction(.)/@maxLength) and empty(xoev:xsdRestriction(.)/@minLength)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="empty(xoev:xsdRestriction(.)/@maxLength) and empty(xoev:xsdRestriction(.)/@minLength)">
               <xsl:attribute name="id">XMLRestriktionLengthSchliesstMaxLengthUndMinLengthAus</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaft length des Stereotyps xsdRestriction darf nicht zusammen mit den Eigenschaften maxLength oder minLength angegeben sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M79"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M79"/>
   <xsl:template match="@*|node()" priority="-2" mode="M79">
      <xsl:apply-templates select="*" mode="M79"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMaxExclusiveUndMaxInclusiveSchliessenSichAusNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@maxExclusive and @maxInclusive]]"
                 priority="1000"
                 mode="M80">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">XMLRestriktionMaxExclusiveUndMaxInclusiveSchliessenSichAus</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaften maxExclusive und maxInclusive des Stereotyps xsdRestriction schließen sich gegenseitig aus. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M80"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M80"/>
   <xsl:template match="@*|node()" priority="-2" mode="M80">
      <xsl:apply-templates select="*" mode="M80"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionMinExclusiveUndMinInclusiveSchliessenSichAusNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@minExclusive and @minInclusive]]"
                 priority="1000"
                 mode="M81">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">XMLRestriktionMinExclusiveUndMinInclusiveSchliessenSichAus</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaften minExclusive und minInclusive des Stereotyps xsdRestriction schließen sich gegenseitig aus. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M81"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M81"/>
   <xsl:template match="@*|node()" priority="-2" mode="M81">
      <xsl:apply-templates select="*" mode="M81"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-XMLRestriktionWhitespaceMitKorrektenWertenNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//generalization[xoev:xsdRestriction(.)[@whitespace]]"
                 priority="1000"
                 mode="M82">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="xoev:xsdRestriction(.)/@whitespace = ('preserve', 'replace', 'collapse')"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="xoev:xsdRestriction(.)/@whitespace = ('preserve', 'replace', 'collapse')">
               <xsl:attribute name="id">XMLRestriktionWhitespaceMitKorrektenWerten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Eigenschaft whitespace des Stereotyps xsdRestriction muss den Wert "preserve", "replace" oder "collapse" besitzen. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M82"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M82"/>
   <xsl:template match="@*|node()" priority="-2" mode="M82">
      <xsl:apply-templates select="*" mode="M82"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AttributMitKorrektemTypNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdAttribute(.)[not(@isRef)]]"
                 priority="1000"
                 mode="M83">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     uml:resolve-type(.)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' or                     uml:resolve-type(.)/uml:is-Enumeration(.) or                     uml:resolve-type(.)/xoev:xsdNamedType(.)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="uml:resolve-type(.)/xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types' or uml:resolve-type(.)/uml:is-Enumeration(.) or uml:resolve-type(.)/xoev:xsdNamedType(.)">
               <xsl:attribute name="id">AttributMitKorrektemTyp</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Typ eines XML-Attributs (UML-Eigenschaft mit dem Stereotyp xsdAttribute) muss ein W3C-Datentyp, die Ableitung eines W3C-Datentyps, eine Enumeration oder ein benannter Datentyp sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M83"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M83"/>
   <xsl:template match="@*|node()" priority="-2" mode="M83">
      <xsl:apply-templates select="*" mode="M83"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementMitKorrektemTypNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.)]"
                 priority="1000"
                 mode="M84">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     uml:resolve-type(.)[xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'] or                     uml:resolve-type(.)/uml:is-Enumeration(.) or                     uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdSchema(.)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="uml:resolve-type(.)[xoev:topmost-parent(.)/parent::packagedElement/@name = 'W3C Data Types'] or uml:resolve-type(.)/uml:is-Enumeration(.) or uml:resolve-type(.)/ancestor::packagedElement/xoev:xsdSchema(.)">
               <xsl:attribute name="id">ElementMitKorrektemTyp</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Typ eines XML-Elements (UML-Eigenschaft mit dem Stereotyp xsdElement) muss ein W3C-Datentyp, die Ableitung eines W3C-Datentyps, eine Enumeration oder ein benannter Datentyp sein. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M84"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M84"/>
   <xsl:template match="@*|node()" priority="-2" mode="M84">
      <xsl:apply-templates select="*" mode="M84"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-ElementUndAttributTypenSichtbarNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and $xoev:ist-zyklenfrei]//ownedAttribute[                 xoev:xsdElement(.) and uml:resolve-type(.)/xoev:xsdNamedType(.) and                 ancestor::packagedElement[xoev:xsdSchema(.)]]"
                 priority="1000"
                 mode="M85">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id =                     (ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id,                     xoev:package-with-imports-and-includes(ancestor::packagedElement[xoev:xsdSchema(.)])/(import, include)/@id)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="uml:resolve-type(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id = (ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id, xoev:package-with-imports-and-includes(ancestor::packagedElement[xoev:xsdSchema(.)])/(import, include)/@id)">
               <xsl:attribute name="id">ElementUndAttributTypenSichtbar</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Typ einer UML-Eigenschaft (bzw. die XML Schema-Definition, die den Typ enthält) muss in der XML Schema-Definition, in der die Eigenschaft spezifiziert ist, sichtbar sein, d. h. direkt oder indirekt per XML-Import bzw. -Include (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport bzw. xsdInclude) eingebunden sein. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M85"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M85"/>
   <xsl:template match="@*|node()" priority="-2" mode="M85">
      <xsl:apply-templates select="*" mode="M85"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-BasistypenSichtbarNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and                 $xoev:ist-zyklenfrei]//packagedElement[uml:is-Class(.) and generalization/uml:resolve-general(.)/xoev:xsdNamedType(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and                 $xoev:ist-zyklenfrei]//nestedClassifier[uml:is-Class(.) and generalization/uml:resolve-general(.)/xoev:xsdNamedType(.)]"
                 priority="1000"
                 mode="M86">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     generalization/uml:resolve-general(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id =                     (ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id,                     (if (ancestor::packagedElement[xoev:xsdSchema(.)]) then                         xoev:package-with-imports-and-includes(ancestor::packagedElement[xoev:xsdSchema(.)])                     else                         ())/(import, include)/@id)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="generalization/uml:resolve-general(.)/ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id = (ancestor::packagedElement[xoev:xsdSchema(.)]/@xmi:id, (if (ancestor::packagedElement[xoev:xsdSchema(.)]) then xoev:package-with-imports-and-includes(ancestor::packagedElement[xoev:xsdSchema(.)]) else ())/(import, include)/@id)">
               <xsl:attribute name="id">BasistypenSichtbar</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Basistyp einer UML-Klasse, von dem per UML-Generalisierung abgeleitet wird (bzw. die XML Schema-Definition, die den Typen enthält) muss in der XML Schema-Definition, in der die ableitende Klasse spezifiziert ist, sichtbar sein, d. h. direkt oder indirekt per XML-Import bzw. -Include (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdImport bzw. xsdInclude) eingebunden sein. Die ableitende Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M86"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M86"/>
   <xsl:template match="@*|node()" priority="-2" mode="M86">
      <xsl:apply-templates select="*" mode="M86"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-EigenschaftenHabenEinenTypNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdAttribute(.) or xoev:xsdElement(.)) and empty(uml:resolve-type(.))]"
                 priority="1000"
                 mode="M87">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">EigenschaftenHabenEinenTyp</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Jede UML-Eigenschaft mit dem Stereotyp xsdAttribute oder xsdElement muss einen Typ besitzen. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M87"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M87"/>
   <xsl:template match="@*|node()" priority="-2" mode="M87">
      <xsl:apply-templates select="*" mode="M87"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AttributeMitEinzelnemWertNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdAttribute(.) and (xoev:upperBound(.) gt 1 or xoev:upperBound(.) = -1)]"
                 priority="1000"
                 mode="M88">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">AttributeMitEinzelnemWert</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) müssen die Multiplizität 0..1 oder 1 besitzen. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M88"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M88"/>
   <xsl:template match="@*|node()" priority="-2" mode="M88">
      <xsl:apply-templates select="*" mode="M88"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaDateiEndungXsdNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and                 not(ends-with(xoev:xsdSchema(.)/@schemaFile, lower-case('.xsd')))]"
                 priority="1000"
                 mode="M89">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">SchemaDateiEndungXsd</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Dateinamen von Schema-Paketen (Eigenschaft schemaFile des Stereotyps xsdSchema) müssen "xsd" als Dateiendung beinhalten. Das UML-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M89"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M89"/>
   <xsl:template match="@*|node()" priority="-2" mode="M89">
      <xsl:apply-templates select="*" mode="M89"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-SchemaLocationEndungXsdNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and xoev:xsdSchema(.)/@schemaLocation and                 not(ends-with(xoev:xsdSchema(.)/@schemaLocation, lower-case('.xsd')))]"
                 priority="1000"
                 mode="M90">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">SchemaLocationEndungXsd</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Schema Locations (Eigenschaft schemaLocation des Stereotyps xsdSchema) müssen "xsd" als Dateiendung beinhalten, sofern sie im Kontext eines Schema-Pakets spezifiziert sind. Das UML-Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M90"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M90"/>
   <xsl:template match="@*|node()" priority="-2" mode="M90">
      <xsl:apply-templates select="*" mode="M90"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-AssoziationImGleichenPaketWieEigenschaftNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[uml:resolve-association(.)]"
                 priority="1000"
                 mode="M91">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="                     ancestor::packagedElement[uml:is-Package(.)][1] = uml:resolve-association(.)/ancestor::packagedElement[uml:is-Package(.)][1]"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="ancestor::packagedElement[uml:is-Package(.)][1] = uml:resolve-association(.)/ancestor::packagedElement[uml:is-Package(.)][1]">
               <xsl:attribute name="id">AssoziationImGleichenPaketWieEigenschaft</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, das eine UML-Assoziation (i. d. R. eine Komposition) im selben Paket wie die über die Assoziation spezifizierte Eigenschaft vorliegt. Die Eigenschaft (Assoziationsende) <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> hält diese Empfehlung nicht ein.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M91"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M91"/>
   <xsl:template match="@*|node()" priority="-2" mode="M91">
      <xsl:apply-templates select="*" mode="M91"/>
   </xsl:template>
   <!--PATTERN NDR-28-ValideW3CXMLSchemaDefinitionen-KeineMehrfachenXMLIncludesNDR-28: Valide W3C XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-28: Valide W3C XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and xoev:dependencies-by-client(.)[xoev:xsdInclude(.)]]"
                 priority="1000"
                 mode="M92">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="                     every $d in xoev:dependencies-by-client(.)[xoev:xsdInclude(.)]                         satisfies                         not(xoev:dependencies-by-client(.)[xoev:xsdInclude(.) and @xmi:id != $d/@xmi:id]/uml:resolve-supplier(.)/@xmi:id =                         $d/uml:resolve-supplier(.)/@xmi:id)"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="every $d in xoev:dependencies-by-client(.)[xoev:xsdInclude(.)] satisfies not(xoev:dependencies-by-client(.)[xoev:xsdInclude(.) and @xmi:id != $d/@xmi:id]/uml:resolve-supplier(.)/@xmi:id = $d/uml:resolve-supplier(.)/@xmi:id)">
               <xsl:attribute name="id">KeineMehrfachenXMLIncludes</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Ein Schema-Paket (UML-Paket mit dem Stereotyp xsdSchema) darf ein anderes Schema-Paket nicht mehrfach per XML-Include (UML-Abhängigkeitsbeziehung mit dem Stereotyp xsdInclude) einbinden. Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M92"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M92"/>
   <xsl:template match="@*|node()" priority="-2" mode="M92">
      <xsl:apply-templates select="*" mode="M92"/>
   </xsl:template>
   <!--PATTERN NDR-29-IdentifizierendeNamensraeume-XMLSchemaDefinitionenHabenNamensraumNDR-29: Identifizierende Namensräume-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-29: Identifizierende Namensräume</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and empty(xoev:getNamespace(.)[. != ''])]"
                 priority="1000"
                 mode="M93">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">XMLSchemaDefinitionenHabenNamensraum</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen einen Namensraum besitzen, entweder über die Eigenschaft namespace des Stereotyps xsdSchema oder die Eigenschaft namespace des Stereotyps xsdXModel. Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M93"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M93"/>
   <xsl:template match="@*|node()" priority="-2" mode="M93">
      <xsl:apply-templates select="*" mode="M93"/>
   </xsl:template>
   <!--PATTERN NDR-29-IdentifizierendeNamensraeume-XMLSchemaDefinitionenHabenPraefixNDR-29: Identifizierende Namensräume-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-29: Identifizierende Namensräume</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[                 xoev:xsdSchema(.) and empty((xoev:xsdSchema(.)/@prefix, ancestor::packagedElement/xoev:xsdXModel(.)/@prefix)[. != ''])]"
                 priority="1000"
                 mode="M94">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">XMLSchemaDefinitionenHabenPraefix</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen ein Namensraumpräfix besitzen, entweder über die Eigenschaft prefix des Stereotyps xsdSchema oder die Eigenschaft prefix des Stereotyps xsdXModel. Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M94"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M94"/>
   <xsl:template match="@*|node()" priority="-2" mode="M94">
      <xsl:apply-templates select="*" mode="M94"/>
   </xsl:template>
   <!--PATTERN NDR-30-VersionierungDerXMLSchemaDefinitionen-XMLSchemaDefinitionenSindVersioniertNDR-30: Versionierung der XML Schema-Definitionen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-30: Versionierung der XML Schema-Definitionen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.)                 and empty((xoev:xsdSchema(.)/@version, ancestor::packagedElement/xoev:xoevVersionStandard(.)/@version)[. != ''])]"
                 priority="1000"
                 mode="M95">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">XMLSchemaDefinitionenSindVersioniert</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML Schema-Definitionen (UML-Pakete mit dem Stereotyp xsdSchema) müssen eine Version besitzen, entweder über die Eigenschaft version des Stereotyps xsdSchema oder die Eigenschaft version des Stereotyps xoevVersionStandard. Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M95"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M95"/>
   <xsl:template match="@*|node()" priority="-2" mode="M95">
      <xsl:apply-templates select="*" mode="M95"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameLangMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@nameLang[. != ''])]"
                 priority="1000"
                 mode="M96">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardNameLangMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (lang) eines Standards muss spezifiziert sein (Eigenschaft nameLang des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M96"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M96"/>
   <xsl:template match="@*|node()" priority="-2" mode="M96">
      <xsl:apply-templates select="*" mode="M96"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameKurzMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@nameKurz[. != ''])]"
                 priority="1000"
                 mode="M97">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardNameKurzMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (kurz) eines Standards muss spezifiziert sein (Eigenschaft nameKurz des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M97"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M97"/>
   <xsl:template match="@*|node()" priority="-2" mode="M97">
      <xsl:apply-templates select="*" mode="M97"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameTechnischMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@nameTechnisch[. != ''])]"
                 priority="1000"
                 mode="M98">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardNameTechnischMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (technisch) eines Standards muss spezifiziert sein (Eigenschaft nameTechnisch des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M98"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M98"/>
   <xsl:template match="@*|node()" priority="-2" mode="M98">
      <xsl:apply-templates select="*" mode="M98"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@kennung[. != ''])]"
                 priority="1000"
                 mode="M99">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardKennungMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung eines Standards muss spezifiziert sein (Eigenschaft kennung des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M99"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M99"/>
   <xsl:template match="@*|node()" priority="-2" mode="M99">
      <xsl:apply-templates select="*" mode="M99"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardBeschreibungMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevStandard(.)/@beschreibung[. != ''])]"
                 priority="1000"
                 mode="M100">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardBeschreibungMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Beschreibung eines Standards muss vorliegen (Eigenschaft beschreibung des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M100"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M100"/>
   <xsl:template match="@*|node()" priority="-2" mode="M100">
      <xsl:apply-templates select="*" mode="M100"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@version[. != ''])]"
                 priority="1000"
                 mode="M101">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementVersionStandardVersionMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version eines Standards muss spezifiziert sein (Eigenschaft version des Stereotyps xoevVersionStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M101"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M101"/>
   <xsl:template match="@*|node()" priority="-2" mode="M101">
      <xsl:apply-templates select="*" mode="M101"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionXOEVHandbuchMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@versionXOEVHandbuch[. != ''])]"
                 priority="1000"
                 mode="M102">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementVersionStandardVersionXOEVHandbuchMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version des XÖV-Handbuchs, zu dessen Regelungen die Version des Standards konform ist, muss spezifiziert sein (Eigenschaft versionXOEVHandbuch des Stereotyps xoevVersionStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M102"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M102"/>
   <xsl:template match="@*|node()" priority="-2" mode="M102">
      <xsl:apply-templates select="*" mode="M102"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionXGeneratorMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@versionXGenerator[. != ''])]"
                 priority="1000"
                 mode="M103">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementVersionStandardVersionXGeneratorMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version des XGenerators, mit dem das XÖV-Fachmodell der Version des Standards verarbeitet und die Bestandteile der Version des Standards erzeugt wurden, muss spezifiziert sein (Eigenschaft versionXGenerator des Stereotyps xoevVersionStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M103"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M103"/>
   <xsl:template match="@*|node()" priority="-2" mode="M103">
      <xsl:apply-templates select="*" mode="M103"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionModellierungswerkzeugMussBefuelltSeinNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(xoev:xoevVersionStandard(.)/@versionModellierungswerkzeug[. != ''])]"
                 priority="1000"
                 mode="M104">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementVersionStandardVersionModellierungswerkzeugMussBefuelltSein</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version des Modellierungswerkzeugs, mit dem das XÖV-Fachmodell der Version des Standards erstellt wurde, muss spezifiziert sein (Eigenschaft versionModellierungswerkzeug des Stereotyps xoevVersionStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M104"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M104"/>
   <xsl:template match="@*|node()" priority="-2" mode="M104">
      <xsl:apply-templates select="*" mode="M104"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussMitUrnXoevDeBeginnenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and not(starts-with(xoev:xoevStandard(.)/@kennung, 'urn:xoev-de:'))]"
                 priority="1000"
                 mode="M105">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardKennungMussMitUrnXoevDeBeginnen</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung des Standards muss mit der Zeichenfolge "urn:xoev-de:" beginnen (Eigenschaft kennung des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M105"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M105"/>
   <xsl:template match="@*|node()" priority="-2" mode="M105">
      <xsl:apply-templates select="*" mode="M105"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussStandardEnthaltenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and not(contains(xoev:xoevStandard(.)/@kennung, ':standard:'))]"
                 priority="1000"
                 mode="M106">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardKennungMussStandardEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung des Standards muss die Zeichenfolge ":standard:" enthalten (Eigenschaft kennung des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M106"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M106"/>
   <xsl:template match="@*|node()" priority="-2" mode="M106">
      <xsl:apply-templates select="*" mode="M106"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungMussNameTechnischEnthaltenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and                 not(contains(xoev:xoevStandard(.)/@kennung,                 lower-case(xoev:xoevStandard(.)/@nameTechnisch)))]"
                 priority="1000"
                 mode="M107">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardKennungMussNameTechnischEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung des Standards (Eigenschaft kennung des Stereotyps xoevStandard) muss den Namen (technisch) des Standards in Kleinschreibung enthalten (Eigenschaft nameTechnisch des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M107"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M107"/>
   <xsl:template match="@*|node()" priority="-2" mode="M107">
      <xsl:apply-templates select="*" mode="M107"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungDarfNichtXoevEnthaltenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and contains(replace(xoev:xoevStandard(.)/@kennung, 'urn:xoev-de', ''), 'xoev')]"
                 priority="1000"
                 mode="M108">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardKennungDarfNichtXoevEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung des Standards muss mit der Zeichenfolge "urn:xoev-de:" beginnen, darf die Zeichenfolge "xoev" jedoch an keiner weiteren Stelle enthalten (Eigenschaft kennung des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M108"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M108"/>
   <xsl:template match="@*|node()" priority="-2" mode="M108">
      <xsl:apply-templates select="*" mode="M108"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardKennungDarfNurErlaubteZeichenEnthaltenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and replace(xoev:xoevStandard(.)/@kennung, '[a-z0-9\.\-,:]', '') != '']"
                 priority="1000"
                 mode="M109">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardKennungDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Kennung des Standards darf nur die Zeichen "a-z", "0-9", "-", ":" und "." enthalten (Eigenschaft kennung des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M109"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M109"/>
   <xsl:template match="@*|node()" priority="-2" mode="M109">
      <xsl:apply-templates select="*" mode="M109"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementStandardNameTechnischDarfNurErlaubteZeichenEnthaltenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and replace(xoev:xoevStandard(.)/@nameTechnisch, '[a-zA-Z0-9\.\-,]', '') != '']"
                 priority="1000"
                 mode="M110">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementStandardNameTechnischDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Der Name (technisch) des Standards darf nur die Zeichen "a-z", "A-Z", "0-9", "-" und "." enthalten (Eigenschaft nameTechnisch des Stereotyps xoevStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M110"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M110"/>
   <xsl:template match="@*|node()" priority="-2" mode="M110">
      <xsl:apply-templates select="*" mode="M110"/>
   </xsl:template>
   <!--PATTERN NDR-32-DokumentationDerMetadatenDesStandards-MetadatenelementVersionStandardVersionDarfNurErlaubteZeichenEnthaltenNDR-32: Dokumentation der Metadaten des Standards-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-32: Dokumentation der Metadaten des Standards</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and replace(xoev:xoevVersionStandard(.)/@version, '[a-zA-Z0-9\.\-,]', '') != '']"
                 priority="1000"
                 mode="M111">

		<!--ASSERT error-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MetadatenelementVersionStandardVersionDarfNurErlaubteZeichenEnthalten</xsl:attribute>
               <xsl:attribute name="role">error</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Version des Standards darf nur die Zeichen "a-z", "A-Z", "0-9", "-", ":" und "." enthalten (Eigenschaft version des Stereotyps xoevVersionStandard).</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M111"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M111"/>
   <xsl:template match="@*|node()" priority="-2" mode="M111">
      <xsl:apply-templates select="*" mode="M111"/>
   </xsl:template>
   <!--PATTERN NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenBenannterTypenUndGlobalerElementeOhneAufeinanderfolgendePunkteNDR-12: Erlaubte Zeichen für Klassifikationen in Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and contains(@name, '..')] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and contains(@name, '..')]"
                 priority="1000"
                 mode="M112">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NamenBenannterTypenUndGlobalerElementeOhneAufeinanderfolgendePunkte</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Namen benannter Datentypen (UML-Klasse mit dem Stereotyp xsdNamedType) und globaler Elemente (UML-Klasse mit dem Stereotyp xsdGlobalElement) sollen keine aufeinanderfolgenden Punkte enthalten. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M112"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M112"/>
   <xsl:template match="@*|node()" priority="-2" mode="M112">
      <xsl:apply-templates select="*" mode="M112"/>
   </xsl:template>
   <!--PATTERN NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenVonElementenUndAttributenOhneAufeinanderfolgendePunkteNDR-12: Erlaubte Zeichen für Klassifikationen in Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and contains(@name, '..')]"
                 priority="1000"
                 mode="M113">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NamenVonElementenUndAttributenOhneAufeinanderfolgendePunkte</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Namen von XML-Elementen (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attributen (UML-Eigenschaften mit dem Stereotyp xsdAttribute) sollen keine aufeinanderfolgenden Punkte enthalten. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M113"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M113"/>
   <xsl:template match="@*|node()" priority="-2" mode="M113">
      <xsl:apply-templates select="*" mode="M113"/>
   </xsl:template>
   <!--PATTERN NDR-12-ErlaubteZeichenFuerKlassifikationenInNamen-NamenVonCodelistenEnumerationenAlsBenannteTypenOhneAufeinanderfolgendePunkteNDR-12: Erlaubte Zeichen für Klassifikationen in Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xoevCodeliste(.) and xoev:xsdNamedType(.)) and contains(@name, '..')]"
                 priority="1000"
                 mode="M114">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NamenVonCodelistenEnumerationenAlsBenannteTypenOhneAufeinanderfolgendePunkte</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Namen von UML-Enumerationen, die Codelisten und benannte Typen darstellen (UML-Enumeration mit den Stereotypen xoevCodeliste und xsdNamedType) sollen keine aufeinanderfolgenden Punkte enthalten. Die Enumeration <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M114"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M114"/>
   <xsl:template match="@*|node()" priority="-2" mode="M114">
      <xsl:apply-templates select="*" mode="M114"/>
   </xsl:template>
   <!--PATTERN NDR-4-ErlaubteEinbindungsartenFuerCodelisten-CodeDatentypEntsprichtCodeTyp1bis4NDR-4: Erlaubte Einbindungsarten für Codelisten-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-4: Erlaubte Einbindungsarten für Codelisten</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdCode(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdCode(.)]"
                 priority="1000"
                 mode="M115">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="                     (ownedAttribute[@name = 'code' and xoev:xsdElement(.) and xoev:upperBound(.) = 1 and xoev:lowerBound(.) = 1] and                     ownedAttribute[@name = 'listURI' and xoev:xsdAttribute(.) and xoev:upperBound(.) = 1] and                     ownedAttribute[@name = 'listVersionID' and xoev:xsdAttribute(.) and xoev:upperBound(.) = 1]) and                                          (if (ownedAttribute[@name = 'code' and uml:resolve-type(.)[uml:is-Enumeration(.)]]) then                         ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and                         ownedAttribute[@name = 'listVersionID' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true']                     else                         (ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and                         ownedAttribute[@name = 'listVersionID' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true']) or                                                  (ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and                         ownedAttribute[@name = 'listVersionID' and xoev:lowerBound(.) = 1]) or                                                  (ownedAttribute[@name = 'listURI' and xoev:lowerBound(.) = 1] and                         ownedAttribute[@name = 'listVersionID' and xoev:lowerBound(.) = 1]))"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="(ownedAttribute[@name = 'code' and xoev:xsdElement(.) and xoev:upperBound(.) = 1 and xoev:lowerBound(.) = 1] and ownedAttribute[@name = 'listURI' and xoev:xsdAttribute(.) and xoev:upperBound(.) = 1] and ownedAttribute[@name = 'listVersionID' and xoev:xsdAttribute(.) and xoev:upperBound(.) = 1]) and (if (ownedAttribute[@name = 'code' and uml:resolve-type(.)[uml:is-Enumeration(.)]]) then ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and ownedAttribute[@name = 'listVersionID' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] else (ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and ownedAttribute[@name = 'listVersionID' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true']) or (ownedAttribute[@name = 'listURI' and (defaultValue/@value, defaultValue/body)[. != ''] and @isReadOnly = 'true'] and ownedAttribute[@name = 'listVersionID' and xoev:lowerBound(.) = 1]) or (ownedAttribute[@name = 'listURI' and xoev:lowerBound(.) = 1] and ownedAttribute[@name = 'listVersionID' and xoev:lowerBound(.) = 1]))">
               <xsl:attribute name="id">CodeDatentypEntsprichtCodeTyp1bis4</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Code-Datentypen (UML-Klassen mit dem Stereotyp xsdCode) sollen entsprechend den Code-Typen 1 bis 4 ausgestaltet sein. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Regel.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M115"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M115"/>
   <xsl:template match="@*|node()" priority="-2" mode="M115">
      <xsl:apply-templates select="*" mode="M115"/>
   </xsl:template>
   <!--PATTERN NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerBenannteTypenUndGlobaleElementeNDR-11: Erlaubte Zeichen für Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-11: Erlaubte Zeichen für Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and                 replace(@name, '[a-zA-Z0-9\.\-_]', '') != ''] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[(xoev:xsdNamedType(.) or xoev:xsdGlobalElement(.)) and                 replace(@name, '[a-zA-Z0-9\.\-_]', '') != '']"
                 priority="1000"
                 mode="M116">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NurErlaubteZeichenFuerBenannteTypenUndGlobaleElemente</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Benannte Typen (UML-Klassen mit dem Stereotyp xsdNamedType) und globale Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) sollen nur die Zeichen "a-z", "A-Z", "0-9", ".", "_" und "-" enthalten. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Regel.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M116"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M116"/>
   <xsl:template match="@*|node()" priority="-2" mode="M116">
      <xsl:apply-templates select="*" mode="M116"/>
   </xsl:template>
   <!--PATTERN NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerElementeUndAttributeNDR-11: Erlaubte Zeichen für Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-11: Erlaubte Zeichen für Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and                 replace(@name, '[a-zA-Z0-9\.\-_]', '') != '']"
                 priority="1000"
                 mode="M117">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NurErlaubteZeichenFuerElementeUndAttribute</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>XML-Elemente (UML-Eigenschaften mit dem Stereotyp xsdElement) und XML-Attribute (UML-Eigenschaften mit dem Stereotyp xsdAttribute) sollen nur die Zeichen "a-z", "A-Z", "0-9", ".", "_" und "-" enthalten. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Regel.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M117"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M117"/>
   <xsl:template match="@*|node()" priority="-2" mode="M117">
      <xsl:apply-templates select="*" mode="M117"/>
   </xsl:template>
   <!--PATTERN NDR-11-ErlaubteZeichenFuerNamen-NurErlaubteZeichenFuerNamenVonCodelistenEnumerationenAlsBenannteTypenNDR-12: Erlaubte Zeichen für Klassifikationen in Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-12: Erlaubte Zeichen für Klassifikationen in Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xoevCodeliste(.) and xoev:xsdNamedType(.) and                 replace(@name, '[a-zA-Z0-9\.\-_]', '') != '']"
                 priority="1000"
                 mode="M118">

		<!--ASSERT warning-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NurErlaubteZeichenFuerNamenVonCodelistenEnumerationenAlsBenannteTypen</xsl:attribute>
               <xsl:attribute name="role">warning</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Die Namen von UML-Enumerationen, die Codelisten und benannte Typen darstellen (UML-Enumeration mit den Stereotypen xoevCodeliste und xsdNamedType) sollen nur die Zeichen "a-z", "A-Z", "0-9", ".", "_" und "-" enthalten. Die Enumeration <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> verletzt diese Vorgabe.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M118"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M118"/>
   <xsl:template match="@*|node()" priority="-2" mode="M118">
      <xsl:apply-templates select="*" mode="M118"/>
   </xsl:template>
   <!--PATTERN NDR-5-DetaillierteStrukturEinesXOEVFachmodells-BasisdatentypenSchemaDefiniertNDR-5: Detaillierte Struktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(packagedElement[xoev:xsdSchema(.) and @name = 'Basisdatentypen'])]"
                 priority="1000"
                 mode="M119">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">BasisdatentypenSchemaDefiniert</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, auf der obersten Ebene des XÖV-Fachmodells ein Paket "Basisdatentypen" vorzusehen.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M119"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M119"/>
   <xsl:template match="@*|node()" priority="-2" mode="M119">
      <xsl:apply-templates select="*" mode="M119"/>
   </xsl:template>
   <!--PATTERN NDR-5-DetaillierteStrukturEinesXOEVFachmodells-BaukastenSchemaDefiniertNDR-5: Detaillierte Struktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and empty(packagedElement[xoev:xsdSchema(.) and @name = 'Baukasten'])]"
                 priority="1000"
                 mode="M120">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">BaukastenSchemaDefiniert</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, auf der obersten Ebene des XÖV-Fachmodells ein Paket "Baukasten" vorzusehen.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M120"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M120"/>
   <xsl:template match="@*|node()" priority="-2" mode="M120">
      <xsl:apply-templates select="*" mode="M120"/>
   </xsl:template>
   <!--PATTERN NDR-5-DetaillierteStrukturEinesXOEVFachmodells-NachrichtenOderFachmodulePaketDefiniertNDR-5: Detaillierte Struktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.) and                 empty(packagedElement[not(xoev:xsdSchema(.)) and (@name = 'Nachrichten' or @name = 'Fachmodule')])]"
                 priority="1000"
                 mode="M121">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NachrichtenOderFachmodulePaketDefiniert</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, auf der obersten Ebene des XÖV-Fachmodells ein Paket "Nachrichten" bzw. "Fachmodule" vorzusehen.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M121"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M121"/>
   <xsl:template match="@*|node()" priority="-2" mode="M121">
      <xsl:apply-templates select="*" mode="M121"/>
   </xsl:template>
   <!--PATTERN NDR-5-DetaillierteStrukturEinesXOEVFachmodells-MindestensEinHauptgruppenschemaNDR-5: Detaillierte Struktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/packagedElement                 [not(xoev:xsdSchema(.)) and (@name = 'Nachrichten' or @name = 'Fachmodule')]                 [empty(packagedElement[xoev:xsdSchema(.) and not(@name = 'Nachrichtentypen')])]"
                 priority="1000"
                 mode="M122">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">MindestensEinHauptgruppenschema</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, im Paket "Nachrichten" bzw. "Fachmodule" mindestens ein Nachrichtenhauptgruppen-Schema vorzusehen.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M122"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M122"/>
   <xsl:template match="@*|node()" priority="-2" mode="M122">
      <xsl:apply-templates select="*" mode="M122"/>
   </xsl:template>
   <!--PATTERN NDR-5-DetaillierteStrukturEinesXOEVFachmodells-NachrichtenNurInHauptgruppenpaketenNDR-5: Detaillierte Struktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and                 not(ancestor::packagedElement[xoev:xsdSchema(.)]/parent::packagedElement[@name = 'Nachrichten' or @name = 'Fachmodule']/parent::packagedElement/@xmi:id =                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/@xmi:id)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and                 not(ancestor::packagedElement[xoev:xsdSchema(.)]/parent::packagedElement[@name = 'Nachrichten' or @name = 'Fachmodule']/parent::packagedElement/@xmi:id =                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/@xmi:id)]"
                 priority="1000"
                 mode="M123">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NachrichtenNurInHauptgruppenpaketen</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) nur in den Hauptgruppenpaketen unterhalb des Pakets "Nachrichten" bzw. "Fachmodule" zu spezifizieren. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M123"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M123"/>
   <xsl:template match="@*|node()" priority="-2" mode="M123">
      <xsl:apply-templates select="*" mode="M123"/>
   </xsl:template>
   <!--PATTERN NDR-5-DetaillierteStrukturEinesXOEVFachmodells-HauptgruppenpaketeNichtOhneNachrichtenNDR-5: Detaillierte Struktur eines XÖV-Fachmodells-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-5: Detaillierte Struktur eines XÖV-Fachmodells</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]/packagedElement[not(xoev:xsdSchema(.)) and (@name = 'Nachrichten' or @name = 'Fachmodule')]/                 packagedElement[xoev:xsdSchema(.) and not(@name = 'Nachrichtentypen')]                 [empty((descendant::packagedElement | descendant::nestedClassifier)[xoev:xsdMessage(.)])]"
                 priority="1000"
                 mode="M124">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">HauptgruppenpaketeNichtOhneNachrichten</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, in einer Nachrichtenhauptgruppe mindestens eine Nachricht zu spezifieren (UML-Klasse mit dem Stereotyp xsdMessage). Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M124"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M124"/>
   <xsl:template match="@*|node()" priority="-2" mode="M124">
      <xsl:apply-templates select="*" mode="M124"/>
   </xsl:template>
   <!--PATTERN NDR-7-XMLWildcardElementeMitNamensraum-AnyElementeMitNamensraumNDR-7: XML-Wildcard-Elemente mit Namensraum-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-7: XML-Wildcard-Elemente mit Namensraum</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdAnyContents(.) and empty(xoev:xsdAnyContents(.)/@namespace[. != ''])] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdAnyContents(.) and empty(xoev:xsdAnyContents(.)/@namespace[. != ''])]"
                 priority="1000"
                 mode="M125">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">AnyElementeMitNamensraum</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, für Any-Elemente (UML-Klassen mit dem Stereotyp xsdAnyContents) einen Namensraum zu vergeben (Eigenschaft namespace des Stereotyps xsdAnyContents). Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M125"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M125"/>
   <xsl:template match="@*|node()" priority="-2" mode="M125">
      <xsl:apply-templates select="*" mode="M125"/>
   </xsl:template>
   <!--PATTERN NDR-15-GroßUndKleinschreibungVonNamen-UpperCamelCaseFuerNamenBenannterTypenNDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdNamedType(.) and                 substring(@name, 1, 1) != upper-case(substring(@name, 1, 1))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdNamedType(.) and                 substring(@name, 1, 1) != upper-case(substring(@name, 1, 1))]"
                 priority="1000"
                 mode="M126">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">UpperCamelCaseFuerNamenBenannterTypen</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Namen benannter Typen (UML-Klassen mit dem Stereotyp xsdNamedType) mit einem Großbuchstaben zu beginnen. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M126"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M126"/>
   <xsl:template match="@*|node()" priority="-2" mode="M126">
      <xsl:apply-templates select="*" mode="M126"/>
   </xsl:template>
   <!--PATTERN NDR-15-GroßUndKleinschreibungVonNamen-LowerCamelCaseFuerNamenVonElementenUndAttributenNDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[(xoev:xsdElement(.) or xoev:xsdAttribute(.)) and                 substring(@name, 1, 1) != lower-case(substring(@name, 1, 1))]"
                 priority="1000"
                 mode="M127">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">LowerCamelCaseFuerNamenVonElementenUndAttributen</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Namen von XML-Elementen (UML-Eigenschaft mit dem Stereotyp xsdElement) und XML-Attributen (UML-Eigenschaft mit dem Stereotyp xsdAttribute) mit einem Kleinbuchstaben zu beginnen. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M127"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M127"/>
   <xsl:template match="@*|node()" priority="-2" mode="M127">
      <xsl:apply-templates select="*" mode="M127"/>
   </xsl:template>
   <!--PATTERN NDR-15-GroßUndKleinschreibungVonNamen-LowerCamelCaseFuerNamenGlobalerElementeNDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-15: Groß- und Kleinschreibung von (und innerhalb zusammengesetzter) Namen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdGlobalElement(.) and                 substring(@name, 1, 1) != lower-case(substring(@name, 1, 1))] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdGlobalElement(.) and                 substring(@name, 1, 1) != lower-case(substring(@name, 1, 1))]"
                 priority="1000"
                 mode="M128">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">LowerCamelCaseFuerNamenGlobalerElemente</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Namen globaler Elemente (UML-Klassen mit dem Stereotyp xsdGlobalElement) mit einem Kleinbuchstaben zu beginnen. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M128"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M128"/>
   <xsl:template match="@*|node()" priority="-2" mode="M128">
      <xsl:apply-templates select="*" mode="M128"/>
   </xsl:template>
   <!--PATTERN NDR-16-NamensstrukturGlobalerElemente-NachrichtennamenMitPraefixNDR-16: Namensstruktur globaler Elementen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-16: Namensstruktur globaler Elementen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and count(tokenize(@name, '\.')) lt 2] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and count(tokenize(@name, '\.')) lt 2]"
                 priority="1000"
                 mode="M129">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NachrichtennamenMitPraefix</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Namen von Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) ein mit einem Punkt abgetrenntes Präfix voranzustelen. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M129"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M129"/>
   <xsl:template match="@*|node()" priority="-2" mode="M129">
      <xsl:apply-templates select="*" mode="M129"/>
   </xsl:template>
   <!--PATTERN NDR-16-NamensstrukturGlobalerElemente-NameNachrichtenpraefixEntsprichtNameSchemapaketNDR-16: Namensstruktur globaler Elementen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-16: Namensstruktur globaler Elementen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.)]"
                 priority="1000"
                 mode="M130">
      <xsl:variable name="msg-prefix" select="tokenize(@name, '\.')[1]"/>
      <xsl:variable name="msg-prefix-norm"
                    select="concat(lower-case(substring($msg-prefix, 1, 1)), substring($msg-prefix, 2, string-length($msg-prefix)))"/>
      <xsl:variable name="schema-name"
                    select="ancestor::packagedElement[xoev:xsdSchema(.)]/@name"/>
      <xsl:variable name="schema-name-norm"
                    select="concat(lower-case(substring($schema-name, 1, 1)), substring($schema-name, 2, string-length($schema-name)))"/>
      <!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="$msg-prefix-norm = $schema-name-norm"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl"
                                test="$msg-prefix-norm = $schema-name-norm">
               <xsl:attribute name="id">NameNachrichtenpraefixEntsprichtNameSchemapaket</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Namen von Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) mit einem Präfix zu versehen, das dem Namen des zugehörigen Hauptgruppenpakets (UML-Paket mit dem Stereotyp xsdSchema) entspricht. (Hinweis: Die Anfangsbuchstaben der UML-Klasse und des UML-Pakets dürfen sich in ihrer Groß- und Kleinschreibung unterscheiden, z. B. "hamsterzuchtregister.hamstergeburtsmeldung.0101" und "Hamsterzuchtregister"). Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M130"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M130"/>
   <xsl:template match="@*|node()" priority="-2" mode="M130">
      <xsl:apply-templates select="*" mode="M130"/>
   </xsl:template>
   <!--PATTERN NDR-17-VersionsuebergreifendEindeutigeNachrichtennummern-NachrichtennameMitNumerischemSuffixNDR-17: Versionsübergreifend eindeutige Nachrichtennummern-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-17: Versionsübergreifend eindeutige Nachrichtennummern</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and replace(tokenize(@name, '\.')[last()], '[0-9]', '') != ''] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and replace(tokenize(@name, '\.')[last()], '[0-9]', '') != '']"
                 priority="1000"
                 mode="M131">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NachrichtennameMitNumerischemSuffix</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, Namen von Nachrichten (UML-Klassen mit dem Stereotyp xsdMessage) mit einem Suffix zu versehen, das die Nachrichtennummer repräsentiert, also ausschließlich aus Ziffern besteht. Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M131"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M131"/>
   <xsl:template match="@*|node()" priority="-2" mode="M131">
      <xsl:apply-templates select="*" mode="M131"/>
   </xsl:template>
   <!--PATTERN NDR-17-VersionsuebergreifendEindeutigeNachrichtennummern-NachrichtennummerEindeutigNDR-17: Versionsübergreifend eindeutige Nachrichtennummern-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-17: Versionsübergreifend eindeutige Nachrichtennummern</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and                 (some $m in                 ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[@xmi:id != current()/@xmi:id and                 xoev:xsdMessage(.) and xoev:getNamespace(.) = current()/xoev:getNamespace(.)]                     satisfies tokenize($m/@name, '\.')[last()] = tokenize(@name, '\.')[last()])] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifier[xoev:xsdMessage(.) and                 (some $m in                 ancestor::packagedElement[xoev:xsdXModel(.)]//(packagedElement | nestedClassifier)[@xmi:id != current()/@xmi:id and                 xoev:xsdMessage(.) and xoev:getNamespace(.) = current()/xoev:getNamespace(.)]                     satisfies tokenize($m/@name, '\.')[last()] = tokenize(@name, '\.')[last()])]"
                 priority="1000"
                 mode="M132">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NachrichtennummerEindeutig</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, eindeutige Nachrichtennummern zu vergeben (Namenssuffix von UML-Klassen mit dem Stereotyp xsdMessage). Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M132"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M132"/>
   <xsl:template match="@*|node()" priority="-2" mode="M132">
      <xsl:apply-templates select="*" mode="M132"/>
   </xsl:template>
   <!--PATTERN NDR-18-NamenVonXMLSchemaDateien-NameSchemadateiEnthaeltNameModellpaketNDR-18: Namen von XML Schema-Dateien-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-18: Namen von XML Schema-Dateien</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and                 not(contains(lower-case(xoev:xsdSchema(.)/@schemaFile), lower-case(ancestor::packagedElement[xoev:xoevStandard(.)]/@name)))]"
                 priority="1000"
                 mode="M133">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">NameSchemadateiEnthaeltNameModellpaket</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, im Namen einer Schema-Datei (Eigenschaft schemaFile des Stereotyps xsdSchema) den Namen des Modellpakets (UML-Modell annotiert mit dem Stereotyp xsdXModel(.)) aufzuführen. Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M133"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M133"/>
   <xsl:template match="@*|node()" priority="-2" mode="M133">
      <xsl:apply-templates select="*" mode="M133"/>
   </xsl:template>
   <!--PATTERN NDR-18-NamenVonXMLSchemaDateien-SchemaLocationEnthaeltNameTechnischDesStandardsNDR-18: Namen von XML Schema-Dateien-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-18: Namen von XML Schema-Dateien</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdSchema(.) and                 not(contains(                 lower-case((xoev:xsdSchema(.)/@schemaLocation[. != ''],                 concat(ancestor::packagedElement/xoev:xsdXModel(.)/@schemaLocationBase, xoev:xsdSchema(.)/@schemaFile))[1]),                 lower-case(ancestor::packagedElement/xoev:xoevStandard(.)/@nameTechnisch)))]"
                 priority="1000"
                 mode="M134">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">SchemaLocationEnthaeltNameTechnischDesStandards</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, in der Schema Location (Eigenschaft schemaLocation des Stereotyps xsdSchema bzw. Eigenschaft schemaLocationBase des Stereotyps xsdXModel in Verbindung mit der Eigenschacht schemaFile des Stereotyps xsdSchema) eines Schema-Pakets (UML-Klasse mit dem Stereotyp xsdSchema) den technischen Namen des Standards aufzuführen (Eigenschaft nameTechnisch des Stereotyps xoevStandard). Das Paket <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M134"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M134"/>
   <xsl:template match="@*|node()" priority="-2" mode="M134">
      <xsl:apply-templates select="*" mode="M134"/>
   </xsl:template>
   <!--PATTERN NDR-20-DokumentationDerRechtsgrundlagen-RechtsgrundlageFuerNachrichtenDokumentiertNDR-20: Dokumentation der Rechtsgrundlagen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-20: Dokumentation der Rechtsgrundlagen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdMessage(.) and empty(xoev:xsdMessage(.)/rechtsgrundlagen)] |                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//nestedClassifer[xoev:xsdMessage(.) and empty(xoev:xsdMessage(.)/rechtsgrundlagen)]"
                 priority="1000"
                 mode="M135">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">RechtsgrundlageFuerNachrichtenDokumentiert</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, für Nachrichten die jeweiligen Rechtsgrundlagen zu dokumentieren (Eigenschaft rechtsgrundlagen des Stereotyps xsdMessage). Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M135"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M135"/>
   <xsl:template match="@*|node()" priority="-2" mode="M135">
      <xsl:apply-templates select="*" mode="M135"/>
   </xsl:template>
   <!--PATTERN NDR-21-CodenamenFuerCodesEinerCodeliste-BeschreibungEinesCodesSpezifiziertNDR-21: Codenamen für Codes einer Codeliste-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-21: Codenamen für Codes einer Codeliste</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedLiteral[xoev:xoevCodelisteneintrag(.) and                 empty(xoev:xoevCodelisteneintrag(.)/@wertErsteBeschreibungsspalte[. != ''])]"
                 priority="1000"
                 mode="M136">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">BeschreibungEinesCodesSpezifiziert</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, zu jedem Code einer Codeliste eine Beschreibung zu spezifizieren (Eigenschaft wertErsteBeschreibungsspalte des Stereotyps xoevCodelisteneintrag). Die Klasse <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M136"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M136"/>
   <xsl:template match="@*|node()" priority="-2" mode="M136">
      <xsl:apply-templates select="*" mode="M136"/>
   </xsl:template>
   <!--PATTERN NDR-27-VerwendungDesUrspruenglichenNamensraumpraefixesBeiXMLSchemaImporten-ImportPraefixAusImportiertemSchemaUebernommenNDR-27: Verwendung des ursprünglichen Namensraumpräfixes bei XML Schema-Importen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-27: Verwendung des ursprünglichen Namensraumpräfixes bei XML Schema-Importen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//packagedElement[xoev:xsdImport(.) and xoev:xsdImport(.)/@prefix]"
                 priority="1000"
                 mode="M137">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ImportPraefixAusImportiertemSchemaUebernommen</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, bei einem XML-Import (UML-Abhängigkeit mit dem Stereotyp xsdImport) das Namensraumpräfix des importierten Schemas zu nutzen und das Präfix in der Import-Beziehung (Eigenschaft prefix des Stereotyps xsdImport) nicht zu spezifizieren. <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M137"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M137"/>
   <xsl:template match="@*|node()" priority="-2" mode="M137">
      <xsl:apply-templates select="*" mode="M137"/>
   </xsl:template>
   <!--PATTERN NDR-6-NutzungVonXMLAttributenUndXMLElementen-ElementreferenzenUnbenanntNDR-6: Nutzung von XML-Attributen und XML-Elementen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-6: Nutzung von XML-Attributen und XML-Elementen</svrl:text>
   <!--RULE -->
   <xsl:template match="/xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.)/@isRef = 'true' and @name[. != '']]"
                 priority="1000"
                 mode="M138">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">ElementreferenzenUnbenannt</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, bei der Referenzierung eines globalen Elements (Eigenschaft isRef des Stereotyps xsdElement) der UML-Eigenschaft keinen Namen zu geben, da dieser irrelevant für die XML Schema-Definition ist. Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M138"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M138"/>
   <xsl:template match="@*|node()" priority="-2" mode="M138">
      <xsl:apply-templates select="*" mode="M138"/>
   </xsl:template>
   <!--PATTERN NDR-6-NutzungVonXMLAttributenUndXMLElementen-KlasseineigenschaftenMitGlobalenElementenAlsTypSindReferenzenNDR-6: Nutzung von XML-Attributen und XML-Elementen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-6: Nutzung von XML-Attributen und XML-Elementen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and uml:resolve-type(.)/xoev:xsdGlobalElement(.) and                 not(xoev:xsdElement(.)/@isRef = 'true')]"
                 priority="1000"
                 mode="M139">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">KlasseineigenschaftenMitGlobalenElementenAlsTypSindReferenzen</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, bei der Nutzung eines globalen Elements (UML-Klasse mit dem Stereotyps xsdGlobalElement) in einer UML-Eigenschaft, auf dieses zu referenzieren (Eigenschaft isRef des Stereotyps xsdElement). Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M139"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M139"/>
   <xsl:template match="@*|node()" priority="-2" mode="M139">
      <xsl:apply-templates select="*" mode="M139"/>
   </xsl:template>
   <!--PATTERN NDR-6-NutzungVonXMLAttributenUndXMLElementen-KlasseineigenschaftenMitGruppenAlsTypSindReferenzenNDR-6: Nutzung von XML-Attributen und XML-Elementen-->
   <svrl:text xmlns:svrl="http://purl.oclc.org/dsdl/svrl">NDR-6: Nutzung von XML-Attributen und XML-Elementen</svrl:text>
   <!--RULE -->
   <xsl:template match="                 /xmi:XMI/uml:Model/packagedElement[xoev:xsdXModel(.)]//ownedAttribute[xoev:xsdElement(.) and uml:resolve-type(.)/xoev:xsdGroup(.) and                 not(xoev:xsdElement(.)/@isRef = 'true')]"
                 priority="1000"
                 mode="M140">

		<!--ASSERT information-->
      <xsl:choose>
         <xsl:when test="false()"/>
         <xsl:otherwise>
            <svrl:failed-assert xmlns:svrl="http://purl.oclc.org/dsdl/svrl" test="false()">
               <xsl:attribute name="id">KlasseineigenschaftenMitGruppenAlsTypSindReferenzen</xsl:attribute>
               <xsl:attribute name="role">information</xsl:attribute>
               <xsl:attribute name="location">
                  <xsl:apply-templates select="." mode="schematron-select-full-path"/>
               </xsl:attribute>
               <svrl:text>Es wird empfohlen, bei der Nutzung einer Gruppe (UML-Klasse mit dem Stereotyp xsdGroup) in einer UML-Eigenschaft, auf die Gruppe zu referenzieren (Eigenschaft isRef des Stereotyps xsdElement). Die Eigenschaft <xsl:text/>
                  <xsl:value-of select="xgen:model-path(.)"/>
                  <xsl:text/> entspricht der Empfehlung nicht.</svrl:text>
            </svrl:failed-assert>
         </xsl:otherwise>
      </xsl:choose>
      <xsl:apply-templates select="*" mode="M140"/>
   </xsl:template>
   <xsl:template match="text()" priority="-1" mode="M140"/>
   <xsl:template match="@*|node()" priority="-2" mode="M140">
      <xsl:apply-templates select="*" mode="M140"/>
   </xsl:template>
</xsl:stylesheet>
